C kap command line: /usr/csrd/kap -c=1 XX.f
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
 
 
 
C
      SUBROUTINE CFILL(A,B)
      REAL A(*),B(*)
      INTEGER I1, I2, I3
C
D        call trace_enter (2001) 
      CDOALL 1 I1=0,0,32
      INTEGER I4, I5
      I5 = I1 + 1
      I4 = MIN0 (I1 + 1 + 32 - 1, 12) - I1
        A(I5:$I4) = B(I5:$I4)
    1   CONTINUE
D        call trace_exit (2002) 
      A(13) =  A(3)*A(11)-A(4)*A(12)-A(5)*A(9) +A(6)*A(10)
      A(14) = -A(4)*A(11)-A(3)*A(12)+A(6)*A(9) +A(5)*A(10)
      A(15) =  A(5)*A(7) -A(6)*A(8) -A(1)*A(11)+A(2)*A(12)
      A(16) = -A(6)*A(7) -A(5)*A(8) +A(2)*A(11)+A(1)*A(12)
      A(17) =  A(1)*A(9) -A(2)*A(10)-A(3)*A(7) +A(4)*A(8)
      A(18) = -A(2)*A(9) -A(1)*A(10)+A(4)*A(7) +A(3)*A(8)
C
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
C     HEAT BATH - USES CABIBBO-MARINARI ALGORITHM INSTEAD OF
C                 METROPOLIS
C                 3 SUBGROUP VERSION
C
C     CONVERTED FROM C TO FORTRAN BY KEN BARISH, CLIVE BAILLIE
C     AND DAVID WALKER, SUMMER 1987
C
      SUBROUTINE CHOOS(SST,PU)
      REAL SST(*)
      REAL PU(*)
C
      PARAMETER ( L1=12, L2=12, L3=12, L4=12 )
      PARAMETER ( MLEG=18*L1*L2*L3 )
      INTEGER DIMS
      PARAMETER (DIMS=4)
      INTEGER LATT(DIMS),LATT1(DIMS),MOV(DIMS),ROT(DIMS),WHICH(13,13)
      REAL WLOOP(13,13),RES(13,13,6),BETA,LEGS(MLEG)
      COMMON /COMSYS/ BETA,WLOOP,RES,LEGS,LATT,LATT1,MOV,ROT,WHICH
C
      REAL R0,R1,R2,R3,R,A0,A1,A2,A3,XX,EFAC,RFAC,NORM
      REAL PART(18),PLAQ(18),MAT(18),DIS,B0,B1,B2,B3,TEMP(18)
      INTEGER I,J
      INTEGER I1, I2, I3
C
D        call trace_enter (2003) 
      CDOALL 1 I1=0,0,32
      INTEGER I4, I5
      I5 = I1 + 1
      I4 = MIN0 (I1 + 1 + 32 - 1, 18) - I1
        PART(I5:$I4) = 0.0
        MAT(I5:$I4) = PU(I5:$I4)
    1   CONTINUE
C
D        call trace_exit (2004) 
D        call trace_enter (2005) 
        CDOALL 2 I=1,18
          PART(I) = PART(I) + SUM (SST(I:$6:18))
    2     CONTINUE
C
D        call trace_exit (2006) 
D        call trace_enter (2007) 
      DO 3 I=1,3
        CALL MULT(MAT,PART,PLAQ)
        IF(I.EQ.1) THEN
          R0 = 0.5*(PLAQ(1)+PLAQ(9))
          R1 = 0.5*(PLAQ(2)-PLAQ(10))
          R2 = 0.5*(PLAQ(3)-PLAQ(7))
          R3 = 0.5*(PLAQ(4)+PLAQ(8))
        ELSEIF(I.EQ.2) THEN
          R0 = 0.5*(PLAQ(9)+PLAQ(17))
          R1 = 0.5*(PLAQ(10)-PLAQ(18))
          R2 = 0.5*(PLAQ(11)-PLAQ(15))
          R3 = 0.5*(PLAQ(12)+PLAQ(16))
        ELSE
          R0 = 0.5*(PLAQ(1)+PLAQ(17))
          R1 = 0.5*(PLAQ(2)-PLAQ(18))
          R2 = 0.5*(PLAQ(5)-PLAQ(13))
          R3 = 0.5*(PLAQ(6)+PLAQ(14))
        ENDIF
        R    = R0*R0+R1*R1+R2*R2+R3*R3
        R    = SQRT(R)
        R0   = R0/R
        R1   = R1/R
        R2   = R2/R
        R3   = R3/R
        XX   = BETA*R*2.0/3.0
        EFAC = EXP(-2.0*XX)
        RFAC = 1.0-EFAC
C
    4   A0   = 1.0+LOG(EFAC+RFAC*PRANF(0))/XX
        XTEMP= PRANF(0)
        IF((XTEMP*XTEMP).GT.(1.0-A0*A0)) GOTO 4
        NORM = SQRT(1.0-A0*A0)
C
    5   A1   = 2.0*PRANF(0)-1.0
        A2   = 2.0*PRANF(0)-1.0
        A3   = 2.0*PRANF(0)-1.0
        DIS  = A1*A1+A2*A2+A3*A3
        IF(DIS.GT.1.0) GOTO 5
C
        NORM = NORM/SQRT(DIS)
        A1   = A1*NORM
        A2   = A2*NORM
        A3   = A3*NORM
        B0   = A0*R0+A1*R1+A2*R2+A3*R3
        B1   =  -A0*R1+A1*R0+A2*R3-A3*R2
        B2   = A2*R0+A3*R1-A0*R2-A1*R3
        B3   =  -A2*R1+A3*R0-A0*R3+A1*R2
        IF(I.EQ.1) THEN
          TEMP(1)  = B0*MAT(1)-B1*MAT(2)-B2*MAT(3)-B3*MAT(4)
          TEMP(2)  = B1*MAT(1)+B0*MAT(2)+B3*MAT(3)-B2*MAT(4)
          TEMP(3)  = B2*MAT(1)-B3*MAT(2)+B0*MAT(3)+B1*MAT(4)
          TEMP(4)  = B3*MAT(1)+B2*MAT(2)-B1*MAT(3)+B0*MAT(4)
          TEMP(7)  = B0*MAT(7)-B1*MAT(8)-B2*MAT(9)-B3*MAT(10)
          TEMP(8)  = B1*MAT(7)+B0*MAT(8)+B3*MAT(9)-B2*MAT(10)
          TEMP(9)  = B2*MAT(7)-B3*MAT(8)+B0*MAT(9)+B1*MAT(10)
          TEMP(10) = B3*MAT(7)+B2*MAT(8)-B1*MAT(9)+B0*MAT(10)
          TEMP(13) = B0*MAT(13)-B1*MAT(14)-B2*MAT(15)-B3*MAT(16)
          TEMP(14) = B1*MAT(13)+B0*MAT(14)+B3*MAT(15)-B2*MAT(16)
          TEMP(15) = B2*MAT(13)-B3*MAT(14)+B0*MAT(15)+B1*MAT(16)
          TEMP(16) = B3*MAT(13)+B2*MAT(14)-B1*MAT(15)+B0*MAT(16)
          MAT(1)   = TEMP(1)
          MAT(2)   = TEMP(2)
          MAT(3)   = TEMP(3)
          MAT(4)   = TEMP(4)
          MAT(7)   = TEMP(7)
          MAT(8)   = TEMP(8)
          MAT(9)   = TEMP(9)
          MAT(10)  = TEMP(10)
          MAT(13)  = TEMP(13)
          MAT(14)  = TEMP(14)
          MAT(15)  = TEMP(15)
          MAT(16)  = TEMP(16)
        ELSEIF(I.EQ.2) THEN
          TEMP(3)  = B0*MAT(3)-B1*MAT(4)-B2*MAT(5)-B3*MAT(6)
          TEMP(4)  = B1*MAT(3)+B0*MAT(4)+B3*MAT(5)-B2*MAT(6)
          TEMP(5)  = B2*MAT(3)-B3*MAT(4)+B0*MAT(5)+B1*MAT(6)
          TEMP(6)  = B3*MAT(3)+B2*MAT(4)-B1*MAT(5)+B0*MAT(6)
          TEMP(9)  = B0*MAT(9)-B1*MAT(10)-B2*MAT(11)-B3*MAT(12)
          TEMP(10) = B1*MAT(9)+B0*MAT(10)+B3*MAT(11)-B2*MAT(12)
          TEMP(11) = B2*MAT(9)-B3*MAT(10)+B0*MAT(11)+B1*MAT(12)
          TEMP(12) = B3*MAT(9)+B2*MAT(10)-B1*MAT(11)+B0*MAT(12)
          TEMP(15) = B0*MAT(15)-B1*MAT(16)-B2*MAT(17)-B3*MAT(18)
          TEMP(16) = B1*MAT(15)+B0*MAT(16)+B3*MAT(17)-B2*MAT(18)
          TEMP(17) = B2*MAT(15)-B3*MAT(16)+B0*MAT(17)+B1*MAT(18)
          TEMP(18) = B3*MAT(15)+B2*MAT(16)-B1*MAT(17)+B0*MAT(18)
          MAT(3)   = TEMP(3)
          MAT(4)   = TEMP(4)
          MAT(5)   = TEMP(5)
          MAT(6)   = TEMP(6)
          MAT(9)   = TEMP(9)
          MAT(10)  = TEMP(10)
          MAT(11)  = TEMP(11)
          MAT(12)  = TEMP(12)
          MAT(15)  = TEMP(15)
          MAT(16)  = TEMP(16)
          MAT(17)  = TEMP(17)
          MAT(18)  = TEMP(18)
        ELSE
          TEMP(1)  = B0*MAT(1)-B1*MAT(2)-B2*MAT(5)-B3*MAT(6)
          TEMP(2)  = B1*MAT(1)+B0*MAT(2)+B3*MAT(5)-B2*MAT(6)
          TEMP(5)  = B2*MAT(1)-B3*MAT(2)+B0*MAT(5)+B1*MAT(6)
          TEMP(6)  = B3*MAT(1)+B2*MAT(2)-B1*MAT(5)+B0*MAT(6)
          TEMP(7)  = B0*MAT(7)-B1*MAT(8)-B2*MAT(11)-B3*MAT(12)
          TEMP(8)  = B1*MAT(7)+B0*MAT(8)+B3*MAT(11)-B2*MAT(12)
          TEMP(11) = B2*MAT(7)-B3*MAT(8)+B0*MAT(11)+B1*MAT(12)
          TEMP(12) = B3*MAT(7)+B2*MAT(8)-B1*MAT(11)+B0*MAT(12)
          MAT(1)   = TEMP(1)
          MAT(2)   = TEMP(2)
          MAT(5)   = TEMP(5)
          MAT(6)   = TEMP(6)
          MAT(7)   = TEMP(7)
          MAT(8)   = TEMP(8)
          MAT(11)  = TEMP(11)
          MAT(12)  = TEMP(12)
        ENDIF
    3   CONTINUE
C
D        call trace_exit (2008) 
      CALL CFILL(PU,MAT)
C
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
      SUBROUTINE CPYMAT(OUTMAT,INMAT,N)
      REAL INMAT(*), OUTMAT(*)
      INTEGER N
      INTEGER I1, I2, I3, I4, I5
C
D        call trace_enter (2009) 
      I2 = (N + 31) / 32
      CDOALL 1 I1=0,32*I2-32,32
      INTEGER I6, I7
      I7 = I1 + 1
      I6 = MIN0 (I1 + 1 + 32 - 1, N) - I1
    1   OUTMAT(I7:$I6) = INMAT(I7:$I6)
C
D        call trace_exit (2010) 
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
      SUBROUTINE DMPSED()
C
      OPEN(UNIT=1,FILE='SEED',ACCESS='SEQUENTIAL',STATUS='UNKNOWN')
      REWIND(1)
      INO = IGETSD(0)
      WRITE (1,10) INO
   10 FORMAT(I12)
      WRITE(6,*) 'O.K. ...... DONE IT !'
      CLOSE(1)
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
C
CCCCCCCCCCCCCCCCCCCCCCCCC END OF ROUTINE DMPSED CCCCCCCCCCCCCCCCCCCC
C
 
 
 
 
       SUBROUTINE GETPOS(LATT,COORD,INDEX)
       INTEGER COORD(4), LATT(4), INDEX
C
       J = INDEX
D        call trace_enter (2011) 
       DO 1 I=1,4
          COORD(I) = MOD (J, LATT(I))
    1     J = J / LATT(I)
C
D        call trace_exit (2012) 
       RETURN
       END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
      SUBROUTINE HIT(COORD,ORIGIN,DIR)
      INTEGER COORD(4),DIR,ORIGIN
C
      INTEGER DIMS
      PARAMETER (DIMS=4)
      PARAMETER ( L1=12, L2=12, L3=12, L4=12 )
      PARAMETER ( MBAR=18*L1*L2*L3 )
      INTEGER UMAX
      PARAMETER ( UMAX=72*L1*L2*L3*L4 )
      INTEGER LATT(DIMS),LATT1(DIMS),MOV(DIMS),ROT(DIMS),WHICH(13,13)
      REAL WLOOP(13,13),RES(13,13,6),BETA,LEGS(MBAR)
      COMMON /COMSYS/ BETA,WLOOP,RES,LEGS,LATT,LATT1,MOV,ROT,WHICH
C
      REAL U1(UMAX)
      COMMON /COMU1/ U1
C
      INTEGER OTHEND,SITE,CNT
      INTEGER PU
      REAL ST(18,6)
      INTEGER PTEMP(24)
C
      INTEGER PSTR(24,4)
      SAVE PSTR
C
      DATA PSTR/ 2,5,6,14,6,5,2,14,3,5,7,14,7,5,3,14,4,5,8,14,8,5,4,14,
     .           1,6,5,14,5,6,1,14,3,6,7,14,7,6,3,14,4,6,8,14,8,6,4,14,
     .           1,7,5,14,5,7,1,14,2,7,6,14,6,7,2,14,4,7,8,14,8,7,4,14,
     .           1,8,5,14,5,8,1,14,2,8,6,14,6,8,2,14,3,8,7,14,7,8,3,14 /
C
C      CALL CPYMAT(PTEMP,PSTR(1,DIR+1),24) LPOINTER 4-3-89
      CALL ICPYMT(PTEMP,PSTR(1,DIR+1),24)
C
      IF(COORD(DIR+1).EQ.LATT1(DIR+1)) THEN
        OTHEND = 0
      ELSE
        OTHEND = COORD(DIR+1)+1
      ENDIF
C
      COORD(DIR+1) = OTHEND
      SITE = COORD(1)*MOV(1)+COORD(2)*MOV(2)+COORD(3)*MOV(3)+
     .           COORD(4)*MOV(4)
      CNT = 1
D        call trace_enter (2013) 
      DO 1 J=1,6
        COORD(DIR+1) = OTHEND
        CALL SYSLOP(COORD,SITE,PTEMP(CNT),ST(1,J),NCHAR)
        CNT = NCHAR+CNT
    1 CONTINUE
C
D        call trace_exit (2014) 
      PU = ORIGIN+ROT(DIR+1)
      CALL CHOOS(ST(1,1),U1(PU+1))
C
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
      SUBROUTINE ICPYMT(OUTMAT,INMAT,N)
      INTEGER INMAT(*), OUTMAT(*), N
      INTEGER I1, I2, I3, I4, I5
 
C     ADDED BY LPOINTER 4-3-89
 
D        call trace_enter (2015) 
      I2 = (N + 31) / 32
      CDOALL 1 I1=0,32*I2-32,32
      INTEGER I6, I7
      I7 = I1 + 1
      I6 = MIN0 (I1 + 1 + 32 - 1, N) - I1
    1    OUTMAT(I7:$I6) = INMAT(I7:$I6)
 
D        call trace_exit (2016) 
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
C
CCCCCCCCCCCCCCCCCCCCCCCCCCC END OF ROUTINE LMULT CCCCCCCCCCCCCCCCCCCCCCC
C
        FUNCTION IGETSD(IDUMMY)
C
        COMMON /RAN/IRAND0,IRAND1,IAB0,IAB1,ICB0,ICB1
        SAVE /RAN/
C
        IGETSD = IRAND0 + IRAND1*2**16
C
        RETURN
        END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
 
 
      SUBROUTINE INIT(FLAG)
C
      INTEGER NUMSTG
      COMMON /COMFIL/ NUMSTG
C
      INTEGER DIMS
      PARAMETER (DIMS=4)
      INTEGER UMAX
      PARAMETER ( L1=12, L2=12, L3=12, L4=12 )
      PARAMETER ( MLEG=18*L1*L2*L3, UMAX=72*L1*L2*L3*L4 )
      INTEGER LATT(DIMS),LATT1(DIMS),MOV(DIMS),ROT(DIMS),WHICH(13,13)
      REAL WLOOP(13,13),RES(13,13,6),BETA,LEGS(MLEG)
      COMMON /COMSYS/ BETA,WLOOP,RES,LEGS,LATT,LATT1,MOV,ROT,WHICH
C
      REAL U1(UMAX)
      COMMON /COMU1/ U1
C
      REAL FACFI,FACIF
      COMMON /COMFAC/ FACFI,FACIF
C
      INTEGER FLAG,BIGNUM,MOVX,BUFF,REM,BUFNUM
      INTEGER PU
      CHARACTER*5 BNAME
C
      MOVX = 72
      BUFF = 256
      BIGNUM = 4*LATT(1)*LATT(2)*LATT(3)*LATT(4)
C
      IF (FLAG.EQ.1) THEN
        WRITE(6,*) 'BACKUP FILE NAME ? : '
        READ(5,100) BNAME
        OPEN(UNIT=1,FILE = BNAME,ACCESS = 'SEQUENTIAL',STATUS='UNKNOWN',
     .       FORM='UNFORMATTED')
        REWIND(1)
        BIGNUM = MOVX*NUMSTG
        BUFNUM = BIGNUM/BUFF
        REM = MOD(BIGNUM, BUFF)
        WRITE(6,*) 'BACKUP FILE NAME = ',BNAME,'BUFNUM = ',BUFNUM,
     .  'REM = ',REM
        PU=1
D        call trace_enter (2017) 
        DO 1 I=0,BUFNUM-1
          READ (1) (U1(J),J=PU,PU+BUFF)
          PU = PU + BUFF
          WRITE(6,*) 'B'
    1     CONTINUE
D        call trace_exit (2018) 
        WRITE(6,*) 'E'
        CLOSE(1)
      ELSE
        PU=1
D        call trace_enter (2019) 
        DO 2 I=0,BIGNUM-1
          U1(PU) = 1.0
          U1(PU+1) = 0.0
          U1(PU+2) = 0.0
          U1(PU+3) = 0.0
          U1(PU+4) = 0.0
          U1(PU+5) = 0.0
          U1(PU+6) = 0.0
          U1(PU+7) = 0.0
          U1(PU+8) = 1.0
          U1(PU+9) = 0.0
          U1(PU+10) = 0.0
          U1(PU+11) = 0.0
          U1(PU+12) = 0.0
          U1(PU+13) = 0.0
          U1(PU+14) = 0.0
          U1(PU+15) = 0.0
          U1(PU+16) = 1.0
          U1(PU+17) = 0.0
          PU = PU + ROT(2)
    2     CONTINUE
D        call trace_exit (2020) 
      ENDIF
C
      RETURN
  100 FORMAT(A)
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
C
CCCCCCCCCCCCCCCCCCCCC END OF ROUTINE PRANF CCCCCCCCCCCCCCCCCCCCCCC C
C
        SUBROUTINE LADD(I0,I1,J0,J1,K0,K1)
C
        PARAMETER (IPOW16=2**16,IPOW15=2**15)
C
        I0=MOD(K0+J0,IPOW16)
        I1=MOD((K0+J0)/IPOW16+K1+J1,IPOW15)
C
        RETURN
        END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
C
C     THE ROUTINES USED TO INITIALIZE AND DUMP THE LATTICE.
C
C     CONVERTED FORM C TO FORTRAN BY KEN BARISH, CLIVE BAILLIE,
C     AND DAVID WALKER, SUMMER 1987
C
      SUBROUTINE LATTOT()
C
      INTEGER UMAX
      PARAMETER ( L1=12, L2=12, L3=12, L4=12 )
      PARAMETER ( UMAX=72*L1*L2*L3*L4 )
      REAL U1(UMAX)
      COMMON /COMU1/ U1
C
      INTEGER NUMSTG
      COMMON /COMFIL/ NUMSTG
C
      INTEGER BIGNUM
      INTEGER BUFNUM,REM
      INTEGER PU
      INTEGER BUFF,MOVX
      CHARACTER*5 BNAME
C
      WRITE(6,*) 'ENTER 5-LETTER BACKUP FILE NAME ? : '
      READ(5,100) BNAME
      WRITE(6,*) BNAME
      OPEN(UNIT=1,FILE = BNAME,ACCESS = 'SEQUENTIAL',STATUS='UNKNOWN')
C     OPEN(UNIT=1,FILE = BNAME,ACCESS = 'SEQUENTIAL',STATUS='UNKNOWN',
C    .FORM='UNFORMATTED')
      REWIND(1)
      MOVX = 72
      BUFF = 256
      BIGNUM = MOVX*NUMSTG
      BUFNUM = BIGNUM/BUFF
      REM = MOD(BIGNUM, BUFF)
      WRITE(6,*) 'BACKUP FILE NAME = ',BNAME,'BUFNUM = ',BUFNUM,'REM = '
      PU = 1
D        call trace_enter (2021) 
      DO 2 I=0,BUFNUM-1
C       WRITE (1) (U1(J),J=PU,PU+BUFF)
        WRITE (1,101) (U1(J),J=PU,PU+BUFF)
  101   FORMAT(9F8.3)
        PU = PU + BUFF
        WRITE(6,*) 'B'
    2   CONTINUE
D        call trace_exit (2022) 
      WRITE(6,*) 'E'
      CLOSE(1)
      RETURN
  100 FORMAT(A)
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
C
C     THIS ROUTINE MAKES BARRED LEGS ONLY IN THE ARRAY LEGS
C
C     CONVERTED FROM C TO FORTRAN BY KEN BARISH, CLIVE BAILLIE,
C     AND DAVID WALKER, 1987
C
      SUBROUTINE LEGMAK(T,TT)
      INTEGER TT,T
C
      INTEGER DIMS
      PARAMETER (DIMS=4)
      PARAMETER ( L1=12, L2=12, L3=12, L4=12 )
      PARAMETER ( MLEG=18*L1*L2*L3 )
      INTEGER LATT(DIMS),LATT1(DIMS),MOV(DIMS),ROT(DIMS),WHICH(13,13)
      REAL WLOOP(13,13),RES(13,13,6),BETA,LEGS(MLEG)
      COMMON /COMSYS/ BETA,WLOOP,RES,LEGS,LATT,LATT1,MOV,ROT,WHICH
C
      INTEGER STRB(26)
C
      INTEGER SITE,COORD(4),PLEGS
      INTEGER I1, I2, I3, I4, I5, I6, I9
C
D        call trace_enter (2023) 
      I3 = (T + 31) / 32
      CDOALL 1 I1=0,32*I3-32,32
      INTEGER I7, I8
      I8 = I1 + 1
      I7 = MIN0 (I1 + 1 + 32 - 1, T) - I1
    1   STRB(I8:$I7) = 18
C
D        call trace_exit (2024) 
D        call trace_enter (2025) 
      I9 = (2 * T - T + 32) / 32
      CDOALL 2 I2=0,32*I9-32,32
      INTEGER I10, I11
      I11 = T + I2 + 1
      I10 = MIN0 (T + I2 + 1 + 32 - 1, 2 * T + 1) - (T + I2)
    2   STRB(I11:$I10) = 30
C
D        call trace_exit (2026) 
      STRB(2*T+1) = 14
C
      COORD(4) = TT
      SITE  = TT*MOV(4)
      PLEGS = 1
D        call trace_enter (2027) 
      DO 3 I=0,LATT(3)-1
        COORD(3) = I
        DO 3 J=0,LATT(2)-1
          COORD(2) = J
          DO 3 K=0,LATT(1)-1
            COORD(1) = K
            CALL SYSLOP(COORD,SITE,STRB,LEGS(PLEGS),NCHAR)
            PLEGS = PLEGS+18
            SITE  = SITE+MOV(1)
    3       CONTINUE
C
D        call trace_exit (2028) 
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
C     LINKBR MULTI-HITS AND AVERAGES U MATRICES IN ANY DIRECTION
C     AND PUTS THE RESULTS IN THE ARRAY POINTED TO BY "WHERE".
C
C     CONVERTED FROM C TO FORTRAN BY KEN BARISH, CLIVE BAILLIE,
C     AND DAVID WALKER, 1987
C
      SUBROUTINE LINKBR(N,DIR,WHERE)
      REAL WHERE(*)
      INTEGER N,DIR
C
      INTEGER DIMS
      PARAMETER (DIMS=4)
      PARAMETER ( L1=12, L2=12, L3=12, L4=12 )
      PARAMETER ( MLEG=18*L1*L2*L3 )
      INTEGER UMAX
      PARAMETER ( UMAX=72*L1*L2*L3*L4 )
      INTEGER LATT(DIMS),LATT1(DIMS),MOV(DIMS),ROT(DIMS),WHICH(13,13)
      REAL WLOOP(13,13),RES(13,13,6),BETA,LEGS(MLEG)
      COMMON /COMSYS/ BETA,WLOOP,RES,LEGS,LATT,LATT1,MOV,ROT,WHICH
C
      REAL U1(UMAX)
      COMMON /COMU1/ U1
C
      INTEGER COORD(4),OTHEND,SITE,ENDSIT,PT,CNT
      INTEGER PU
      INTEGER PSTR(24)
      REAL AVMAT(18),MAT2(18),ST(18,6)
C
      INTEGER ENV(24,4)
      SAVE ENV
      INTEGER J1, I1, I2, K1, J2, J3, I3, I4, K2, K3
C
      DATA ENV/ 2,5,6,14,6,5,2,14,3,5,7,14,7,5,3,14,4,5,8,14,8,5,4,14,
     .          1,6,5,14,5,6,1,14,3,6,7,14,7,6,3,14,4,6,8,14,8,6,4,14,
     .          1,7,5,14,5,7,1,14,2,7,6,14,6,7,2,14,4,7,8,14,8,7,4,14,
     .          1,8,5,14,5,8,1,14,2,8,6,14,6,8,2,14,3,8,7,14,7,8,3,14 /
C
      PT = 1
D        call trace_enter (2029) 
      DO 1 ICORD4=0,LATT(4)-1
        COORD(4) = ICORD4
        DO 1 ICORD3=0,LATT(3)-1
          COORD(3) = ICORD3
          DO 1 ICORD2=0,LATT(2)-1
            COORD(2) = ICORD2
            DO 1 ICORD1=0,LATT(1)-1
              COORD(1) = ICORD1
              CNT = 1
              SITE = ICORD1*MOV(1)+ICORD2*MOV(2)+ICORD3*MOV(3)
     .                                            +ICORD4*MOV(4)
              PU = SITE+ROT(DIR+1)
              CALL CPYMAT(AVMAT,U1(PU+1),18)
              IF(N.GT.1) THEN
                CDOALL 2 J1=0,0,32
                INTEGER J4, J5
                J5 = J1 + 1
                J4 = MIN0 (J1 + 1 + 32 - 1, 18) - J1
    2             MAT2(J5:$J4) = U1(PU+J5:$J4)
                IF(COORD(DIR+1).EQ.LATT1(DIR+1)) THEN
                  OTHEND = 0
                  ENDSIT = SITE - LATT1(DIR+1)*MOV(DIR+1)
                ELSE
                  OTHEND = COORD(DIR+1) +1
                  ENDSIT = SITE + MOV(DIR+1)
                ENDIF
C                CALL CPYMAT(PSTR,ENV(1,DIR+1),24) LPOINTER 4-3-89
                CALL ICPYMT(PSTR,ENV(1,DIR+1),24)
C
                DO 3 J=1,6
                  COORD(DIR+1) = OTHEND
                  CALL SYSLOP(COORD,ENDSIT,PSTR(CNT),ST(1,J),NCHAR)
    3             CNT = CNT+NCHAR
                DO 4 J=1,N-1
                  CALL CHOOS(ST(1,1),MAT2)
                  CDOALL 5 I1=0,0,32
                  INTEGER I5, I6
                  I6 = I1 + 1
                  I5 = MIN0 (I1 + 1 + 32 - 1, 18) - I1
    5 AVMAT(I6:$I5) = AVMAT(I6:$I5) + MAT2(I6:$I5)
    4             CONTINUE
                CDOALL 6 I2=0,0,32
                INTEGER I7, I8
                I8 = I2 + 1
                I7 = MIN0 (I2 + 1 + 32 - 1, 18) - I2
    6             AVMAT(I8:$I7) = AVMAT(I8:$I7) / N
              ENDIF
                CDOALL 7 K1=0,0,32
                INTEGER K4, K5
                K5 = K1 + 1
                K4 = MIN0 (K1 + 1 + 32 - 1, 18) - K1
    7            WHERE(PT+K5-1:$K4) = AVMAT(K5:$K4)
              PT = PT + 18
    1         CONTINUE
C
D        call trace_exit (2030) 
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
C
CCCCCCCCCCCCCCCCCCCCC END OF ROUTINE LADD CCCCCCCCCCCCCCCCCCCCCCC C
C
        SUBROUTINE LMULT(I0,I1,J0,J1,K0,K1)
C
        PARAMETER (IPOW30=2**30,IPOW16=2**16,IPOW15=2**15)
C
        K = K0*J0
        IF(K.LT.0) K = (K+IPOW30)+IPOW30
        I0=MOD(K,IPOW16)
        L = K0*J1+K1*J0
        IF(L.LT.0) L = (L+IPOW30)+IPOW30
        K = K/IPOW16+L
        IF(K.LT.0) K = (K+IPOW30)+IPOW30
        I1=MOD(K,IPOW15)
C
        RETURN
        END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
 
 
 
C
C     S. W. OTTO AND J. W. FLOWER, SUMMER 1985.
C
C     CONSTRUCTS THE STRINGS FOR MEASURING PLANAR RxT WILSON LOOPS.
C     IF R=1 THEN INSTEAD OF FETCHING A BARRED LEG FOR THE T DIRECTION W
C     CONSTRUCT IT EXPLICITLY USING THE REGULAR LINKS.
C
C     CONVERTED FROM C TO FORTRAN BY KEN BARISH, CLIVE BAILLIE,
C     AND DAVID WALKER, 1987
C
      SUBROUTINE LPSTRM(PSTRT,PSTRU,PSTRB,R,T,DIR)
      INTEGER PSTRT(60),PSTRU(60),PSTRB(60)
      INTEGER R,T,DIR
C
      INTEGER RR,TT,CNT,TEMP
      INTEGER II1, II2, II3, II4, II5, II6, II7, II8, TT1, RR1, RR2, TT2
     X  , RR3, TT3, TT4, RR4, RR5, RR6, TT5, TT6, TT7, II11, RR7, RR8,
     X  RR9, II14, RR11, RR12, II17, TT9, II20, RR15, II23, TT11, II26,
     X  TT13, II29, RR17, II32, RR19
      INTEGER II35, RR22, II38
C
C  FIRST GET THE TOP OF THE LOOP BARRING AS MANY LINKS AS POSSIBLE
C
      CNT = 1
D        call trace_enter (2031) 
      TT5 = (T + 31) / 32
      II9 = 32 * TT5 - 32
      II10 = 32
      II11 = MAX0 ((II9 + II10) / II10, 0)
      CDOALL 1 TT1=0,II9,II10
      INTEGER TT8, II9, II10
      TT8 = MIN0 (TT1 + 32 - 1, T - 1) - TT1 + 1
        PSTRT(TT1+1:$TT8) = 26
    1   END CDOALL
        IF (II11 .GT. 0) CNT = T + 1
C
D        call trace_exit (2032) 
      TEMP = 23+DIR
D        call trace_enter (2033) 
        II1 = CNT
      RR7 = (R + 31) / 32
      II12 = 32 * RR7 - 32
      II13 = 32
      II14 = MAX0 ((II12 + II13) / II13, 0)
      CDOALL 2 RR1=0,II12,II13
      INTEGER RR10, II12, II13
      RR10 = MIN0 (RR1 + 32 - 1, R - 1) - RR1 + 1
        PSTRT(II1+RR1:$RR10) = TEMP
    2   END CDOALL
        IF (II14 .GT. 0) CNT = II1 + R
C
D        call trace_exit (2034) 
      TEMP = 5+DIR
      PSTRT(CNT) = TEMP
      CNT = CNT+1
C
      TEMP = 19+DIR
D        call trace_enter (2035) 
        II2 = CNT
      RR11 = (R + 29) / 32
      II15 = 32 * RR11 - 32
      II16 = 32
      II17 = MAX0 ((II15 + II16) / II16, 0)
      CDOALL 3 RR2=0,II15,II16
      INTEGER RR13, RR14, II15, II16
      RR14 = RR2 + 1
      RR13 = MIN0 (RR2 + 1 + 32 - 1, R - 2) - RR2
        PSTRT(II2+RR14-1:$RR13) = TEMP
    3   END CDOALL
        IF (II17 .GT. 0) CNT = II2 + R - 2
C
D        call trace_exit (2036) 
      IF(R.GE.2) THEN
        TEMP = 5+DIR
        PSTRT(CNT) = TEMP
        CNT = CNT+1
      ENDIF
C
D        call trace_enter (2037) 
        II3 = CNT
      TT9 = (T + 31) / 32
      II18 = 32 * TT9 - 32
      II19 = 32
      II20 = MAX0 ((II18 + II19) / II19, 0)
      CDOALL 4 TT2=0,II18,II19
      INTEGER TT10, II18, II19
      TT10 = MIN0 (TT2 + 32 - 1, T - 1) - TT2 + 1
        PSTRT(II3+TT2:$TT10) = 30
    4   END CDOALL
        IF (II20 .GT. 0) CNT = II3 + T
D        call trace_exit (2038) 
      PSTRT(CNT) = 14
C
C  NOW CONSTRUCT THE TIMELIKE LEG. IF R=1 MAKE EXPLICITLY
C
      CNT = 1
      TEMP = 23+DIR
D        call trace_enter (2039) 
      RR15 = (R + 31) / 32
      II21 = 32 * RR15 - 32
      II22 = 32
      II23 = MAX0 ((II21 + II22) / II22, 0)
      CDOALL 5 RR3=0,II21,II22
      INTEGER RR16, II21, II22
      RR16 = MIN0 (RR3 + 32 - 1, R - 1) - RR3 + 1
        PSTRU(RR3+1:$RR16) = TEMP
    5   END CDOALL
        IF (II23 .GT. 0) CNT = R + 1
C
D        call trace_exit (2040) 
      IF(R.GT.1) THEN
        PSTRU(CNT) = 36
        CNT = CNT+1
      ELSE
D        call trace_enter (2041) 
        II4 = CNT
        TT11 = (T + 31) / 32
        II24 = 32 * TT11 - 32
        II25 = 32
        II26 = MAX0 ((II24 + II25) / II25, 0)
        CDOALL 6 TT3=0,II24,II25
        INTEGER TT12, II24, II25
        TT12 = MIN0 (TT3 + 32 - 1, T - 1) - TT3 + 1
          PSTRU(II4+TT3:$TT12) = 4
    6     END CDOALL
          IF (II26 .GT. 0) CNT = II4 + T
D        call trace_exit (2042) 
D        call trace_enter (2043) 
        II5 = CNT
        TT13 = (T + 31) / 32
        II27 = 32 * TT13 - 32
        II28 = 32
        II29 = MAX0 ((II27 + II28) / II28, 0)
        CDOALL 7 TT4=0,II27,II28
        INTEGER TT14, II27, II28
        TT14 = MIN0 (TT4 + 32 - 1, T - 1) - TT4 + 1
          PSTRU(II5+TT4:$TT14) = 30
    7     END CDOALL
          IF (II29 .GT. 0) CNT = II5 + T
D        call trace_exit (2044) 
      ENDIF
C
      TEMP = 27+DIR
D        call trace_enter (2045) 
        II6 = CNT
      RR17 = (R + 31) / 32
      II30 = 32 * RR17 - 32
      II31 = 32
      II32 = MAX0 ((II30 + II31) / II31, 0)
      CDOALL 8 RR4=0,II30,II31
      INTEGER RR18, II30, II31
      RR18 = MIN0 (RR4 + 32 - 1, R - 1) - RR4 + 1
        PSTRU(II6+RR4:$RR18) = TEMP
    8   END CDOALL
        IF (II32 .GT. 0) CNT = II6 + R
C
D        call trace_exit (2046) 
      PSTRU(CNT) = 14
      CNT = CNT+1
C
C  FINALLY MAKE THE BOTTOM OF THE LOOP
C
      CNT = 1
      TEMP = 1+DIR
      PSTRB(CNT) = TEMP
C
      CNT = CNT+1
      TEMP = 15+DIR
D        call trace_enter (2047) 
        II7 = CNT
      RR19 = (R + 29) / 32
      II33 = 32 * RR19 - 32
      II34 = 32
      II35 = MAX0 ((II33 + II34) / II34, 0)
      CDOALL 9 RR5=0,II33,II34
      INTEGER RR20, RR21, II33, II34
      RR21 = RR5 + 1
      RR20 = MIN0 (RR5 + 1 + 32 - 1, R - 2) - RR5
        PSTRB(II7+RR21-1:$RR20) = TEMP
    9   END CDOALL
        IF (II35 .GT. 0) CNT = II7 + R - 2
C
D        call trace_exit (2048) 
      IF(R.GE.2) THEN
        TEMP = 1+DIR
        PSTRB(CNT) = TEMP
        CNT = CNT+1
      ENDIF
C
      TEMP = 27+DIR
D        call trace_enter (2049) 
        II8 = CNT
      RR22 = (R + 31) / 32
      II36 = 32 * RR22 - 32
      II37 = 32
      II38 = MAX0 ((II36 + II37) / II37, 0)
      CDOALL 10 RR6=0,II36,II37
      INTEGER RR23, II36, II37
      RR23 = MIN0 (RR6 + 32 - 1, R - 1) - RR6 + 1
        PSTRB(II8+RR6:$RR23) = TEMP
   10   END CDOALL
        IF (II38 .GT. 0) CNT = II8 + R
C
D        call trace_exit (2050) 
      PSTRB(CNT) = 14
C
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
 
 
 
C
C     STEVE OTTO (AND JON FLOWER) JULY 1984
C
C     SETS UP INITIAL MOVEMENT TABLES.
C
C     CONVERTED FROM C TO FORTRAN BY KEN BARISH, CLIVE BAILLIE,
C     AND DAVID WALKER, SUMMER 1987
C
      SUBROUTINE MAKE
      INTEGER DIMS
      PARAMETER (DIMS=4)
      PARAMETER ( L1=12, L2=12, L3=12, L4=12 )
      PARAMETER ( MLEG=18*L1*L2*L3 )
      INTEGER LATT(DIMS),LATT1(DIMS),MOV(DIMS),ROT(DIMS),WHICH(13,13)
      REAL WLOOP(13,13),RES(13,13,6),BETA,LEGS(MLEG)
      COMMON /COMSYS/ BETA,WLOOP,RES,LEGS,LATT,LATT1,MOV,ROT,WHICH
C
D        call trace_enter (2051) 
      CDOALL 1 I=1,4
    1   ROT(I) = 18*(I-1)
C
D        call trace_exit (2052) 
      MOV(1) = 72
      MOV(2) = MOV(1)*LATT(1)
      MOV(3) = MOV(2)*LATT(2)
      MOV(4) = MOV(3)*LATT(3)
C
D        call trace_enter (2053) 
      CDOALL 2 I=1,4
    2   LATT1(I) = LATT(I)-1
C
D        call trace_exit (2054) 
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
C
C     JON FLOWER, STEVE OTTO   MARCH 1985.  MOD: JUNE 85
C
C     MEASURES WILSON LOOPS UP TO RxT BARRING EVERYTHING IN SIGHT....
C     ALSO MAKES LEGS.
C
C     CONVERTED FROM C TO FORTRAN BY KEN BARISH, CLIVE BAILLIE,
C     AND DAVID WALKER, 1987
C
      SUBROUTINE MEASUR(DIR,RMIN,RMAX,NUMHIT)
      INTEGER DIR,RMIN,RMAX,NUMHIT
C
      INTEGER DIMS
      PARAMETER (DIMS=4)
      PARAMETER ( L1=12, L2=12, L3=12, L4=12 )
      PARAMETER ( MLEG=18*L1*L2*L3 )
      INTEGER UMAX
      PARAMETER ( UMAX=72*L1*L2*L3*L4 )
      PARAMETER ( MBAR=18*L1*L2*L3*L4 )
      INTEGER LATT(DIMS),LATT1(DIMS),MOV(DIMS),ROT(DIMS),WHICH(13,13)
      REAL WLOOP(13,13),RES(13,13,6),BETA,LEGS(MLEG)
      COMMON /COMSYS/ BETA,WLOOP,RES,LEGS,LATT,LATT1,MOV,ROT,WHICH
C
      REAL UBAR(MBAR),SBAR(MBAR)
      COMMON /COMUBR/ UBAR,SBAR
C
      INTEGER R,NCHAR,COORD(4),TFLAG,SITE,T,PLEGS
      INTEGER STRT(60),STRU(60),STRB(60)
      REAL UP(18),DOWN(18),TOP(18),BOTTOM(18),STEMP(18,2)
C
D        call trace_enter (2055) 
        CDOALL 1 T=0,12
          WLOOP(1:$13,T+1) = 0.0
    1     CONTINUE
C
D        call trace_exit (2056) 
      CALL LINKBR(NUMHIT,DIR,SBAR)
C
C     ONE TIME SLICE AT A TIME
C
D        call trace_enter (2057) 
      DO 3 ICORD4=0,LATT(4)-1
        COORD(4) = ICORD4
        DO 4 T=1,12
          TFLAG = 0
          DO 5 R=RMIN,RMAX
            IF (WHICH(R+1,T+1) .EQ. 1) TFLAG = 1
    5       CONTINUE
C
C    TFLAG=1 MEANS WE NEED LEGS OF THIS T
C
          IF(TFLAG.EQ.1) CALL LEGMAK(T,ICORD4)
C
          DO 6 R=RMIN,RMAX
            IF((R.LE.T).AND.(WHICH(R+1,T+1).EQ.1)) THEN
              CALL LPSTRM(STRT,STRU,STRB,R,T,DIR)
              SITE = ICORD4*MOV(4)
              PLEGS = 1
              DO 8 ICORD3=0,LATT(3)-1
                COORD(3) = ICORD3
                DO 8 ICORD2=0,LATT(2)-1
                  COORD(2) = ICORD2
                  DO 8 ICORD1=0,LATT(1)-1
                     COORD(1) = ICORD1
C
C                    FETCH AND DAGGER THE DOWN LEG
C
                     CALL UDAG(LEGS(PLEGS),DOWN)
C
C                    FIND THE TOP
C
                     CALL SYSLOP(COORD,SITE,STRT,TOP,NCHAR)
C
C                    FIND THE UP
C
                     CALL SYSLOP(COORD,SITE,STRU,UP,NCHAR)
C
C                    FIND THE BOTTOM
C
                     CALL SYSLOP(COORD,SITE,STRB,BOTTOM,NCHAR)
C
C                    PUT THEM ALL TOGETHER
C
                     CALL MULT(BOTTOM,UP,STEMP(1,1))
                     CALL MULT(STEMP(1,1),TOP,STEMP(1,2))
                     CALL MULT(STEMP(1,2),DOWN,STEMP(1,1))
                     WLOOP(R+1,T+1) = WLOOP(R+1,T+1)+(STEMP(1,1)+
     .                                  STEMP(9,1)+STEMP(17,1))/3.0
                     PLEGS = PLEGS+18
                     SITE = SITE+MOV(1)
    8                CONTINUE
            ENDIF
    6       CONTINUE
    4     CONTINUE
    3   CONTINUE
C
D        call trace_exit (2058) 
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
      SUBROUTINE MULT(A,B,C)
      REAL A(18),B(18),C(18)
C
      C(1)  = A(1)*B(1)-A(2)*B(2)+A(7)*B(3)-A(8)*B(4)+A(13)*B(5)
     .       -A(14)*B(6)
      C(2)  = A(1)*B(2)+A(2)*B(1)+A(7)*B(4)+A(8)*B(3)+A(13)*B(6)
     .       +A(14)*B(5)
      C(3)  = A(3)*B(1)-A(4)*B(2)+A(9)*B(3)-A(10)*B(4)+A(15)*B(5)
     .       -A(16)*B(6)
      C(4)  = A(3)*B(2)+A(4)*B(1)+A(9)*B(4)+A(10)*B(3)+A(15)*B(6)
     .       +A(16)*B(5)
      C(5)  = A(5)*B(1)-A(6)*B(2)+A(11)*B(3)-A(12)*B(4)+A(17)*B(5)
     .       -A(18)*B(6)
      C(6)  = A(5)*B(2)+A(6)*B(1)+A(11)*B(4)+A(12)*B(3)+A(17)*B(6)
     .       +A(18)*B(5)
      C(7)  = A(1)*B(7)-A(2)*B(8)+A(7)*B(9)-A(8)*B(10)+A(13)*B(11)
     .       -A(14)*B(12)
      C(8)  = A(1)*B(8)+A(2)*B(7)+A(7)*B(10)+A(8)*B(9)+A(13)*B(12)
     .       +A(14)*B(11)
      C(9)  = A(3)*B(7)-A(4)*B(8)+A(9)*B(9)-A(10)*B(10)+A(15)*B(11)
     .       -A(16)*B(12)
      C(10) = A(3)*B(8)+A(4)*B(7)+A(9)*B(10)+A(10)*B(9)+A(15)*B(12)
     .       +A(16)*B(11)
      C(11) = A(5)*B(7)-A(6)*B(8)+A(11)*B(9)-A(12)*B(10)+A(17)*B(11)
     .       -A(18)*B(12)
      C(12) = A(5)*B(8)+A(6)*B(7)+A(11)*B(10)+A(12)*B(9)+A(17)*B(12)
     .       +A(18)*B(11)
      C(13) = A(1)*B(13)-A(2)*B(14)+A(7)*B(15)-A(8)*B(16)+A(13)*B(17)
     .       -A(14)*B(18)
      C(14) = A(1)*B(14)+A(2)*B(13)+A(7)*B(16)+A(8)*B(15)+A(13)*B(18)
     .       +A(14)*B(17)
      C(15) = A(3)*B(13)-A(4)*B(14)+A(9)*B(15)-A(10)*B(16)+A(15)*B(17)
     .       -A(16)*B(18)
      C(16) = A(3)*B(14)+A(4)*B(13)+A(9)*B(16)+A(10)*B(15)+A(15)*B(18)
     .       +A(16)*B(17)
      C(17) = A(5)*B(13)-A(6)*B(14)+A(11)*B(15)-A(12)*B(16)+A(17)*B(17)
     .       -A(18)*B(18)
      C(18) = A(5)*B(14)+A(6)*B(13)+A(11)*B(16)+A(12)*B(15)+A(17)*B(18)
     .       +A(18)*B(17)
C
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
C
C
C    J. W. FLOWER   AUG 1985
C
C     CONSTRUCTS THE THREE QUARK OBSERVABLE :
C
C                            (1)  (2)  (3)
C       EPSILON   EPSILON    U    U    U
C              IJK       PQR  IP   JQ   KR
C
C    THIS CODE IS CERTAINLY NON-OPTIMAL BUT SACRIFICES
C            SPEED FOR CODING SIMPLICITY
C
C    CONVERTED FROM C TO FORTRAN BY KEN BARISH, CLIVE BAILLIE,
C    AND DAVID WALKER, 1987
C
      SUBROUTINE OBSERV(TOT,U1,U2,U3)
      REAL TOT(2),U1(2,9),U2(2,9),U3(2,9)
C
      INTEGER P,Q,R,EPSILO(3,3,3)
      REAL FAC
C
D        call trace_enter (2059) 
          CDOALL 1 K=1,3
    1       EPSILO(1:$3,1:$3,K) = 0
C
D        call trace_exit (2060) 
      EPSILO(1,2,3) = 1
      EPSILO(2,3,1) = 1
      EPSILO(3,1,2) = 1
      EPSILO(2,1,3) = -1
      EPSILO(1,3,2) = -1
      EPSILO(3,2,1) = -1
C
D        call trace_enter (2061) 
      DO 2 I=0,2
        DO 2 P=0,2
          DO 2 J=0,2
            DO 2 Q=0,2
              DO 2 K=0,2
                IF(EPSILO(I+1,J+1,K+1).NE.0) THEN
                DO 3 R=0,2
                  IF(EPSILO(P+1,Q+1,R+1).NE.0) THEN
                    FAC = EPSILO(I+1,J+1,K+1)*EPSILO(P+1,Q+1,R+1)
      TOT(1) = TOT(1) + FAC * U1(1,3*I+P+1) * U2(1,3*J+Q+1) * U3(1,3*K+R
     X  +1)
      TOT(1) = TOT(1) - FAC * U1(2,3*I+P+1) * U2(2,3*J+Q+1) * U3(1,3*K+R
     X  +1)
      TOT(1) = TOT(1) - FAC * U1(1,3*I+P+1) * U2(2,3*J+Q+1) * U3(2,3*K+R
     X  +1)
      TOT(1) = TOT(1) - FAC * U1(2,3*I+P+1) * U2(1,3*J+Q+1) * U3(2,3*K+R
     X  +1)
                    TOT(2) = TOT(2)+ FAC*U1(1,3*I+P+1)*U2(1,3*J+Q+1)
     .                       *U3(2,3*K+R+1)
                    TOT(2) = TOT(2)+ FAC*U1(1,3*I+P+1)*U2(2,3*J+Q+1)
     .                       *U3(1,3*K+R+1)
                    TOT(2) = TOT(2)+ FAC*U1(2,3*I+P+1)*U2(1,3*J+Q+1)
     .                       *U3(1,3*K+R+1)
                    TOT(2) = TOT(2)- FAC*U1(2,3*I+P+1)*U2(2,3*J+Q+1)
     .                       *U3(2,3*K+R+1)
                  ENDIF
    3             CONTINUE
                ENDIF
    2           CONTINUE
C
D        call trace_exit (2062) 
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
C
CCCCCCCCCCCCCCCCCCCCC END OF ROUTINE PRNSET CCCCCCCCCCCCCCCCCCCCCCC C
C
        FUNCTION PRANF(IDUMMY)
        COMMON /RAN/IRAND0,IRAND1,IAB0,IAB1,ICB0,ICB1
        SAVE /RAN/
C
        DOUBLE PRECISION RANDB,DIVFAC,POW16
        PARAMETER (DIVFAC=2.147483648D9,POW16=6.5536D4)
C
          RANDB=(DBLE(IRAND0)+6.5536D4*DBLE(IRAND1))/2.147483648D9
C        RANDB=(DBLE(IRAND0)+POW16*DBLE(IRAND1))/DIVFAC
         PRANF=REAL(RANDB)

          iKLMULT=IAB0*IRAND0
          IF (iKLMULT.LT.0) THEN
                iKLMULT=(iKLMULT+1073741824)+1073741824
            END IF
          J0=MOD(iKLMULT,65536)
         iLLMULT=IAB0*IRAND1+IAB1*IRAND0
         IF (iLLMULT.LT.0) THEN
                iLLMULT=(iLLMULT+1073741824)+1073741824
            END IF
         iKLMULT=iKLMULT/65536+iLLMULT
         IF (iKLMULT.LT.0) THEN
                iKLMULT=(iKLMULT+1073741824)+1073741824
            END IF
          J1=MOD(iKLMULT,32768)
          IRAND0=MOD(ICB0+J0,65536)
          IRAND1=MOD(((ICB0+J0)/65536+ICB1)+J1,32768)

C        CALL LMULT(J0,J1,IRAND0,IRAND1,IAB0,IAB1)
C        CALL LADD(IRAND0,IRAND1,J0,J1,ICB0,ICB1)
C
        RETURN
        END









C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
C
      SUBROUTINE PRNSE2(ISEED)
      PARAMETER (MULT = 1103515245, IADD=12345)
      INTEGER AAA,BBB,RANDX
      COMMON /COMPRA/ AAA,BBB,RANDX
      SAVE /COMPRA/
      AAA = MULT
      BBB = IADD
      RANDX = ISEED
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
C
        SUBROUTINE PRNSET(ISEED)
        COMMON /RAN/IRAND0,IRAND1,IAB0,IAB1,ICB0,ICB1
        SAVE /RAN/
C
        PARAMETER (MULT0=20077,MULT1=16838,IADD0=12345,IADD1=0)
        PARAMETER (IPOW16=2**16)
C
        ISEED0=MOD(ISEED,IPOW16)
        ISEED1=ISEED/IPOW16
        IAB0=MULT0
        IAB1=MULT1
        ICB0=IADD0
        ICB1=IADD1
        CALL LMULT(J0,J1,ISEED0,ISEED1,IAB0,IAB1)
        CALL LADD(IRAND0,IRAND1,J0,J1,ICB0,ICB1)
        RETURN
        END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
C
CCCCCCCCCCCCCCCCCCCCCCCCCCC  END OF ROUTINE IGETSD  CCCCCCCCCCCCCCCCCCCC
C
 
C
C     STEVE OTTO  AND JON FLOWER, JULY 1984.
C
C     DUE TO THE STRANGE SHAPE OF THE SU(3) GROUP MANIFOLD (WHATEVER IT
C     THE LINK MATRICES TEND TO DRIFT OFF AND MUST BE PROJECTED BACK
C     PERIODICALLY. THE SITUATION IS OBVIOUSLY NOT HELPED BY THE LIMITED
C     ACCURACY OF THE FIXED POINT FORMAT.                             */
C
C     CONVERTED FROM C TO FORTRAN BY KEN BARISH, CLIVE BAILLIE,
C     AND DAVID WALKER, 1987
C
      SUBROUTINE PROJEC
C
      INTEGER DIMS
      PARAMETER (DIMS=4)
      PARAMETER ( L1=12, L2=12, L3=12, L4=12 )
      PARAMETER ( MLEG=18*L1*L2*L3 )
      INTEGER UMAX
      PARAMETER ( UMAX=72*L1*L2*L3*L4 )
      INTEGER LATT(DIMS),LATT1(DIMS),MOV(DIMS),ROT(DIMS),WHICH(13,13)
      REAL WLOOP(13,13),RES(13,13,6),BETA,LEGS(MLEG)
      COMMON /COMSYS/ BETA,WLOOP,RES,LEGS,LATT,LATT1,MOV,ROT,WHICH
C
      REAL U1(UMAX)
      COMMON /COMU1/ U1
C
      REAL X(12),Z(6),FAC
      INTEGER SITE
      INTEGER PU
      INTEGER J1, J2, J3, J4, J5
C
      NUMLIN = 4*LATT(1)*LATT(2)*LATT(3)*LATT(4)
C
D        call trace_enter (2063) 
      DO 1 I=0,NUMLIN-1
        SITE = ROT(2)*I
        PU = SITE
        CDOALL 10 J1=0,0,32
        INTEGER J6, J7
        J7 = J1 + 1
        J6 = MIN0 (J1 + 1 + 32 - 1, 12) - J1
   10     X(J7:$J6) = U1(PU+J7:$J6)
        Z(1) = X(3)*X(11) - X(4)*X(12) - X(5)*X(9) + X(6)*X(10)
        Z(2) = -X(4)*X(11) - X(3)*X(12) + X(6)*X(9) + X(5)*X(10)
        Z(3) = X(5)*X(7) - X(6)*X(8) - X(1)*X(11) + X(2)*X(12)
        Z(4) = -X(6)*X(7) - X(5)*X(8) + X(2)*X(11) + X(1)*X(12)
        Z(5) = X(1)*X(9) - X(2)*X(10) - X(3)*X(7) + X(4)*X(8)
        Z(6) = -X(2)*X(9) - X(1)*X(10) + X(4)*X(7) + X(3)*X(8)
        FAC  = 0.0
    2     FAC = FAC + DOTPRODUCT (X(1:$6), X(1:$6))
        FAC = 1.0/SQRT(FAC)
        CDOALL 3 J2=0,0,32
        INTEGER J8, J9
        J9 = J2 + 1
        J8 = MIN0 (J2 + 1 + 32 - 1, 6) - J2
    3     X(J9:$J8) = X(J9:$J8) * FAC
        X(7)  = Z(3)*X(5) - Z(4)*X(6) - Z(5)*X(3) + Z(6)*X(4)
        X(8)  = -Z(3)*X(6) - Z(4)*X(5) + Z(5)*X(4) + Z(6)*X(3)
        X(9)  = Z(5)*X(1) - Z(6)*X(2) - Z(1)*X(5) + Z(2)*X(6)
        X(10) = -Z(5)*X(2) - Z(6)*X(1) + Z(1)*X(6) + Z(2)*X(5)
        X(11) = Z(1)*X(3) - Z(2)*X(4) - Z(3)*X(1) + Z(4)*X(2)
        X(12) = -Z(1)*X(4) - Z(2)*X(3) + Z(3)*X(2) + Z(4)*X(1)
        FAC=0.0
    4     FAC = FAC + DOTPRODUCT (X(7:$6), X(7:$6))
        FAC = 1.0/SQRT(FAC)
        CDOALL 5 J3=0,0,32
        INTEGER J10, J11
        J11 = J3 + 1
        J10 = MIN0 (J3 + 1 + 32 - 1, 6) - J3
    5     X(J11+6:$J10) = X(J11+6:$J10) * FAC
        CALL CFILL(U1(PU+1),X)
    1 CONTINUE
C
D        call trace_exit (2064) 
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C                THIS SOFTWARE COPYRIGHTED BY CALTECH, 1983, 1986, 1987
C
C                PURE GAUGE SU(3) MONTE CARLO
C                THIS CODE HAS A LONG HISTORY:
C                    EARLY VERSIONS OF THIS DEVELOPED FOR THE MARK I
C                    HYPERCUBE BY STEVE OTTO AND PAUL STOLORZ (19
C                    JON FLOWER AND STEVE OTTO EXTENDED AND IMPROVED THE
C                    CODE FOR THE MARK II MACHINES. (1984-86)
C                    THE CURRENT INCARNATION IS A "PORT" TO THE NCUBE
C                    DONE BY CLIVE BAILLIE, ED FELTEN, STEVE OTTO,
C                    AND DAVID WALKER  (1987)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C               PURE GAUGE SU(3) THEORY IN 3+1 DIMENSIONS
C               LINK VARIABLE UPDATING DONE VIA CABIBBO-MARINARI HEAT BA
C
C     CONVERTED FROM C TO FORTRAN BY KEN BARISH, CLIVE BAILLIE
C     AND DAVID WALKER, SUMMER 1987
C
      PROGRAM QCD2
C
      INTEGER DIMS
      PARAMETER (DIMS=4)
      PARAMETER ( L1=12, L2=12, L3=12, L4=12 )
      PARAMETER ( MLEG=18*L1*L2*L3 )
      INTEGER UMAX
      PARAMETER ( UMAX=72*L1*L2*L3*L4 )
      PARAMETER ( MBAR=18*L1*L2*L3*L4 )
      INTEGER LATT(DIMS),LATT1(DIMS),MOV(DIMS),ROT(DIMS),WHICH(13,13)
      REAL WLOOP(13,13),RES(13,13,6),BETA,LEGS(MLEG)
      COMMON /COMSYS/ BETA,WLOOP,RES,LEGS,LATT,LATT1,MOV,ROT,WHICH
      PARAMETER ( LISMAX=(L1*L2*L3*L4)/2+1 )
      COMMON /COLCOM/ LISRED(LISMAX),LISBLK(LISMAX),NRED,NBLACK
C
      REAL U1(UMAX)
      COMMON /COMU1/ U1
C
      REAL UBAR(MBAR),SBAR(MBAR)
      COMMON /COMUBR/ UBAR,SBAR
C
      INTEGER NUMSTG
      COMMON /COMFIL/ NUMSTG
C
      INTEGER I,J,K,NUMOFF,AVGNUM,FLG
      INTEGER R,T,NUMBAR,DIR,RMIN,RMAX,TMIN(13),TMAX(13)
      INTEGER R1MAX,R2MAX,R1,R2,R3,TMX,TMN
      CHARACTER C
      INTEGER SWEEPS,PINVAL
C
      REAL FC(2)
      REAL TIME(6)
      INTEGER R4
C
      OPEN(5,FILE='LGI5',STATUS='OLD')
      OPEN(6,FILE='LGO6',STATUS='NEW')
      OPEN(8,FILE='LGV',STATUS='NEW')
C
D      CALL  INIT_TRACE(1)
      CALL CPUTIM(TIME(3))
      CALL ELAPSE(TIME(4))
       
C
      CALL PRNSET(42)
C
      WRITE(8,201)
201   FORMAT(1X,'OUTPUT FOR PERFECT CLUB BENCHMARK: QCD'/
     *       1X,'$Revision: 1.13 $ $Author: kipp $'/)
      WRITE(8,202)
202   FORMAT(1X,'VALIDATION PARAMETERS:'/)
C
      WRITE(6,*) 'PURE GAUGE QCD USING PSEUDO HEAT BATH'
      WRITE(6,*) '-------------------------------------'
      WRITE(6,*) ' '
      WRITE(6,*) 'ENTER COMMAND (? FOR HELP)'
      WRITE(6,*) ' '
   10 READ (5,200) C
C
      IF (C.EQ.'R') THEN
        CALL SETSED()
      ELSEIF (C.EQ.'D') THEN
        CALL DMPSED()
      ELSEIF (C.EQ.'S') THEN
        CALL SETPAR()
      ELSEIF (C.EQ.'P') THEN
        CALL PROJEC()
      ELSEIF (C.EQ.'U') THEN
        WRITE(6,*) 'ENTER NUMBER OF TEMPORAL LINK HITS TO AVERAGE OVER'
        READ (5,*) AVGNUM
        WRITE(6,*) AVGNUM
C       CLOCK = SECNDS(0)
        CALL CPUTIM(TIME(1))
        CALL LINKBR(AVGNUM,3,UBAR)
        CALL CPUTIM(TIME(2))
C       WRITE(6,101) SECNDS(0)-CLOCK
        WRITE(6,101) TIME(2)-TIME(1)
        WRITE(6,*) 'UBARS MADE.'
      ELSEIF (C.EQ.'M') THEN
        WRITE(6,*) 'ENTER DIR (0<->X,1<->Y,2<->Z), RMIN, RMAX'
        READ (5,*) DIR,RMIN,RMAX
        WRITE(6,*) DIR,RMIN,RMAX
D        call trace_enter (2065) 
        DO 1 R=RMIN,RMAX
          WRITE(6,*) 'FOR R = ',R,' ENTER TMIN, TMAX '
          READ (5,*) TMIN(R+1),TMAX(R+1)
          WRITE(6,*) TMIN(R+1),TMAX(R+1)
    1   CONTINUE
C
D        call trace_exit (2066) 
D        call trace_enter (2067) 
          CDOALL 2 T=1,13
            WHICH(1:$13,T) = 0
    2   CONTINUE
C
D        call trace_exit (2068) 
D        call trace_enter (2069) 
        R4 = RMAX - RMIN + 1
          CDOALL 3 T=1,13
          WHERE ((T .GE. TMIN(RMIN+1:$R4)) .AND. (T .LE. TMAX(RMIN+1:$R4
     X      ))) WHICH(RMIN+1:$R4,T+1) = 1
    3   CONTINUE
C
D        call trace_exit (2070) 
        WRITE(6,*) 'ENTER NUMBER OF SPATIAL LINK HITS TO AVERAGE OVER'
        READ (5,*) AVGNUM
        WRITE(6,*) AVGNUM
        WRITE(6,*) 'MEASURING WILSON (ON-AXIS) LOOPS IN DIRECTION ',DIR
C       CLOCK = SECNDS(0)
        CALL CPUTIM(TIME(1))
        CALL MEASUR(DIR,RMIN,RMAX,AVGNUM)
        CALL CPUTIM(TIME(2))
        WRITE(6,102) TIME(2)-TIME(1)
C       WRITE(6,102) SECNDS(0)-CLOCK
        FC(1) = NUMSTG
D        call trace_enter (2071) 
        DO 4 R=RMIN,RMAX
          DO 4 T=TMIN(R+1),TMAX(R+1)
            FC(2) = WLOOP(R+1,T+1)
            FC(2) = FC(2)/FC(1)
            WRITE(6,*) 'W',R,'X',T,':',FC(2)
            WRITE(8,*) 'W',R,'X',T,':',FC(2)
C
    4   CONTINUE
C
D        call trace_exit (2072) 
        IVAL=0
        IF (ABS((FC(2)-.633259)/.633259).GE.1E-2) IVAL=1
C
      ELSEIF (C.EQ.'I') THEN
        NUMOFF = 0
      ELSEIF (C.EQ.'A') THEN
        WRITE(6,*) 'ENTER R1,R2,R3,TMN,TMX'
        READ (5,*) R1,R2,R3,TMN,TMX
        WRITE(6,*) R1,R2,R3,TMN,TMX
        WRITE(6,*) 'MEASURING BARYON LOOPS ...'
C       CLOCK = SECNDS(0)
        CALL CPUTIM(TIME(1))
D        call trace_enter (2073) 
        DO 5 T=TMN,TMX
          CALL QQQMEA(R1,R2,R3,T)
    5   CONTINUE
D        call trace_exit (2074) 
        CALL CPUTIM(TIME(2))
        WRITE(6,103) TIME(2)-TIME(1)
C       WRITE(6,103) SECNDS(0)-CLOCK
C
         IF(IVAL.EQ.0) THEN
           WRITE(8,203)
203        FORMAT(//1X,'RESULTS FOR THIS RUN ARE:   VALID')
         ELSE
           WRITE(8,204)
204        FORMAT(//1X,'RESULTS FOR THIS RUN ARE: INVALID')
         ENDIF
C
      ELSEIF (C.EQ.'E') THEN
        WRITE(6,*) 'ENTER DIR (0<->X,1<->Y,2<->Z)'
        READ (5,*) DIR
        WRITE(6,*) DIR
        WRITE(6,*) 'ENTER NUMBER OF SPATIAL LINK HITS TO AVERAGE OVER'
        READ (5,*) NUMBAR
        WRITE(6,*) NUMBAR
D        call trace_enter (2075) 
            CDOALL 6 K=1,6
    6          RES(1:$13,1:$13,K) = 0.0
               I = 14
               J = 14
D        call trace_exit (2076) 
        WRITE(6,*) 'ENTER R1MAX AND R2MAX :'
        READ (5,*) R1MAX,R2MAX
        WRITE(6,*) R1MAX,R2MAX
        WRITE(6,*) 'NOW ENTER THE QUADRANT TABLE OF TMINS ;'
        WRITE(6,*) R1MAX,'ROWS &',R2MAX,'COLS (0 ==> OMIT)'
        READ(5,*)((WHICH(I,J), J=1,R2MAX),I=1,R1MAX)
        WRITE(6,*) 'MEASURING LOOPS IN DIRECTION ',DIR
C
C       CLOCK = SECNDS(0)
        CALL CPUTIM(TIME(1))
        CALL ROTMEA(DIR,NUMBAR,R1MAX,R2MAX)
        CALL CPUTIM(TIME(2))
        WRITE(6,105) TIME(2)-TIME(1)
C       WRITE(6,105) SECNDS(0)-CLOCK
D        call trace_enter (2077) 
        DO 7 I=1,R1MAX
          DO 7 J=1,R2MAX
            IF(WHICH(I,J).NE.0) THEN
              TMX = MIN(12,WHICH(I,J)+5)
              DO 8 T=WHICH(I,J),TMX-1
                WRITE(6,*) 'R (',I+1,',',J+1,') X',T,':',
     .                   RES(I,J,T-WHICH(I,J)+1)/REAL(NUMSTG)
                WRITE(8,*) 'R (',I+1,',',J+1,') X',T,':',
     .                   RES(I,J,T-WHICH(I,J)+1)/REAL(NUMSTG)
    8           CONTINUE
            ENDIF
    7     CONTINUE
C
D        call trace_exit (2078) 
        IF (ABS((RES(1,1,1-WHICH(1,1)+1)/REAL(NUMSTG)
     .          -.434777)/.434777).GE.1E-2) IVAL=1
        IF (ABS((RES(1,1,2-WHICH(1,1)+1)/REAL(NUMSTG)
     .          -.299319)/.299319).GE.1E-2) IVAL=1
        IF (ABS((RES(1,1,3-WHICH(1,1)+1)/REAL(NUMSTG)
     .          -.205511)/.205511).GE.1E-2) IVAL=1
        IF (ABS((RES(1,1,4-WHICH(1,1)+1)/REAL(NUMSTG)
     .         -.136702)/.136702).GE.1E-2) IVAL=1
        IF (ABS((RES(1,1,5-WHICH(1,1)+1)/REAL(NUMSTG)
     .      -9.14717E-02)/9.14717E-02).GE.1E-2) IVAL=1
C
      ELSEIF (C.EQ.'C') THEN
        WRITE(6,*) '0 <-> COLD START, 1 <-> RESTART'
        READ (5,*) FLG
        WRITE(6,*) FLG
        CALL INIT(FLG)
        WRITE(6,*) 'INITIALIZED SUCCESSFULLY.'
      ELSEIF (C.EQ.'B') THEN
        CALL LATTOT()
        WRITE(6,*) 'BACKED UP SUCCESSFULLY'
      ELSEIF (C.EQ.'F') THEN
        WRITE(6,*) 'INPUT # OF SWEEPS AND PROJECT INTERVAL'
        READ (5,*) SWEEPS,PINVAL
        WRITE(6,*) SWEEPS,PINVAL
        WRITE(6,*) 'RUNNING...'
C       CLOCK = SECNDS(0)
        CALL CPUTIM(TIME(1))
        CALL UPDATE(SWEEPS,PINVAL)
        CALL CPUTIM(TIME(2))
        WRITE(6,104) TIME(2)-TIME(1)
C       WRITE(6,104) SECNDS(0)-CLOCK
        WRITE(6,*) 'LATTICE UPDATED'
      ELSEIF (C.EQ.'?') THEN
        WRITE(6,*) 'COMMANDS (AND THEIR PARAMETERS) ARE:'
        WRITE(6,*) '===================================='
        WRITE(6,*) 'C :             INITIALIZE (COLD OR READ)'
        WRITE(6,*) 'D :             UPDATES (SWEEPS, PINVAL)'
        WRITE(6,*) 'B :             BACK UP LATTICE (FILENAME)'
        WRITE(6,*) 'S :             SET PARAMETERS'
        WRITE(6,*) 'R :             RESET RANDOM NUMBER SEEDS'
        WRITE(6,*) 'D :             DUMP CURRENT SEED TO FILE'
        WRITE(6,*) 'P :             PROJECT MATRICES ONTO SU(3)'
        WRITE(6,*) 'M :             MEASURE ON AXIS LOOPS'
        WRITE(6,*) 'E :             MEASURE OFF AXIS LOOP'
        WRITE(6,*) 'A :             MEASURE BARYON LOOPS'
        WRITE(6,*) 'U :             MAKE U BARS'
        WRITE(6,*) 'Q :             QUIT'
      ELSEIF (C.EQ.'Q') THEN
        WRITE(6,*) 'FINISHED.'
C
        CALL CPUTIM(TIME(5))
        CALL ELAPSE(TIME(6))
D       CALL EXIT_TRACE()
C
      WRITE(8,*)
      WRITE(8,*) 'ELAPSED CPU TIME IN SECONDS: ',TIME(5)-TIME(3)
C MFLOPS = MFLOP 1 CPU CRAY X-MP/CPU TIME
      WRITE(8,*) 'MFLOPS RATE: ', 259.550/(TIME(5)-TIME(3))
      WRITE(8,*) 'ELAPSED WALLCLOCK TIME IN SECONDS: ',
     *            MOD(TIME(6)-TIME(4)+1000000.0,1000000.0)
C
        STOP
      ELSE
        WRITE(6,*) 'UNKNOWN COMMAND (? FOR HELP)'
      ENDIF
      GOTO 10
C
  101 FORMAT(/5X,'Time for LINKBR = ',F11.4,' seconds')
  102 FORMAT(/5X,'Time for MEASUR = ',F11.4,' seconds')
  103 FORMAT(/5X,'Time for QQQMEA = ',F11.4,' seconds')
  104 FORMAT(/5X,'Time for UPDATE  = ',F11.4,' seconds')
  105 FORMAT(/5X,'Time for ROTMEA = ',F11.4,' seconds')
  200 FORMAT(A1)
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
C
C     J. W. FLOWER & STEVE OTTO, SEPTEMBER 1984.
C
C     USED TO ACTUALLY CALCULATE THE THREE QUARK OBSERVABLES.       */
C
C     CONVERTED FROM C TO FORTRAN BY KEN BARISH, CLIVE BAILLIE,
C     AND DAVID WALKER, 1987
C
      SUBROUTINE QQQLPC(R1,R2,R3,T,LPSTR,TOT)
      INTEGER R1,R2,R3,T
      INTEGER LPSTR(512)
      REAL TOT(2)
C
      INTEGER DIMS
      PARAMETER (DIMS=4)
      PARAMETER ( L1=12, L2=12, L3=12, L4=12 )
      PARAMETER ( MLEG=18*L1*L2*L3 )
      INTEGER LATT(DIMS),LATT1(DIMS),MOV(DIMS),ROT(DIMS),WHICH(13,13)
      REAL WLOOP(13,13),RES(13,13,6),BETA,LEGS(MLEG)
      COMMON /COMSYS/ BETA,WLOOP,RES,LEGS,LATT,LATT1,MOV,ROT,WHICH
C
      INTEGER COORD(4),ODIR,SITE,CNT
      INTEGER PSTR(512)
      REAL U1(18),U2(18),U3(18),BITS(18,3),TEMP(18)
      INTEGER I1, I2, I3, I4, I5
C
      SITE = T*MOV(4)
C
      COORD(4) = T
D        call trace_enter (2079) 
      DO 1 ICORD3=0,LATT(3)-1
        COORD(3) = ICORD3
        DO 1 ICORD2=0,LATT(2)-1
          COORD(2) = ICORD2
          DO 1 ICORD1=0,LATT(1)-1
            COORD(1) = ICORD1
C
C     FIRST GET THE MATRIX CORRESPONDING TO DIRECTION R1.
C
C            CALL CPYMAT(PSTR,LPSTR,512) LPOINTER 4-3-89
            CALL ICPYMT(PSTR,LPSTR,512)
            CNT = 1
            DO 2 I=1,3
              CALL SYSLOP(COORD,SITE,PSTR(CNT),BITS(1,I),NCHAR)
    2         CNT = NCHAR+CNT
            IF(R1.GT.0) THEN
              CALL MULT(BITS(1,1),BITS(1,2),TEMP)
              CALL MULT(TEMP,BITS(1,3),U1)
            ELSE
              CDOALL 3 I1=0,0,32
              INTEGER I6, I7
              I7 = I1 + 1
              I6 = MIN0 (I1 + 1 + 32 - 1, 18) - I1
    3           U1(I7:$I6) = BITS(I7:$I6,2)
             ENDIF
C
C      NEXT GET THE MATRIX CORRESPONDING TO DIRECTION R2.
C
            DO 4 I=1,3
              CALL SYSLOP(COORD,SITE,PSTR(CNT),BITS(1,I),NCHAR)
    4         CNT = CNT+NCHAR
            IF(R2.GT.0) THEN
              CALL MULT(BITS(1,1),BITS(1,2),TEMP)
              CALL MULT(TEMP,BITS(1,3),U2)
            ELSE
              CDOALL 5 I2=0,0,32
              INTEGER I8, I9
              I9 = I2 + 1
              I8 = MIN0 (I2 + 1 + 32 - 1, 18) - I2
    5           U2(I9:$I8) = BITS(I9:$I8,2)
            ENDIF
C
C       NOW LOOP OVER THE TWO (CURRENTLY) DIRECTIONS FOR THE R3 LEG
C       CALCULATING THE OBSERVABLES AS WE GO.
C
            DO 6 ODIR=1,2
              DO 7 I=1,3
                CALL SYSLOP(COORD,SITE,PSTR(CNT),BITS(1,I),NCHAR)
    7           CNT = CNT+NCHAR
              IF(R3.GT.0) THEN
                CALL MULT(BITS(1,1),BITS(1,2),TEMP)
                CALL MULT(TEMP,BITS(1,3),U3)
              ELSE
                CDOALL 8 I3=0,0,32
                INTEGER I10, I11
                I11 = I3 + 1
                I10 = MIN0 (I3 + 1 + 32 - 1, 18) - I3
    8             U3(I11:$I10) = BITS(I11:$I10,2)
              ENDIF
C
C        CALCULATE OBSERVABLES
C
              CALL OBSERV(TOT,U1,U2,U3)
C
    6         CONTINUE
C
C        MOVE TO NEXT SITE IN LATTICE.
C
            SITE = SITE+MOV(1)
    1     CONTINUE
C
D        call trace_exit (2080) 
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
C
C     J .W .FLOWER  AUG 1985
C
C
C     FROM ABOVE THE THREE QUARK ORIENTATION IS SPECIFIED AS FOLLOWS :
C
C
C                                   * ^
C                                   |
C                                   | R3
C                                   |
C                     * ------------|-------------------- *
C                     <---- R1 ---->|<-------- R2 -------->
C
C     THE LIMB WITH R1 & R2 IS TAKEN TO LIE IN DIRECTION "DIR" AND THE
C     OTHER LIMB IS TAKEN IN THE TWO TRANSVERSE DIRECTIONS SUCCESSIVELY.
C     NOTE : SINCE WE HAVE ACCESS TO ONLY BARRED 'LEGS' WE NEED TO MAKE
C     SOME TIMELIKE PIECES ON THE FLY.
C                                                                     */
C     CONVERTED FROM C TO FORTRAN BY KEN BARISH, CLIVE BAILLIE,
C     AND DAVID WALKER, 1987
C
      SUBROUTINE QQQLPS(R1,R2,R3,T,DIR,STR)
      INTEGER R1,R2,R3,T,DIR
      INTEGER STR(*)
      INTEGER CTR,ODIR,TEMP
      INTEGER II1, II2, II3, II4, II5, II6, II7, II8, II9, II10, II11,
     X  II12, II13, II14, II15, II16, II17, II18, II19, II20, II21, II22
     X  , II23, II24, II25, II26, II27, II28, II29, I1, I2, I3, I4, I5,
     X  I6, I7, I8, I9, I10, I11
      INTEGER I12, I13, I14, I15, I16, I17, I18, I19, I20, I21, I22, I23
     X  , II32, I25, II35, I27, II38, I29, II41, I31, II44, I33, II47,
     X  I35, II50, I37, II53, I39, II56, I41, II59, I43, II62, I45, II65
     X  , I47, II68, I49, II71, I51
      INTEGER II74, I53, II77, I55, II80, I57, II83, I59, II86, I61,
     X  II89
C
C  DO R1 LIMB - GO BACK IN "DIR" FIRST.
C
      CTR=1
      TEMP=5+DIR
D        call trace_enter (2081) 
      I21 = (R1 + 31) / 32
      II30 = 32 * I21 - 32
      II31 = 32
      II32 = MAX0 ((II30 + II31) / II31, 0)
      CDOALL 1 I1=0,II30,II31
      INTEGER I24, II30, II31
      I24 = MIN0 (I1 + 32 - 1, R1 - 1) - I1 + 1
        STR(I1+1:$I24) = TEMP
    1   END CDOALL
        IF (II32 .GT. 0) CTR = R1 + 1
C
D        call trace_exit (2082) 
      TEMP=23+DIR
D        call trace_enter (2083) 
        II1 = CTR
      I25 = (R1 + 31) / 32
      II33 = 32 * I25 - 32
      II34 = 32
      II35 = MAX0 ((II33 + II34) / II34, 0)
      CDOALL 2 I2=0,II33,II34
      INTEGER I26, II33, II34
      I26 = MIN0 (I2 + 32 - 1, R1 - 1) - I2 + 1
        STR(II1+I2:$I26) = TEMP
    2   END CDOALL
        IF (II35 .GT. 0) CTR = II1 + R1
C
D        call trace_exit (2084) 
      STR(CTR) = 14
      CTR=CTR+1
C
      TEMP=27+DIR
D        call trace_enter (2085) 
        II2 = CTR
      I27 = (R1 + 31) / 32
      II36 = 32 * I27 - 32
      II37 = 32
      II38 = MAX0 ((II36 + II37) / II37, 0)
      CDOALL 3 I3=0,II36,II37
      INTEGER I28, II36, II37
      I28 = MIN0 (I3 + 32 - 1, R1 - 1) - I3 + 1
        STR(II2+I3:$I28) = TEMP
    3   END CDOALL
        IF (II38 .GT. 0) CTR = II2 + R1
C
D        call trace_exit (2086) 
      IF(R1.NE.0) THEN
        STR(CTR) = 36
        CTR=CTR+1
      ELSE
D        call trace_enter (2087) 
        II3 = CTR
        I29 = (T + 31) / 32
        II39 = 32 * I29 - 32
        II40 = 32
        II41 = MAX0 ((II39 + II40) / II40, 0)
        CDOALL 4 I4=0,II39,II40
        INTEGER I30, II39, II40
        I30 = MIN0 (I4 + 32 - 1, T - 1) - I4 + 1
          STR(II3+I4:$I30) = 4
    4     END CDOALL
          IF (II41 .GT. 0) CTR = II3 + T
D        call trace_exit (2088) 
D        call trace_enter (2089) 
        II4 = CTR
        I31 = (T + 31) / 32
        II42 = 32 * I31 - 32
        II43 = 32
        II44 = MAX0 ((II42 + II43) / II43, 0)
        CDOALL 5 I5=0,II42,II43
        INTEGER I32, II42, II43
        I32 = MIN0 (I5 + 32 - 1, T - 1) - I5 + 1
          STR(II4+I5:$I32) = 30
    5     END CDOALL
          IF (II44 .GT. 0) CTR = II4 + T
D        call trace_exit (2090) 
      ENDIF
C
      TEMP=23+DIR
D        call trace_enter (2091) 
        II5 = CTR
      I33 = (R1 + 31) / 32
      II45 = 32 * I33 - 32
      II46 = 32
      II47 = MAX0 ((II45 + II46) / II46, 0)
      CDOALL 6 I6=0,II45,II46
      INTEGER I34, II45, II46
      I34 = MIN0 (I6 + 32 - 1, R1 - 1) - I6 + 1
        STR(II5+I6:$I34) = TEMP
    6   END CDOALL
        IF (II47 .GT. 0) CTR = II5 + R1
C
D        call trace_exit (2092) 
      STR(CTR) = 14
      CTR=CTR+1
C
      TEMP=27+DIR
D        call trace_enter (2093) 
        II6 = CTR
      I35 = (R1 + 31) / 32
      II48 = 32 * I35 - 32
      II49 = 32
      II50 = MAX0 ((II48 + II49) / II49, 0)
      CDOALL 7 I7=0,II48,II49
      INTEGER I36, II48, II49
      I36 = MIN0 (I7 + 32 - 1, R1 - 1) - I7 + 1
        STR(II6+I7:$I36) = TEMP
    7   END CDOALL
        IF (II50 .GT. 0) CTR = II6 + R1
C
D        call trace_exit (2094) 
D        call trace_enter (2095) 
        II7 = CTR
      I37 = (T + 31) / 32
      II51 = 32 * I37 - 32
      II52 = 32
      II53 = MAX0 ((II51 + II52) / II52, 0)
      CDOALL 8 I8=0,II51,II52
      INTEGER I38, II51, II52
      I38 = MIN0 (I8 + 32 - 1, T - 1) - I8 + 1
        STR(II7+I8:$I38) = 26
    8   END CDOALL
        IF (II53 .GT. 0) CTR = II7 + T
C
D        call trace_exit (2096) 
      TEMP=1+DIR
D        call trace_enter (2097) 
        II8 = CTR
      I39 = (R1 + 31) / 32
      II54 = 32 * I39 - 32
      II55 = 32
      II56 = MAX0 ((II54 + II55) / II55, 0)
      CDOALL 9 I9=0,II54,II55
      INTEGER I40, II54, II55
      I40 = MIN0 (I9 + 32 - 1, R1 - 1) - I9 + 1
        STR(II8+I9:$I40) = TEMP
    9   END CDOALL
        IF (II56 .GT. 0) CTR = II8 + R1
C
D        call trace_exit (2098) 
D        call trace_enter (2099) 
        II9 = CTR
      I41 = (T + 31) / 32
      II57 = 32 * I41 - 32
      II58 = 32
      II59 = MAX0 ((II57 + II58) / II58, 0)
      CDOALL 10 I10=0,II57,II58
      INTEGER I42, II57, II58
      I42 = MIN0 (I10 + 32 - 1, T - 1) - I10 + 1
        STR(II9+I10:$I42) = 30
   10   END CDOALL
        IF (II59 .GT. 0) CTR = II9 + T
C
D        call trace_exit (2100) 
      STR(CTR) = 14
      CTR=CTR+1
C
C   DO R2 LIMB - GO FORWARD IN "DIR" FIRST.
C
      TEMP=1+DIR
D        call trace_enter (2101) 
        II10 = CTR
      I43 = (R2 + 31) / 32
      II60 = 32 * I43 - 32
      II61 = 32
      II62 = MAX0 ((II60 + II61) / II61, 0)
      CDOALL 11 I11=0,II60,II61
      INTEGER I44, II60, II61
      I44 = MIN0 (I11 + 32 - 1, R2 - 1) - I11 + 1
        STR(II10+I11:$I44) = TEMP
   11   END CDOALL
        IF (II62 .GT. 0) CTR = II10 + R2
C
D        call trace_exit (2102) 
      TEMP=27+DIR
D        call trace_enter (2103) 
        II11 = CTR
      I45 = (R2 + 31) / 32
      II63 = 32 * I45 - 32
      II64 = 32
      II65 = MAX0 ((II63 + II64) / II64, 0)
      CDOALL 12 I12=0,II63,II64
      INTEGER I46, II63, II64
      I46 = MIN0 (I12 + 32 - 1, R2 - 1) - I12 + 1
        STR(II11+I12:$I46) = TEMP
   12   END CDOALL
        IF (II65 .GT. 0) CTR = II11 + R2
C
D        call trace_exit (2104) 
      STR(CTR) = 14
      CTR=CTR+1
C
      TEMP=23+DIR
D        call trace_enter (2105) 
        II12 = CTR
      I47 = (R2 + 31) / 32
      II66 = 32 * I47 - 32
      II67 = 32
      II68 = MAX0 ((II66 + II67) / II67, 0)
      CDOALL 13 I13=0,II66,II67
      INTEGER I48, II66, II67
      I48 = MIN0 (I13 + 32 - 1, R2 - 1) - I13 + 1
        STR(II12+I13:$I48) = TEMP
   13   END CDOALL
        IF (II68 .GT. 0) CTR = II12 + R2
C
D        call trace_exit (2106) 
      IF(R2.NE.0) THEN
        STR(CTR) = 36
        CTR=CTR+1
      ELSE
D        call trace_enter (2107) 
        II13 = CTR
        I49 = (T + 31) / 32
        II69 = 32 * I49 - 32
        II70 = 32
        II71 = MAX0 ((II69 + II70) / II70, 0)
        CDOALL 14 I14=0,II69,II70
        INTEGER I50, II69, II70
        I50 = MIN0 (I14 + 32 - 1, T - 1) - I14 + 1
          STR(II13+I14:$I50) = 4
   14     END CDOALL
          IF (II71 .GT. 0) CTR = II13 + T
D        call trace_exit (2108) 
D        call trace_enter (2109) 
        II14 = CTR
        I51 = (T + 31) / 32
        II72 = 32 * I51 - 32
        II73 = 32
        II74 = MAX0 ((II72 + II73) / II73, 0)
        CDOALL 15 I15=0,II72,II73
        INTEGER I52, II72, II73
        I52 = MIN0 (I15 + 32 - 1, T - 1) - I15 + 1
          STR(II14+I15:$I52) = 30
   15     END CDOALL
          IF (II74 .GT. 0) CTR = II14 + T
D        call trace_exit (2110) 
      ENDIF
C
      TEMP=27+DIR
D        call trace_enter (2111) 
        II15 = CTR
      I53 = (R2 + 31) / 32
      II75 = 32 * I53 - 32
      II76 = 32
      II77 = MAX0 ((II75 + II76) / II76, 0)
      CDOALL 16 I16=0,II75,II76
      INTEGER I54, II75, II76
      I54 = MIN0 (I16 + 32 - 1, R2 - 1) - I16 + 1
        STR(II15+I16:$I54) = TEMP
   16   END CDOALL
        IF (II77 .GT. 0) CTR = II15 + R2
C
D        call trace_exit (2112) 
      STR(CTR) = 14
      CTR=CTR+1
C
      TEMP=23+DIR
D        call trace_enter (2113) 
        II16 = CTR
      I55 = (R2 + 31) / 32
      II78 = 32 * I55 - 32
      II79 = 32
      II80 = MAX0 ((II78 + II79) / II79, 0)
      CDOALL 17 I17=0,II78,II79
      INTEGER I56, II78, II79
      I56 = MIN0 (I17 + 32 - 1, R2 - 1) - I17 + 1
        STR(II16+I17:$I56) = TEMP
   17   END CDOALL
        IF (II80 .GT. 0) CTR = II16 + R2
C
D        call trace_exit (2114) 
D        call trace_enter (2115) 
        II17 = CTR
      I57 = (T + 31) / 32
      II81 = 32 * I57 - 32
      II82 = 32
      II83 = MAX0 ((II81 + II82) / II82, 0)
      CDOALL 18 I18=0,II81,II82
      INTEGER I58, II81, II82
      I58 = MIN0 (I18 + 32 - 1, T - 1) - I18 + 1
        STR(II17+I18:$I58) = 26
   18   END CDOALL
        IF (II83 .GT. 0) CTR = II17 + T
C
D        call trace_exit (2116) 
      TEMP=5+DIR
D        call trace_enter (2117) 
        II18 = CTR
      I59 = (R2 + 31) / 32
      II84 = 32 * I59 - 32
      II85 = 32
      II86 = MAX0 ((II84 + II85) / II85, 0)
      CDOALL 19 I19=0,II84,II85
      INTEGER I60, II84, II85
      I60 = MIN0 (I19 + 32 - 1, R2 - 1) - I19 + 1
        STR(II18+I19:$I60) = TEMP
   19   END CDOALL
        IF (II86 .GT. 0) CTR = II18 + R2
C
D        call trace_exit (2118) 
D        call trace_enter (2119) 
        II19 = CTR
      I61 = (T + 31) / 32
      II87 = 32 * I61 - 32
      II88 = 32
      II89 = MAX0 ((II87 + II88) / II88, 0)
      CDOALL 20 I20=0,II87,II88
      INTEGER I62, II87, II88
      I62 = MIN0 (I20 + 32 - 1, T - 1) - I20 + 1
        STR(II19+I20:$I62) = 30
   20   END CDOALL
        IF (II89 .GT. 0) CTR = II19 + T
C
D        call trace_exit (2120) 
      STR(CTR) = 14
      CTR=CTR+1
C
C  NOW GET OTHER LEG ... LOOP OVER TRANSVERSE DIRECTIONS
C   .... AND ALSO GO FORWARD AND (EVENTUALLY) BACK TO R3.
C
D        call trace_enter (2121) 
      DO 21 NTRANS=1,2
        ODIR = MOD((DIR + NTRANS),3)
        TEMP=1+ODIR
        II20 = CTR
          STR(II20:$R3) = TEMP
   22     CTR = II20 + R3
        TEMP=27+ODIR
        II21 = CTR
          STR(II21:$R3) = TEMP
   23     CTR = II21 + R3
        STR(CTR) = 14
        CTR = CTR + 1
C
        TEMP=23+ODIR
        II22 = CTR
          STR(II22:$R3) = TEMP
   24     CTR = II22 + R3
        IF(R3.NE.0) THEN
          STR(CTR) = 36
          CTR = CTR + 1
        ELSE
        II23 = CTR
            STR(II23:$T) = 4
   25       CTR = II23 + T
            II24 = CTR
            STR(II24:$T) = 30
   26       CTR = II24 + T
        ENDIF
        TEMP=27+ODIR
        II25 = CTR
          STR(II25:$R3) = TEMP
   27     CTR = II25 + R3
        STR(CTR) = 14
        CTR = CTR + 1
C
        TEMP=23+ODIR
        II26 = CTR
          STR(II26:$R3) = TEMP
   28     CTR = II26 + R3
          II27 = CTR
          STR(II27:$T) = 26
   29     CTR = II27 + T
        TEMP=5+ODIR
        II28 = CTR
          STR(II28:$R3) = TEMP
   30     CTR = II28 + R3
          II29 = CTR
          STR(II29:$T) = 30
   31     CTR = II29 + T
        STR(CTR) = 14
C
        CTR = CTR + 1
   21   CONTINUE
C
D        call trace_exit (2122) 
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
 
 
 
C
C   J. W. FLOWER & STEVE OTTO  SEPTEMBER 1984
C
C   MEASURES THREE QUARK OBSERVABLES USING UBARS.
C
C   CONVERTED FROM C TO FORTRAN BY KEN BARISH, CLIVE BAILLIE,
C   AND DAVID WALKER, 1987
C
      SUBROUTINE QQQMEA(R1,R2,R3,TT)
      INTEGER R1,R2,R3,TT
C
      INTEGER DIMS
      PARAMETER (DIMS=4)
      PARAMETER ( L1=12, L2=12, L3=12, L4=12 )
      PARAMETER ( MLEG=18*L1*L2*L3 )
      INTEGER LATT(DIMS),LATT1(DIMS),MOV(DIMS),ROT(DIMS),WHICH(13,13)
      REAL WLOOP(13,13),RES(13,13,6),BETA,LEGS(MLEG)
      COMMON /COMSYS/ BETA,WLOOP,RES,LEGS,LATT,LATT1,MOV,ROT,WHICH
C
      INTEGER NUMSTG
      COMMON /COMFIL/ NUMSTG
C
      INTEGER DIR,T
CMWB 6.22.88      CHARACTER*512 LPSTR
      INTEGER LPSTR(512)
      REAL TOT(2),VALS(2,15)
C
      VALS(1,TT) = 0.0
      VALS(2,TT) = 0.0
C
D        call trace_enter (2123) 
      DO 1 T=0,LATT(4)-1
        CALL LEGMAK(TT,T)
        TOT(1) = 0.0
        TOT(2) = 0.0
        DO 2 DIR=0,2
          CALL QQQLPS(R1,R2,R3,TT,DIR,LPSTR)
          CALL QQQLPC(R1,R2,R3,T,LPSTR,TOT)
    2     CONTINUE
        VALS(1,TT) = VALS(1,TT) + TOT(1)
        VALS(2,TT) = VALS(2,TT) + TOT(2)
    1   CONTINUE
C
D        call trace_exit (2124) 
      VALS(1,TT) = VALS(1,TT) / REAL(NUMSTG*3*2)
      VALS(2,TT) = VALS(2,TT) / REAL(NUMSTG*3*2)
      WRITE(6,*) 'Q (',R1,R2,R3,')','  X ',TT,' : ',
     *           VALS(1,TT),VALS(2,TT)
C
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
C   MAKE THE STRINGS USED TO MEASURE OFF-AXIS WILSON LOOPS.
C   STRING COMES IN THREE PARTS.
C    (i)  OUTWARD MOVES AND FAKE BACK
C    (ii) FETCH LEG AND FAKE BACK.
C    (iii GET TOP PART AND FAKE BACK.
C   BARS ALL T LINKS EXCEPT IF R1+R2=1.
C
C   CONVERTED FROM C TO FORTRAN BY KEN BARISH, CLIVE BAILLIE,
C   AND DAVID WALKER, 1987
C
      SUBROUTINE ROTLPS(PSTR,R1,R2,T,DIR1,DIR2)
      INTEGER PSTR(256)
      INTEGER R1,R2,T,DIR1,DIR2
C
      INTEGER R,DIR,CNT,TEMP
      INTEGER II1, II2, II3, II4, II5, II6, II7, II8, II9, II10, II11,
     X  II12, II13, II14, R3, I1, I2, I3, I4, I5, I6, I7, I8, I9, I10,
     X  I11, R4, I12, R5, R6, R7, R8, II17, I13, I14, I15, II20, I17,
     X  II23, I19
      INTEGER II26, I21, II29, I23, II32, I25, II35, I27, II38, I29,
     X  II41, I31, II44, I33, II47, I35, II50, R11, II53, I37, II56
C
C   GO OUT IN SPATIAL DIRECTION.
C
      NUM1=0
      NUM2=0
      CNT = 1
    1 CONTINUE
      IF((NUM1.LT.R1) .AND. (NUM2.LT.R2)) THEN
        TEMP=1+DIR2
        PSTR(CNT) = TEMP
        CNT=CNT+1
        NUM2=NUM2+1
        IF((NUM1+NUM2).LT.(R1+R2-1)) THEN
          TEMP=15+DIR1
        ELSE
          TEMP=1+DIR1
        ENDIF
        PSTR(CNT) = TEMP
        CNT=CNT+1
        NUM1=NUM1+1
        GOTO 1
      ENDIF
C
      IF(NUM1.LT.R1) THEN
        DIR=DIR1
      ELSE
        DIR=DIR2
      ENDIF
C
D        call trace_enter (2125) 
        II1 = CNT
      R5 = (R1 + R2 - (NUM1 + NUM2) + 31) / 32
      R8 = MAX0 (MIN0 (NUM1 + NUM2 + 31, R1 + R2 - 1) - (NUM1 + NUM2) +
     X  1, 1)
      II15 = 32 * R5 - 32
      II16 = 32
      II17 = MAX0 ((II15 + II16) / II16, 0)
      CDOALL 2 R3=0,II15,II16
      INTEGER TEMP1(R8)
      INTEGER R9, R10, II15, II16
      R10 = NUM1 + NUM2 + R3
      R9 = MIN0 (NUM1 + NUM2 + R3 + 32 - 1, (R1 + R2 - 1)) - (NUM1 +
     X  NUM2 + R3) + 1
      WHERE ((DIR .EQ. DIR1) .AND. ([R10 :$ R9] .LT. R1 + R2 - 1) .AND.
     X  ([R10 :$ R9] .GT. 0))
          TEMP1(1:$R9) = 15 + DIR
          OTHERWISE
          TEMP1(1:$R9) = 1 + DIR
          END WHERE
        PSTR(II1+(R10-(NUM1+NUM2)):$R9) = TEMP1(1:$R9)
    2   CONTINUE
        IF (II17 .GT. 0) CNT = II1 + (R1 + R2 - (NUM1 + NUM2))
C
C   NOW FAKE BACK... THIS PART IS EASY !
C
D        call trace_exit (2126) 
      TEMP=27+DIR1
D        call trace_enter (2127) 
        II2 = CNT
      I13 = (R1 + 31) / 32
      II18 = 32 * I13 - 32
      II19 = 32
      II20 = MAX0 ((II18 + II19) / II19, 0)
      CDOALL 3 I1=0,II18,II19
      INTEGER I16, II18, II19
      I16 = MIN0 (I1 + 32 - 1, R1 - 1) - I1 + 1
        PSTR(II2+I1:$I16) = TEMP
    3   END CDOALL
        IF (II20 .GT. 0) CNT = II2 + R1
D        call trace_exit (2128) 
      TEMP=27+DIR2
D        call trace_enter (2129) 
        II3 = CNT
      I17 = (R2 + 31) / 32
      II21 = 32 * I17 - 32
      II22 = 32
      II23 = MAX0 ((II21 + II22) / II22, 0)
      CDOALL 4 I2=0,II21,II22
      INTEGER I18, II21, II22
      I18 = MIN0 (I2 + 32 - 1, R2 - 1) - I2 + 1
        PSTR(II3+I2:$I18) = TEMP
    4   END CDOALL
        IF (II23 .GT. 0) CNT = II3 + R2
D        call trace_exit (2130) 
      PSTR(CNT) = 14
      CNT=CNT+1
C
C   NOW GO FETCH THE LEG. IF R1+R2 = 1 THEN WE HAVE TO DO
C   THE LEG ON THE FLY
C
      TEMP=23+DIR1
D        call trace_enter (2131) 
        II4 = CNT
      I19 = (R1 + 31) / 32
      II24 = 32 * I19 - 32
      II25 = 32
      II26 = MAX0 ((II24 + II25) / II25, 0)
      CDOALL 5 I3=0,II24,II25
      INTEGER I20, II24, II25
      I20 = MIN0 (I3 + 32 - 1, R1 - 1) - I3 + 1
        PSTR(II4+I3:$I20) = TEMP
    5   END CDOALL
        IF (II26 .GT. 0) CNT = II4 + R1
D        call trace_exit (2132) 
      TEMP=23+DIR2
D        call trace_enter (2133) 
        II5 = CNT
      I21 = (R2 + 31) / 32
      II27 = 32 * I21 - 32
      II28 = 32
      II29 = MAX0 ((II27 + II28) / II28, 0)
      CDOALL 6 I4=0,II27,II28
      INTEGER I22, II27, II28
      I22 = MIN0 (I4 + 32 - 1, R2 - 1) - I4 + 1
        PSTR(II5+I4:$I22) = TEMP
    6   END CDOALL
        IF (II29 .GT. 0) CNT = II5 + R2
D        call trace_exit (2134) 
      IF((R1+R2).NE.1) THEN
        PSTR(CNT) = 36
        CNT=CNT+1
      ELSE
D        call trace_enter (2135) 
        II6 = CNT
        I23 = (T + 31) / 32
        II30 = 32 * I23 - 32
        II31 = 32
        II32 = MAX0 ((II30 + II31) / II31, 0)
        CDOALL 7 I5=0,II30,II31
        INTEGER I24, II30, II31
        I24 = MIN0 (I5 + 32 - 1, T - 1) - I5 + 1
          PSTR(II6+I5:$I24) = 4
    7     END CDOALL
          IF (II32 .GT. 0) CNT = II6 + T
D        call trace_exit (2136) 
D        call trace_enter (2137) 
        II7 = CNT
        I25 = (T + 31) / 32
        II33 = 32 * I25 - 32
        II34 = 32
        II35 = MAX0 ((II33 + II34) / II34, 0)
        CDOALL 8 I6=0,II33,II34
        INTEGER I26, II33, II34
        I26 = MIN0 (I6 + 32 - 1, T - 1) - I6 + 1
          PSTR(II7+I6:$I26) = 30
    8     END CDOALL
          IF (II35 .GT. 0) CNT = II7 + T
D        call trace_exit (2138) 
      ENDIF
      TEMP=27+DIR1
D        call trace_enter (2139) 
        II8 = CNT
      I27 = (R1 + 31) / 32
      II36 = 32 * I27 - 32
      II37 = 32
      II38 = MAX0 ((II36 + II37) / II37, 0)
      CDOALL 9 I7=0,II36,II37
      INTEGER I28, II36, II37
      I28 = MIN0 (I7 + 32 - 1, R1 - 1) - I7 + 1
        PSTR(II8+I7:$I28) = TEMP
    9   END CDOALL
        IF (II38 .GT. 0) CNT = II8 + R1
D        call trace_exit (2140) 
      TEMP=27+DIR2
D        call trace_enter (2141) 
        II9 = CNT
      I29 = (R2 + 31) / 32
      II39 = 32 * I29 - 32
      II40 = 32
      II41 = MAX0 ((II39 + II40) / II40, 0)
      CDOALL 10 I8=0,II39,II40
      INTEGER I30, II39, II40
      I30 = MIN0 (I8 + 32 - 1, R2 - 1) - I8 + 1
        PSTR(II9+I8:$I30) = TEMP
   10   END CDOALL
        IF (II41 .GT. 0) CNT = II9 + R2
D        call trace_exit (2142) 
      PSTR(CNT) = 14
      CNT=CNT+1
C
C   NOW FETCH THE TOP PART OF THE LOOP.
C
      TEMP=23+DIR1
D        call trace_enter (2143) 
        II10 = CNT
      I31 = (R1 + 31) / 32
      II42 = 32 * I31 - 32
      II43 = 32
      II44 = MAX0 ((II42 + II43) / II43, 0)
      CDOALL 11 I9=0,II42,II43
      INTEGER I32, II42, II43
      I32 = MIN0 (I9 + 32 - 1, R1 - 1) - I9 + 1
        PSTR(II10+I9:$I32) = TEMP
   11   END CDOALL
        IF (II44 .GT. 0) CNT = II10 + R1
D        call trace_exit (2144) 
      TEMP=23+DIR2
D        call trace_enter (2145) 
        II11 = CNT
      I33 = (R2 + 31) / 32
      II45 = 32 * I33 - 32
      II46 = 32
      II47 = MAX0 ((II45 + II46) / II46, 0)
      CDOALL 12 I10=0,II45,II46
      INTEGER I34, II45, II46
      I34 = MIN0 (I10 + 32 - 1, R2 - 1) - I10 + 1
        PSTR(II11+I10:$I34) = TEMP
   12   END CDOALL
        IF (II47 .GT. 0) CNT = II11 + R2
D        call trace_exit (2146) 
D        call trace_enter (2147) 
        II12 = CNT
      I35 = (T + 31) / 32
      II48 = 32 * I35 - 32
      II49 = 32
      II50 = MAX0 ((II48 + II49) / II49, 0)
      CDOALL 13 I11=0,II48,II49
      INTEGER I36, II48, II49
      I36 = MIN0 (I11 + 32 - 1, T - 1) - I11 + 1
        PSTR(II12+I11:$I36) = 26
   13   END CDOALL
        IF (II50 .GT. 0) CNT = II12 + T
C
D        call trace_exit (2148) 
      NUM1=0
      NUM2=0
   14 CONTINUE
      IF((NUM1.LT.R1).AND.(NUM2.LT.R2)) THEN
        TEMP=5+DIR2
        PSTR(CNT) = TEMP
        CNT=CNT+1
        NUM2=NUM2+1
        IF((NUM1+NUM2).LT.(R1+R2-1)) THEN
          TEMP=19+DIR1
        ELSE
          TEMP=5+DIR1
        ENDIF
        PSTR(CNT) = TEMP
        CNT=CNT+1
        NUM1=NUM1+1
        GOTO 14
      ENDIF
C
      IF(NUM1.LT.R1) THEN
        DIR=DIR1
      ELSE
        DIR=DIR2
      ENDIF
D        call trace_enter (2149) 
        II13 = CNT
      R11 = (R1 + R2 - (NUM1 + NUM2) + 31) / 32
      R8 = MAX0 (MIN0 (NUM1 + NUM2 + 31, R1 + R2 - 1) - (NUM1 + NUM2) +
     X  1, 1)
      II51 = 32 * R11 - 32
      II52 = 32
      II53 = MAX0 ((II51 + II52) / II52, 0)
      CDOALL 15 R4=0,II51,II52
      INTEGER TEMP2(R8)
      INTEGER R12, R13, II51, II52
      R13 = NUM1 + NUM2 + R4
      R12 = MIN0 (NUM1 + NUM2 + R4 + 32 - 1, (R1 + R2 - 1)) - (NUM1 +
     X  NUM2 + R4) + 1
      WHERE ((DIR .EQ. DIR1) .AND. ([R13 :$ R12] .LT. (R1 + R2 - 1))
     X   .AND. ([R13 :$ R12] .GT. 0))
          TEMP2(1:$R12) = 19 + DIR
          OTHERWISE
          TEMP2(1:$R12) = 5 + DIR
          END WHERE
        PSTR(II13+(R13-(NUM1+NUM2)):$R12) = TEMP2(1:$R12)
   15   END CDOALL
        IF (II53 .GT. 0) CNT = II13 + (R1 + R2 - (NUM1 + NUM2))
C
D        call trace_exit (2150) 
D        call trace_enter (2151) 
        II14 = CNT
      I37 = (T + 31) / 32
      II54 = 32 * I37 - 32
      II55 = 32
      II56 = MAX0 ((II54 + II55) / II55, 0)
      CDOALL 16 I12=0,II54,II55
      INTEGER I38, II54, II55
      I38 = MIN0 (I12 + 32 - 1, T - 1) - I12 + 1
        PSTR(II14+I12:$I38) = 30
   16   END CDOALL
        IF (II56 .GT. 0) CNT = II14 + T
C
D        call trace_exit (2152) 
      PSTR(CNT) = 14
C
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
 
 
 
C
C   J. W. FLOWER  OCT 1985
C
C   THIS CODE MEASURES THE OFF AXIS WILSON LOOPS.
C
C   CONVERTED FROM C TO FORTRAN BY KEN BARISH, CLIVE BAILLIE,
C   AND DAVID WALKER, 1987
C
      SUBROUTINE ROTMEA(DIR,NUMHIT,R1MAX,R2MAX)
      INTEGER DIR,NUMHIT,R1MAX,R2MAX
C
      INTEGER DIMS
      PARAMETER (DIMS=4)
      PARAMETER ( L1=12, L2=12, L3=12, L4=12 )
      PARAMETER ( MLEG=18*L1*L2*L3 )
      PARAMETER ( MBAR=18*L1*L2*L3*L4 )
      INTEGER LATT(DIMS),LATT1(DIMS),MOV(DIMS),ROT(DIMS),WHICH(13,13)
      REAL WLOOP(13,13),RES(13,13,6),BETA,LEGS(MLEG)
      COMMON /COMSYS/ BETA,WLOOP,RES,LEGS,LATT,LATT1,MOV,ROT,WHICH
C
      REAL UBAR(MBAR),SBAR(MBAR)
      COMMON /COMUBR/ UBAR,SBAR
C
      INTEGER TMAX,T,PLEGS,CNT
      INTEGER COORD(4),NCHAR,TFLAG,SITE,TMP
      REAL BOT(18),TOP(18),UP(18),DOWN(18),STEMP(18,2)
      REAL TEMP
      INTEGER PSTR(256),LPSTR(256)
C
      CALL LINKBR(NUMHIT,DIR,SBAR)
C
D        call trace_enter (2153) 
      DO 2 ICORD4=0,LATT(4)-1
        COORD(4) = ICORD4
        DO 2 T=1,12
          TFLAG=0
          DO 3 I=1,R1MAX
            CDOACROSS 3 J=1,R2MAX
            INTEGER TMAX
              IF(WHICH(I,J).NE.0) THEN
                IF ((WHICH(I,J) .LE. T) .AND. (T .LE. MIN (12, WHICH(I,J
     X            ) + 5))) THEN
                CALL AWAIT (1, 1)
                TFLAG = 1
                END IF
              ENDIF
              CALL ADVANCE (1, TFLAG)
    3         CONTINUE
          IF (TFLAG .EQ. 1) THEN
          CALL LEGMAK(T,ICORD4)
C
C    NOW LOOP THROUGH THE REQUIRED LOOPS.
C
          DO 4 I=1,R1MAX
            DO 4 J=1,R2MAX
              IF(WHICH(I,J).NE.0) THEN
                WLOOP(I,J) = 0.
                TMAX = MIN(12,WHICH(I,J)+5)
                IF((T.GE.WHICH(I,J)).AND.(T.LE.TMAX)) THEN
                  CALL ROTLPS(LPSTR,I,J,T,DIR,MOD((DIR+1),3))
                  SITE = COORD(4)*MOV(4)
                  PLEGS=1
                  DO 5 ICORD3=0,LATT(3)-1
                    COORD(3) = ICORD3
                    DO 5 ICORD2=0,LATT(2)-1
                      COORD(2) = ICORD2
                      DO 5 ICORD1=0,LATT(1)-1
                        COORD(1) = ICORD1
                        CALL UDAG(LEGS(PLEGS),DOWN)
C                        CALL CPYMAT(PSTR,LPSTR,256) LPOINTER 4-3-89
                        CALL ICPYMT(PSTR,LPSTR,256)
                        CNT=1
                        CALL SYSLOP(COORD,SITE,PSTR(CNT),BOT,NCHAR)
                        CNT=CNT+NCHAR
                        CALL SYSLOP(COORD,SITE,PSTR(CNT),UP,NCHAR)
                        CNT=CNT+NCHAR
                        CALL SYSLOP(COORD,SITE,PSTR(CNT),TOP,NCHAR)
                        CALL MULT(BOT,UP,STEMP(1,1))
                        CALL MULT(STEMP(1,1),TOP,STEMP(1,2))
                        CALL MULT(STEMP(1,2),DOWN,STEMP(1,1))
                        WLOOP(I,J)=WLOOP(I,J)+(STEMP(1,1)+STEMP(9,1)
     .                             +STEMP(17,1))/3.0
                        PLEGS=PLEGS+18
                        SITE = SITE + MOV(1)
    5                   CONTINUE
                  ENDIF
                ENDIF
    4           CONTINUE
              CDOALL 6 J=1,R2MAX
              REAL TEMP1(R1MAX)
              INTEGER TMP
C
              WHERE (WHICH(1:$R1MAX,J) .NE. 0)
                  TEMP1(1:$R1MAX) = WLOOP(1:$R1MAX,J)
                  RES([1:$R1MAX]+(13*J+169*(T-WHICH(1:$R1MAX,J)))-13,1,1
     X              ) = RES([1:$R1MAX]+(13*J+169*(T-WHICH(1:$R1MAX,J)))-
     X              13,1,1) + TEMP1(1:$R1MAX)
                  END WHERE
    6           CONTINUE
                END IF
    2     CONTINUE
C
D        call trace_exit (2154) 
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
      SUBROUTINE SETCOL(LATT)
      INTEGER LATT(4)
C
      PARAMETER ( L1=12, L2=12, L3=12, L4=12 )
      PARAMETER ( LISMAX=(L1*L2*L3*L4)/2+1 )
      COMMON /COLCOM/ LISRED(LISMAX),LISBLK(LISMAX),NRED,NBLACK
C
      NRED   = 0
      NBLACK = 0
      IPTR   = 0
      INDEX4 = 0
D        call trace_enter (2155) 
      DO 4 I=1,LATT(4)
         INDEX3 = INDEX4
         DO 3 J=1,LATT(3)
            INDEX2 = INDEX3
            DO 2 K=1,LATT(2)
               INDEX1 = INDEX2
               DO 1 L=1,LATT(1)
                  IF (INDEX1 .EQ. 0) THEN
      NRED = NRED + 1
      LISRED(NRED) = IPTR
                  ELSE
      NBLACK = NBLACK + 1
      LISBLK(NBLACK) = IPTR
                  ENDIF
                  IPTR   = IPTR+72
    1             INDEX1 = 1 - INDEX1
    2          INDEX2 = 1 - INDEX2
    3       INDEX3 = 1 - INDEX3
    4    INDEX4 = 1 - INDEX4
C
D        call trace_exit (2156) 
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
C
C   STEVE OTTO AND JON FLOWER   JULY 1984.
C
C   RECEIVES  PARAMETER INPUT FOR THE SU3 ROUTINES.
C
C   CONVERTED FROM C TO FORTRAN BY KEN BARISH, CLIVE BAILLIE,
C   AND DAVID WALKER, 1987
C
      SUBROUTINE SETPAR
C
      INTEGER DIMS
      PARAMETER (DIMS=4)
      PARAMETER ( L1=12, L2=12, L3=12, L4=12 )
      PARAMETER ( MLEG=18*L1*L2*L3 )
      INTEGER UMAX
      PARAMETER ( UMAX=72*L1*L2*L3*L4 )
      INTEGER LATT(DIMS),LATT1(DIMS),MOV(DIMS),ROT(DIMS),WHICH(13,13)
      REAL WLOOP(13,13),RES(13,13,6),BETA,LEGS(MLEG)
      COMMON /COMSYS/ BETA,WLOOP,RES,LEGS,LATT,LATT1,MOV,ROT,WHICH
C
      INTEGER NUMSTG
      COMMON /COMFIL/ NUMSTG
C
    1 WRITE(6,*) 'ENTER X,Y,Z,T LATTICE SIZE ?'
      READ (5,*) LATT
      WRITE(6,*) LATT
      NUM = LATT(1)*LATT(2)*LATT(3)*LATT(4)
C
      IF(NUM*72.GT.UMAX) THEN
        WRITE(6,*) 'NOT ENOUGH ROOM FOR GAUGE FIELD'
        WRITE(6,*) '*******************************'
        WRITE(6,*) 'TRY AGAIN'
        GOTO 1
      ENDIF
C
      NUMSIT = LATT(1)*LATT(2)*LATT(3)*LATT(4)
      NUMSTG = LATT(1)*LATT(2)*LATT(3)*LATT(4)
      WRITE(6,*) 'ENTER VALUE OF BETA '
      READ (5,*) BETA
      WRITE(6,*) BETA
C
      CALL MAKE()
C
      CALL SETCOL(LATT)
C
      WRITE(6,*) 'PARAMETERS NOW SET.'
      WRITE(6,*) 'NOW NEED TO INITIALIZE..........'
C
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
      SUBROUTINE SETSED()
C
      INTEGER SEED,MODE
C
      WRITE(6,*) 'SELECT MODE OF SEED SETTING: '
      WRITE(6,*) '0  <->  BY HAND'
      WRITE(6,*) '1  <->  READ IN FROM STANDARD FILE, SEED'
      READ (5,*) MODE
      IF( MODE.EQ.0) THEN
        WRITE(6,*) 'INPUT SEED'
        READ (5,*) SEED
        CALL PRNSET(SEED)
      ELSE
        OPEN(UNIT=1,FILE='SEED',ACCESS='SEQUENTIAL',STATUS='UNKNOWN')
        REWIND(1)
        READ(1,10) SEED
   10   FORMAT(I12)
        CALL PRNSET(SEED)
        CLOSE(1)
      ENDIF
      WRITE(6,*) 'SEED SET'
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
C
CCCCCCCCCCCCCCCCCCCCCCCCC END OF ROUTINE SETSED CCCCCCCCCCCCCCCCCCCC
C
 
 
 
 
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C          THIS SOFTWARE COPYRIGHTED BY CALTECH, 1983, 1986, 1987     C
C                                                                     C
C          PURE GAUGE SU(3) MONTE CARLO                               C
C                                                                     C
C          THIS CODE HAS A LONG HISTORY:                              C
C              EARLY VERSIONS OF THIS DEVELOPED FOR THE MARK I        C
C              HYPERCUBE BY STEVE OTTO AND PAUL STOLORZ (1981-83)     C
C              JON FLOWER AND STEVE OTTO EXTENDED AND IMPROVED THE    C
C              CODE FOR THE MARK II MACHINES. (1984-86)               C
C              THE CURRENT INCARNATION IS A "PORT" TO THE NCUBE       C
C              DONE BY CLIVE BAILLIE, ED FELTEN, STEVE OTTO,          C
C              AND DAVID WALKER  (1987)                               C
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C       SYSLOP SYSTEMATICALLY CALCULATES WILSON LOOPS
C       FOR SU3 THEORY IN 3+1 DIM WITH THE INT STRINGS
C       AS INPUT, ALSO KEEPS TRACK OF THE LENGTH OF THE STRING.
C
C       CODING OF LATTICE PATHS:
C                1, 2, 3, 4 +X,+Y,+Z,+T
C                5, 6, 7, 8 -X,-Y,-Z,-T
C               15,16,17,18  X,+Y,+Z,+T USING BARS.
C               19,20,21,22 -X,-Y,-Z,-T USING BARS.
C               23,24,25,26 +X,+Y,+Z,+T FAKE STEPS
C               27,28,29,30 -X,-Y,-Z,-T FAKE STEPS
C               36          RETURNS LEG
C
C       CONVERTED FROM C TO FORTRAN BY KEN BARISH, CLIVE BAILLIE,
C       AND DAVID WALKER, 1987
C
      SUBROUTINE SYSLOP(COORD,SITE,PTR,PLOOP,NN)
      INTEGER COORD(4),NN,SITE,SITES
      INTEGER PTR(*)
      REAL PLOOP(18)
C
      INTEGER DIMS
      PARAMETER (DIMS=4)
      PARAMETER ( L1=12, L2=12, L3=12, L4=12 )
      PARAMETER ( MLEG=18*L1*L2*L3 )
      INTEGER UMAX
      PARAMETER ( UMAX=72*L1*L2*L3*L4 )
      PARAMETER ( MBAR=18*L1*L2*L3*L4 )
      INTEGER LATT(DIMS),LATT1(DIMS),MOV(DIMS),ROT(DIMS),WHICH(13,13)
      REAL WLOOP(13,13),RES(13,13,6),BETA,LEGS(MLEG)
      COMMON /COMSYS/ BETA,WLOOP,RES,LEGS,LATT,LATT1,MOV,ROT,WHICH
C
      REAL U1(UMAX)
      COMMON /COMU1/ U1
C
      REAL UBAR(MBAR),SBAR(MBAR)
      COMMON /COMUBR/ UBAR,SBAR
C
      REAL FTEMP(18,2),FILMAT(18),EXTRA(18)
      INTEGER PU,PBAR
      INTEGER PLEGS,TINDEX,SETFLG
      INTEGER I1, J1, I2, I3, I4, J2, J3
C
      SITES  = SITE
      INDEX  = 0
      SETFLG = 0
      NN     = 0
C
    1 NN = NN+1
      IC = PTR(NN)
      IF (IC .NE. 14) THEN
C
      IF(IC.LE.4) THEN
        IND = IC
        PU  = SITES+ROT(IND)
        IF(SETFLG.EQ.0) THEN
          CALL CPYMAT(FTEMP(1,INDEX+1),U1(PU+1),18)
          SETFLG = 1
        ELSE
          CALL CPYMAT(FILMAT,U1(PU+1),18)
          TINDEX = 1-INDEX
          CALL MULT(FTEMP(1,INDEX+1),FILMAT,FTEMP(1,TINDEX+1))
          INDEX  = TINDEX
        ENDIF
        COORD(IND) = MOD( COORD(IND)+1, LATT1(IND)+1 )
        IF(COORD(IND).EQ.0) THEN
          SITES = SITES-MOV(IND)*LATT1(IND)
        ELSE
          SITES = SITES+MOV(IND)
        ENDIF
C
      ELSEIF(IC.LE.8) THEN
        IND = IC - 4
        IF(COORD(IND).EQ.0) THEN
          COORD(IND) = LATT1(IND)
          SITES = SITES+MOV(IND)*LATT1(IND)
        ELSE
          COORD(IND) = COORD(IND)-1
          SITES = SITES-MOV(IND)
        ENDIF
        PU = SITES+ROT(IND)
        IF(SETFLG.EQ.0) THEN
          CALL CPYMAT(FILMAT,U1(PU+1),18)
          CALL UDAG(FILMAT,FTEMP(1,INDEX+1))
          SETFLG = 1
        ELSE
          CALL CPYMAT(EXTRA,U1(PU+1),18)
          CALL UDAG(EXTRA,FILMAT)
          TINDEX = 1-INDEX
          CALL MULT(FTEMP(1,INDEX+1),FILMAT,FTEMP(1,TINDEX+1))
          INDEX  = TINDEX
        ENDIF
C
      ELSEIF(IC.EQ.36) THEN
        LSITE = SITES - COORD(4)*MOV(4)
        PLEGS = (LSITE/72)*18
D        call trace_enter (2157) 
        CDOALL 4 I1=0,0,32
        INTEGER I5, I6
        I6 = I1 + 1
        I5 = MIN0 (I1 + 1 + 32 - 1, 18) - I1
    4     FTEMP(I6:$I5,INDEX+1) = LEGS(PLEGS+I6:$I5)
D        call trace_exit (2158) 
        SETFLG = 1
C
      ELSEIF(IC.LE.18) THEN
        IND = IC - 14
        PBAR = (SITES/72)*18
        IF(IND.EQ.4) THEN
          CALL CPYMAT(FILMAT,UBAR(PBAR+1),18)
        ELSE
          CALL CPYMAT(FILMAT,SBAR(PBAR+1),18)
        ENDIF
        IF(SETFLG.EQ.0) THEN
D        call trace_enter (2159) 
          CDOALL 3 J1=0,0,32
          INTEGER J4, J5
          J5 = J1 + 1
          J4 = MIN0 (J1 + 1 + 32 - 1, 18) - J1
    3       FTEMP(J5:$J4,INDEX+1) = FILMAT(J5:$J4)
D        call trace_exit (2160) 
          SETFLG = 1
        ELSE
          TINDEX = 1-INDEX
          CALL MULT(FTEMP(1,INDEX+1),FILMAT,FTEMP(1,TINDEX+1))
          INDEX  = TINDEX
        ENDIF
        COORD(IND) = MOD( COORD(IND)+1, LATT1(IND)+1 )
        IF(COORD(IND).EQ.0) THEN
          SITES = SITES-MOV(IND)*LATT1(IND)
        ELSE
          SITES = SITES+MOV(IND)
        ENDIF
C
      ELSEIF(IC.LE.22) THEN
        IND = IC - 18
        IF(COORD(IND).EQ.0) THEN
          COORD(IND) = LATT1(IND)
          SITES = SITES+ MOV(IND)*LATT1(IND)
        ELSE
          COORD(IND) = COORD(IND)-1
          SITES = SITES-MOV(IND)
        ENDIF
        PBAR = (SITES/72)*18
        IF(IND.EQ.4) THEN
          CALL CPYMAT(EXTRA,UBAR(PBAR+1),18)
        ELSE
          CALL CPYMAT(EXTRA,SBAR(PBAR+1),18)
        ENDIF
        IF(SETFLG.EQ.0) THEN
          CALL UDAG(EXTRA,FTEMP(1,INDEX+1))
          SETFLG = 1
        ELSE
          CALL UDAG(EXTRA,FILMAT)
          TINDEX = 1-INDEX
          CALL MULT(FTEMP(1,INDEX+1),FILMAT,FTEMP(1,TINDEX+1))
          INDEX  = TINDEX
        ENDIF
C
      ELSEIF(IC.LE.26) THEN
        IND = IC - 22
        COORD(IND) = MOD( COORD(IND)+1, LATT1(IND)+1 )
        IF(COORD(IND).EQ.0) THEN
          SITES = SITES-MOV(IND)*LATT1(IND)
        ELSE
          SITES = SITES+MOV(IND)
        ENDIF
C
      ELSEIF(IC.LE.30) THEN
        IND = IC - 26
        IF(COORD(IND).EQ.0) THEN
          COORD(IND) = LATT1(IND)
          SITES = SITES+MOV(IND)*LATT1(IND)
        ELSE
          COORD(IND) = COORD(IND)-1
          SITES = SITES-MOV(IND)
        ENDIF
C
      ENDIF
      GOTO 1
      END IF
C
    2 CONTINUE
C
D        call trace_enter (2161) 
      CDOALL 5 I2=0,0,32
      INTEGER I7, I8
      I8 = I2 + 1
      I7 = MIN0 (I2 + 1 + 32 - 1, 18) - I2
    5   PLOOP(I8:$I7) = FTEMP(I8:$I7,INDEX+1)
C
D        call trace_exit (2162) 
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
C
C   UDAG EVALUATES THE COMPLEX CONJUGATE OF THE INPUT 3x3 MATRIX
C
      SUBROUTINE UDAG(PIN,POUT)
      REAL PIN(18),POUT(18)
C
      POUT(1)  =  PIN(1)
      POUT(7)  =  PIN(3)
      POUT(13) =  PIN(5)
      POUT(2)  = -PIN(2)
      POUT(8)  = -PIN(4)
      POUT(14) = -PIN(6)
      POUT(3)  =  PIN(7)
      POUT(9)  =  PIN(9)
      POUT(15) =  PIN(11)
      POUT(4)  = -PIN(8)
      POUT(10) = -PIN(10)
      POUT(16) = -PIN(12)
      POUT(5)  =  PIN(13)
      POUT(11) =  PIN(15)
      POUT(17) =  PIN(17)
      POUT(6)  = -PIN(14)
      POUT(12) = -PIN(16)
      POUT(18) = -PIN(18)
C
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 14 Jun 1991)  o3,r1,d3  8 Apr 1992 16:27:13
 
 
 
C
C     J. W. FLOWER AND STEVE OTTO   JULY 1984.
C
C     UPDATES THE LATICE "SWEEPS" TIMES WITH PROJECTIONS EVERY "PINVAL"
C
C     CONVERRTED FROM C TO FORTRAN BY KEN BARISH, CLIVE BAILLIE,
C     AND DAVID WALKER, 1987
C
      SUBROUTINE UPDATE(SWEEPS,PINVAL)
      INTEGER SWEEPS,PINVAL
C
      INTEGER DIMS
      PARAMETER (DIMS=4)
      PARAMETER ( L1=12, L2=12, L3=12, L4=12 )
      PARAMETER ( MLEG=18*L1*L2*L3 )
      INTEGER UMAX
      PARAMETER ( UMAX=72*L1*L2*L3*L4 )
      INTEGER LATT(DIMS),LATT1(DIMS),MOV(DIMS),ROT(DIMS),WHICH(13,13)
      REAL WLOOP(13,13),RES(13,13,6),BETA,LEGS(MLEG)
      COMMON /COMSYS/ BETA,WLOOP,RES,LEGS,LATT,LATT1,MOV,ROT,WHICH
      PARAMETER ( LISMAX=(L1*L2*L3*L4)/2+1 )
      COMMON /COLCOM/ LISRED(LISMAX),LISBLK(LISMAX),NRED,NBLACK
C
C
      REAL U1(UMAX)
      COMMON /COMU1/ U1
C
      INTEGER COORD(4),DIR,ORIGIN
C
D        call trace_enter (2163) 
      DO 1000 LOOP=0,SWEEPS-1
C
C  FIRST DO RED POINTS
C
        DO 1 I=1,NRED
           ORIGIN = LISRED(I)
           INDEX  = ORIGIN/72
           CALL GETPOS(LATT,COORD,INDEX)
           DO 10 DIR=0,3
              CALL HIT(COORD,ORIGIN,DIR)
   10         CONTINUE
    1      CONTINUE
C
C  NOW DO BLACK POINTS
C
        DO 2 I=1,NBLACK
           ORIGIN = LISBLK(I)
           INDEX  = ORIGIN/72
           CALL GETPOS(LATT,COORD,INDEX)
           DO 20 DIR=0,3
              CALL HIT(COORD,ORIGIN,DIR)
   20         CONTINUE
    2      CONTINUE
C
        IF(MOD(LOOP,PINVAL).EQ.(PINVAL-1)) CALL PROJEC()
 1000   CONTINUE
C
D        call trace_exit (2164) 
      RETURN
      END
