C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:04:23
C
      SUBROUTINE ACAC(AC,EX,WORK)
C
C COMPLEX ANTISYMMETRIC TO COMPLEX ANTISYMMETRIC
C
      COMMON /FT/NPTS, NSKIP, MTRN, MSKIP, ISIGN, LOG, IEXSHF
      COMMON /DATA/ALPHA, BETA, BOXX, H, RNU, RKAPA, DT, DTT, T
     X  , NSTEPS
      COMMON /OPTONS/N1, N2, NUMBER, KDATA, LMAPP, NOTEMP, KTA,
     X     KTAPE, KSM, KPP, KZP, KTP, KUP, KVP, KPF, KZF, KTF, KUF, KVF
     X     , KPRESS, NOALS
      COMMON /TIMING/TXXXIN, TXXOUT, TXXRCS, TXXCSR, TXSCSC,
     X  TXACAC, TFTVMT, TXSHUF, TUSHUF, TXPRNT, TXLOG2, EXXRCS, EXXCSR,
     X  EXSCSC, EXACAC, EFTVMT, NXXXIN, NXXOUT, NXXRCS, NXXCSR, NXSCSC,
     X  NXACAC, NFTVMT, NXSHUF, NUSHUF, NXPRNT, NXLOG2
      COMPLEX AC(1),WORK(1),TEMP1,TEMP2,X,Y,BJ,BJSYM
      DIMENSION EX(1)
      integer div, NSKIPlt, MSKIPlt, gcd
C
      LOGICAL   LFIRST,LXSTEP,LXTIME
      DATA      LFIRST,LXSTEP,LXTIME /.TRUE.,.FALSE.,.TRUE./
C
      IF (NSTEPS.EQ.NUMBER) LXSTEP = .TRUE.
      IF (LFIRST) CALL CPUTIM (T1)
      IF (LXSTEP) THEN
        IF (LXTIME) CALL CPUTIM (T1)
      END IF
C
      M=NPTS/2
      NPTS=M
      MH=M/2
      MHP=MH+1
      ISTOP=1+(MTRN-1)*MSKIP
      MNSKIP=M*NSKIP
      LOG=LOG-1
      NSKIP2=NSKIP*2
      MP2=M+2
      IEXSHF=IEXSHF*2
      FACT=REAL(ISIGN)/2.
      MNSH=MNSKIP/2
      IPROD=MNSH
      div = gcd(MSKIP, NSKIP)
      MSKIPlt = MSKIP/div
      NSKIPlt = NSKIP/div
      if ((MSKIPlt .GT. 0) .and.
     #    (MSKIPlt .LT. M) .and.
     #    (NSKIPlt .GT. 0) .and.
     #    (NSKIPlt .LT. MTRN)) then

C---Serial version of 30

D        call trace_enter (2001) 
      DO 30 LOOP=1,ISTOP,MSKIP
         ISUM=LOOP+MNSKIP
         IAC=LOOP+NSKIP
         WORK(1)=CMPLX(0.,2.)*AC(IAC)
         DO 10 I=2,MH
            IAC=IAC+NSKIP2
            TEMP1=CMPLX(0.,1.)*(AC(IAC)-AC(IAC-NSKIP2))
            TEMP2=AC(IAC-NSKIP)
            WORK(I)=TEMP2+TEMP1
            WORK(MP2-I)=TEMP1-TEMP2
   10    CONTINUE
         WORK(MHP)=CMPLX(0.,-2.)*AC(IAC)
         IAC=LOOP
         DO 20 I=1,M
            AC(IAC)=WORK(I)
            IAC=IAC+NSKIP
   20    CONTINUE
   30 CONTINUE
D        call trace_exit (2002) 
      CALL FTRVMT(AC,EX)
D        call trace_enter (2003) 
      DO 40 LOOP=1,ISTOP,MSKIP
         ISUM=LOOP+MNSKIP
         JSUM=ISUM+LOOP
         AC(LOOP)=0.
         ISTART=LOOP+NSKIP
         IFIN=LOOP+IPROD
         I=2
         DO 35 J=ISTART,IFIN,NSKIP
            I=I+IEXSHF
            JSYM=JSUM-J
            BJ=AC(J)
            BJSYM=AC(JSYM)
            TEMP1=BJ-BJSYM
            TEMP2=CMPLX(FACT/EX(I),0.)*(BJ+BJSYM)
            AC(J)=TEMP1+TEMP2
            AC(JSYM)=TEMP2-TEMP1
   35    CONTINUE
   40 CONTINUE
D        call trace_exit (2004) 
      else

C---Parallel version of 30

D        call trace_enter (2005) 
      CDOALL 930 LOOP=1,ISTOP,MSKIP
         integer IAC, I
         complex TEMP1(2:MH), TEMP2(2:MH), LWORK(M)
         IAC=LOOP+NSKIP
         LWORK(1)=CMPLX(0.,2.)*AC(IAC)
            IAC=IAC+NSKIP2
            TEMP1=CMPLX(0.,1.)*(AC(IAC:$(MH-1):NSKIP2)-
     *                          AC((IAC-NSKIP2):$(MH-1):NSKIP2))
            TEMP2=AC((IAC-NSKIP):$(MH-1):NSKIP2)
            LWORK(2:MH)=TEMP2+TEMP1
            LWORK((MP2-2):(MP2-MH):-1)=TEMP1-TEMP2
  910    CONTINUE
         LWORK(MHP)=CMPLX(0.,-2.)*AC(IAC+(MH-2)*NSKIP2)
            AC(LOOP:$M:NSKIP)=LWORK(1:M)
  920    CONTINUE
         if (LOOP .eq. ISTOP) then
                WORK(1:M) = LWORK(1:M)
         endif
  930 CONTINUE
D        call trace_exit (2006) 
      CALL FTRVMT(AC,EX)
D        call trace_enter (2007) 
      CDOALL 940 LOOP=1,ISTOP,MSKIP
         integer ISUM, JSUM, JSYM, ISTART, IFIN, I, J
         complex TEMP1, TEMP2, BJ, BJSYM
         ISUM=LOOP+MNSKIP
         JSUM=ISUM+LOOP
         AC(LOOP)=0.
         ISTART=LOOP+NSKIP
         IFIN=LOOP+IPROD
         I=2
         DO 935 J=ISTART,IFIN,NSKIP
            I=I+IEXSHF
            JSYM=JSUM-J
            BJ=AC(J)
            BJSYM=AC(JSYM)
            TEMP1=BJ-BJSYM
            TEMP2=CMPLX(FACT/EX(I),0.)*(BJ+BJSYM)
            AC(J)=TEMP1+TEMP2
            AC(JSYM)=TEMP2-TEMP1
  935    CONTINUE
  940 CONTINUE
D        call trace_exit (2008) 
      endif

      NPTS=M*2
      LOG=LOG+1
      IEXSHF=IEXSHF/2
C
      IF (LFIRST) THEN
        LFIRST = .FALSE.
        CALL CPUTIM (T2)
        TXACAC = T2-T1
      END IF
C
      IF (LXSTEP) THEN
        IF (LXTIME) THEN
          LXTIME = .FALSE.
          CALL CPUTIM (T2)
          EXACAC = T2-T1
        END IF
      END IF
C
      NXACAC = NXACAC+1
C
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:05:10
      BLOCK DATA
      COMMON /TIMING/TXXXIN, TXXOUT, TXXRCS, TXXCSR, TXSCSC,
     X  TXACAC, TFTVMT, TXSHUF, TUSHUF, TXPRNT, TXLOG2, EXXRCS, EXXCSR,
     X  EXSCSC, EXACAC, EFTVMT, NXXXIN, NXXOUT, NXXRCS, NXXCSR, NXSCSC,
     X  NXACAC, NFTVMT, NXSHUF, NUSHUF, NXPRNT, NXLOG2
      COMMON /VERIFY/VDAT(15), CDAT(15)
      COMMON /PI/PI
      COMMON /DEBUG/NUMBER, TLAST
C
      DATA            TXXXIN,TXXOUT,TXXRCS,TXXCSR,TXSCSC,TXACAC,TFTVMT
     1              /     0.,    0.,    0.,    0.,    0.,    0.,    0./
      DATA            TXSHUF,TUSHUF,TXPRNT,TXLOG2
     1              /     0.,    0.,    0.,    0./
      DATA            EXXRCS,EXXCSR,EXSCSC,EXACAC,EFTVMT
     1              /     0.,    0.,    0.,    0.,    0./
      DATA            NXXXIN,NXXOUT,NXXRCS,NXXCSR,NXSCSC,NXACAC,NFTVMT
     1              /     0 ,    0 ,    0 ,    0 ,    0 ,    0 ,    0 /
      DATA            NXSHUF,NUSHUF,NXPRNT,NXLOG2
     1              /     0 ,    0 ,    0 ,    0 /
      DATA VDAT/
     * 0.10000E+03,-0.10000E+03, 0.10000E-04,-0.10000E+03,-0.15708E+01,
     * 0.99983E+02,-0.18147E+01,-0.20427E+01,-0.22452E+01,-0.24181E+01,
     * 0.95976E+02,-0.95977E+02, 0.10000E-04,-0.95978E+02,-0.25589E+01/
C
C PI IS A USEFULL CONSTANT
C
      DATA  PI /3.141592653589793/
      DATA NUMBER /1/, TLAST /0.0/
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:05:33
C***********************************************************************
C2%2      SUBROUTINE EIGIN
C2%2C
C2%2C
C2%2C THESE SUBROUTINES WILL TAKE CARE OF THE HISTORY TAPE.
C2%2C SINCE THEY ARE NOT WRITEN YET, ONLY AN ERROR MESAGE IS PRINTED.
C2%2C
C2%2C
C2%2      ENTRY EIGOUT
C2%2      ENTRY DATAIN
C2%2      ENTRY DATAOUT
C2%2      WRITE(6,100)
C2%2100   FORMAT(' SUBROUTINES WHICH HANDLE THE TAPE DO NOT YET EXIST.',
C2%2     1       ' THIS IS AN ERROR EXIT, PLEASE CHECK OPTIONS SPECIFIED
C2%2     2       ' IN SUBROUTINE START.')
C2%2      STOP
C2%2      END
C***********************************************************************
C2%2      SUBROUTINE PRESSET (CA,G,GMAPP,CWORK,EX,EVAL,IR,IC,E,N2M,LPRES
C2%2      COMMON /SOLV/ LVECT, LSKIP, NVECT, NVSKIP
C2%2      COMMON /FT/ NPTS, NSKIP, MTRN, MSKIP, ISIGN, LOG, IEXSHF
C2%2      COMMON /EXSIZE/ NMAX2
C2%2      COMMON /PI/ PI
C2%2      COMMON /DATA/ SKIP(3), H, RDUMY1(5), IDUMY1
C2%2      COMMON /LADDR/ LDUMMY(8), LEIG, LE, LH, LEV
C2%2      DIMENSION INDIC(127)
C2%2      DIMENSION G(1), GMAPP(1), EVAL(1)
C2%2      DIMENSION IR(1), IC(1), E(N2M,1)
C2%2      COMPLEX CA(1), EX(1), CWORK(1)
C2%2C
C2%2C PREPARE THE MATRIX TO COMPUTE EIGENVALUES AND EIGENVECTORS
C2%2C USING THE MAPPING FUNCTION. MAPPING FUNCTION IS STORED IN GMAPP
C2%2C AND IT GOES FROM 0. TO H
C2%2C VECTOR G CONTAINS ITS DERIVATIVE UPON THE RETURN FROM EIGSET
C2%2C
C2%2      N2 = N2M+1
C2%2      N2P = N2+1
C2%2      H = GMAPP(N2P)
C2%2      F = H/REAL(N2)
C2%2      DO 10 I = 1,N2P
C2%2           G(I) = GMAPP(I)-F*REAL(I-1)
C2%210         CA(I) = CMPLX (G(I), 0.)
C2%2      CA(1) = 0.
C2%2      CA(N2P) = 0.
C2%2      NPTS = 2*(N2P-1)
C2%2      NSKIP = 1
C2%2      MTRN = 1
C2%2      MSKIP = 1
C2%2      IEXSHF = NMAX2/NPTS
C2%2      CALL XLOG2 (NPTS,LOG)
C2%2      ISIGN = -1
C2%2      CALL ACAC (CA,EX,CWORK)
C2%2      DO 20 I = 1,N2P
C2%220         CA(I) = CA(I)*CMPLX(0., REAL(I-1))
C2%2      CA(N2P) = 0.
C2%2      ISIGN = 1
C2%2      CALL SCSC (CA,EX,CWORK)
C2%2      F = 8.*REAL(N2P-1)*H/PI
C2%2      FN = 8.*REAL(N2P-1)
C2%2      DO 30 I = 1,N2P
C2%230         G(I) = FN/(F+REAL(CA(I)))
C2%2      NWM = N2M*N2M
C2%2      NWEIG = N2M*(N2M+3)
C2%2      AFACT = 2./REAL(N2)
C2%2      PIFACT = PI/REAL(N2)
C2%2      NPTS = 2*N2
C2%2      NSKIP = 1
C2%2      MTRN = 1
C2%2      MSKIP = 1
C2%2      CALL XLOG2 (NPTS,LOG)
C2%2      IEXSHF = NMAX2/NPTS
C2%2      FF = 1./(16.*REAL(N2*N2))
C2%2      KE = LE
C2%2      DO 100 J = 1,N2M
C2%2           FACT = PIFACT*REAL(J)
C2%2           DO 40 I = 1,N2P
C2%240              CWORK(I) = CMPLX(0.,-G(I)*REAL(J)*SIN(FACT*REAL(I-
C2%2           ISIGN = -1
C2%2           CALL ACAC (CWORK,EX,E)
C2%2           DO 50 I = 1,N2
C2%250              CWORK(I) = CWORK(I)*CMPLX(0.,REAL(I-1))
C2%2           CWORK(N2P) = 0.
C2%2           ISIGN = 1
C2%2           CALL SCSC (CWORK,EX,E)
C2%2           DO 60 I = 1,N2P
C2%260               CWORK(I) = G(I)*CWORK(I)
C2%2           ISIGN = -1
C2%2           CALL SCSC (CWORK,EX,E)
C2%2           DO 70 I = 2,N2
C2%270              E(I-1,1) = REAL(CWORK(I))*FF
C2%2           CALL OUT (E,KE,N2M)
C2%2100        KE = KE + N2M
C2%2      CALL IN (E,LE,NWM)
C2%2C
C2%2C COMPUTE EIGENVALUES AND EIGENVECTORS, CHECK SUCCESS AND STOP IF NO
C2%2C
C2%2      CALL LCMRQR (E,N2M,N2M,EVAL,1,LH,LEV,INDIC)
C2%2      LVECT = N2M
C2%2      LSKIP = 2
C2%2      NVECT = 1
C2%2      NVSKIP = 1
C2%2      DO 110 I = 1,N2M
C2%2           IF (INDIC(I) - 1) 1000, 1001, 110
C2%21000       WRITE(6,210)  I,INDIC(I)
C2%2           STOP
C2%2C
C2%2C IF AN EIGENVECTOR WAS NOT FOUND, COMPUTE IT THE OLD WAY
C2%2C
C2%21001       CALL OUT (E,LEV,NWM)
C2%2           CALL IN (E,LE,NWM)
C2%2           DO 1010 J = 1,N2M
C2%2                CWORK(J) = 1.
C2%21010            E(J,J) = E(J,J)-EVAL(I)
C2%2           CALL LU2 (E,N2M,N2M,IR,IC)
C2%2           DO 1020 K = 1,3
C2%2                CALL SOLVE2 (CWORK,E,N2M,IR,IC)
C2%2                SUM = 0.
C2%2                DO 1030 J = 1,N2M
C2%21030                 SUM = SUM + REAL(CWORK(J))*REAL(CWORK(J))
C2%2                IF (SUM .EQ. 0.) GO TO 1020
C2%2                F = 1./SQRT(SUM)
C2%2                DO 1040 J = 1,N2M
C2%21040                 CWORK(J) = REAL(CWORK(J))*F
C2%21020            CONTINUE
C2%2           XLARGE = 0.
C2%2           DO 1060 J = 1,N2M
C2%2                IF (ABS(REAL(CWORK(J))) .LT. XLARGE) GO TO 1060
C2%2                XLARGE = ABS(REAL(CWORK(J)))
C2%2                IXL = J
C2%21060            CONTINUE
C2%2           FACT = 1./REAL(CWORK(IXL))
C2%2           CALL IN (E,LEV,NWM)
C2%2           DO 1050 J = 1,N2M
C2%21050            E(J,I) = REAL(CWORK(J))*FACT
C2%2           WRITE(6,220)  I,INDIC(I),EVAL(I)
C2%2110        CONTINUE
C2%2210   FORMAT (' EIGSET ERROR, INDIC(',I3,') =',I3)
C2%2220   FORMAT (///,' LCMRQR FAILURE. INDIC(',I3,') =',I2,/,
C2%2     1        ' EIGENVECTOR CORRESPONDING TO EIGENVALUE ',E15.7,
C2%2     2        ' HAS BEEN COMPUTED THE OLD WAY')
C2%2C
C2%2C LU TRANSFORM EIGENVECTORS AND STORE RESULTS IN LCM
C2%2C ASSUMING THAT EVAL, IR, IC AND E OCCUPY NWEIG CONSECUTIVE LOCATION
C2%2C
C2%2      CALL LU2 (E,N2M,N2M,IR,IC)
C2%2      CALL OUT (EVAL,LPRESS,NWEIG)
C2%2      RETURN
C2%2      END
C***********************************************************************
      SUBROUTINE BUG (POINT)
      CHARACTER*10 POINT
      COMMON /DEBUG/NUMBER, TLAST
      CALL CPUTIM (TNOW)
      TSINCE = TNOW-TLAST
      WRITE(6,100) NUMBER,TNOW,TSINCE,POINT
100   FORMAT (' NUMBER =',I3,'; TNOW =',F9.3,' S; TSINCE =',
     1     F9.3,' S; LOCATION IS: ',A10)
      NUMBER = NUMBER+1
      TLAST = TNOW
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:05:54
C***********************************************************************
C
C     FGPS 29-MAR-88 MODIFIED RPRINT =====> CPRINT SO AS TO PRINT OUT
C                    COMPLEX ARRAYS
C
C     N O T E :  THE INDEXING OF COMPLEX ARRAYS REPRESENTING PRINCIPAL V
C     IABLES IS OF THE FORM
C
C     COMPLEX  ======>  CA (1<=JY<=N2P,1<=IX<=N1H)
C
C     WHERE "JY" IS THE COUNT ALONG THE Y-AXIS AND "IX" RUNS ALONG THE X
C     AXIS, AND WHERE
C
C                          N2P = (N2+1)                    FOR THE Y-AXI
C     AND
C                           N1H = N1/2                     FOR THE X-AXI
C
C     AND WHERE THE GRID IS NOMINALLY DIMENSIONED (N2+1) BY N1.  MOREOVE
C     THE INDEX PAIR  JY = (N2+1)/2, IX= N1H/2  IS ASSUMED TO IDENTIFY T
C     CENTER OF THE VORTEX CELL.  HOWEVER, IN ACTUAL USE HERE, THE PROGR
C     MING INVOLVES THE REAL EQUIVALENT TO CA; I.E.,
C
C     REAL     ======>  RA (1<=JY<=N2P,1<=IX<=N1)
C
C
      SUBROUTINE CPRINT (RA,NAME,N1H,N2P,IMODE)
C
      COMMON /DATA/ALPHA, BETA, BOXX, H, RNU, RKAPA, DT, DTT, T
     X  , NSTEPS
      COMMON /VERIFY/VDAT(15), CDAT(15)
      COMMON /OPTONS/N1, N2, NUMBER, KDATA, LMAPP, NOTEMP, KTA,
     X     KTAPE, KSM, KPP, KZP, KTP, KUP, KVP, KPF, KZF, KTF, KUF, KVF
     X     , KPRESS, NOALS
      REAL            RA(N2P,1)
      CHARACTER*8     NAME
C
      WRITE (6,1002) NSTEPS
C
C     SELECT THE PRINT-OUT MODE
C
      IF (IMODE) 1000,2000,3000
C
 1000 CONTINUE
C
         IX1 = 1+N1H/4
         IX2 = 1+N1H/2
         JY1 = 1+N2P/2
         WRITE (6,1010) NAME,JY1,IX1,RA(JY1,IX1)
         WRITE (6,1020) NAME,JY1,IX2,RA(JY1,IX2)
         IF (NAME .EQ. 'PSI PHYS' .AND. NSTEPS .EQ. NUMBER) THEN
            CDAT(11) = RA(JY1,IX2)
         ENDIF
C
      RETURN
C
 1002 FORMAT(/2X,8HNSTEPS =,I7)
 1010 FORMAT(2X,A8,4H(JY=,I3,4H,IX=,I3,3H) =,1PE13.6)
 1020 FORMAT(2X,A8,4H(JY=,I3,4H,IX=,I3,3H) =,1PE13.6/)
C
 2000 CONTINUE
C
C     VALUES OF THE VARIABLE ASSOCIATED WITH NAME ARE PRINTED OUT AT INT
C     VALS AS A FUNCTION OF Y (I.E., 1<=JY<=N2P WITH STRIDE = 4) AT CONS
C     X (E.G., IX = N1H/2)
C
         IX1 = N1H/2
         WRITE (6,2020) (JY,NAME,IX1,RA(JY,IX1),JY=1,N2P,4)
C
      RETURN
C
 2020 FORMAT(/,34(2X,4HJY =,I5,2X,A8,7H(JY,IX=,I3,3H) =,1PE13.6,6X,
     1   4HJY =,I5,2X,A8,7H(JY,IX=,I3,3H) =,1PE13.6/))
C
 3000 CONTINUE
C
C     VALUES OF THE VARIABLE ASSOCIATED WITH NAME ARE PRINTED OUT AT INT
C     VALS AS A FUNCTION OF X (I.E., 1<=IX<=N1 WITH STRIDE = 4) AT CONST
C     Y (E.G., JY = N2P/2 + 1)
C
         N1 = N1H + N1H
         JY1 = N2P/2 + 1
         WRITE (6,3020) (IX,NAME,JY1,RA(JY1,IX),IX=1,N1,4)
         IF (NAME .EQ. 'PSI PHYS') THEN
            IF (NSTEPS .EQ. 1) THEN
               CDAT(1) = RA(JY1,33)
            ELSE IF (NSTEPS .EQ. 2) THEN
               CDAT(6) = RA(JY1,33)
            ENDIF
         ENDIF
C
      RETURN
C
 3020 FORMAT(/,34(2X,4HIX =,I5,2X,A8,4H(JY=,I3,6H,IX) =,1PE13.6/))
C
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:03:55
C
C     CPUTIM RETURNS ELAPSED USER TIME, T, IN SECONDS.
C     NOTE T IS OF TYPE 'REAL'
C
C     ON THE ALLIANT, INTRINSIC FUNTION ETIME IS CALLED.
C     THE ETIME FUNCTION EXPECTS ITS ARGUEMENT TO BE A 4-BYTE REAL,
C     SO THE NON-ANSI CONSTRUCT REAL*4 IS USED IN THIS CODE.
C
      SUBROUTINE CPUTIM(T)
      REAL T
      REAL*4 TARRAY(2),ETIME
      T=ETIME(TARRAY)
      T=TARRAY(1)
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:06:30
C
      SUBROUTINE CSR( A, EX )
      COMMON /FT/NPTS, NSKIP, MTRN, MSKIP, ISIGN, LOG, IEXSHF
      COMMON /DATA/ALPHA, BETA, BOXX, H, RNU, RKAPA, DT, DTT, T
     X  , NSTEPS
      COMMON /OPTONS/N1, N2, NUMBER, KDATA, LMAPP, NOTEMP, KTA,
     X     KTAPE, KSM, KPP, KZP, KTP, KUP, KVP, KPF, KZF, KTF, KUF, KVF
     X     , KPRESS, NOALS
      COMMON /TIMING/TXXXIN, TXXOUT, TXXRCS, TXXCSR, TXSCSC,
     X  TXACAC, TFTVMT, TXSHUF, TUSHUF, TXPRNT, TXLOG2, EXXRCS, EXXCSR,
     X  EXSCSC, EXACAC, EFTVMT, NXXXIN, NXXOUT, NXXRCS, NXXCSR, NXSCSC,
     X  NXACAC, NFTVMT, NXSHUF, NUSHUF, NXPRNT, NXLOG2
      COMPLEX A( 1 ), EX( 1 ), BJ, BJSTAR
      integer div, gcd, MSKIPlt, NSKIPlt
C
C   PERFORM A CONJUGATE SYMMETRIC TO REAL TRANSFORM ON A PACKED
C   CONJUGATE SYMMETRIC ARRAY.  ONLY HALF THE ARRAY IS STORED, AND A(0)
C   AND A(N/2) ARE BOTH PACKED TOGETHER IN A(0) SINCE THEY ARE BOTH REAL
C
      LOGICAL   LFIRST,LXSTEP,LXTIME
      DATA      LFIRST,LXSTEP,LXTIME /.TRUE.,.FALSE.,.TRUE./
C
      IF (NSTEPS.EQ.NUMBER) LXSTEP = .TRUE.
      IF (LFIRST) CALL CPUTIM (T1)
      IF (LXSTEP) THEN
        IF (LXTIME) CALL CPUTIM (T1)
      END IF
C
      N = NPTS
      NPTS = NPTS/2
      M = NPTS
      ISHIFT = 0
      IF (ISIGN .LT. 0)  ISHIFT=M*IEXSHF
      MH = M/2
      MHP = MH + 1
      div = gcd(MSKIP, NSKIP)
      MSKIPlt = MSKIP/div
      NSKIPlt = NSKIP/div
      if ((MSKIPlt .GT. 0) .and.
     *    (MSKIPlt .LE. M) .and.
     *    (NSKIPlt .GT. 0) .and.
     *    (NSKIPlt .LT. MTRN)) then

C--- Serial version of DO 20

D        call trace_enter (2009) 
      DO 20 LOOP = 1, MTRN
      IST = (LOOP - 1)*MSKIP
      ISTP = IST + 1
      A( ISTP ) = CMPLX( REAL( A(ISTP) ) + AIMAG( A(ISTP) ),
     1                    REAL( A(ISTP) ) - AIMAG( A(ISTP) ) )
      DO 10 I = 2, MH
      J = (I - 1)*NSKIP + ISTP
      JSTAR = (M - I + 1)*NSKIP + ISTP
      BJ = A( J )
      BJSTAR = A( JSTAR )
      IEXL = IEXSHF*(I - 1) + 1 + ISHIFT
      IEXH = IEXSHF*(M - I + 1) + 1 + ISHIFT
      A( J ) = BJ + CONJG( BJSTAR ) +
     1                (0., 1.)*EX( IEXL )*( BJ - CONJG( BJSTAR ) )
      A( JSTAR ) = BJSTAR + CONJG( BJ ) +
     1                (0., 1.)*EX( IEXH )*( BJSTAR - CONJG( BJ ) )
10    CONTINUE
      J = MH*NSKIP + ISTP
      A(J) = 2. * A(J)
      IF (ISIGN .GT. 0)  A(J) = CONJG( A(J) )
20    CONTINUE
D        call trace_exit (2010) 
      else
D        call trace_enter (2011) 
      CDOALL 920 LOOP = 1, MTRN
         INTEGER IST, ISTP, J, JSTAR, I, IEXL, IEXH
         COMPLEX BJ, BJSTAR
         IST = (LOOP - 1)*MSKIP
         ISTP = IST + 1
         A( ISTP ) = CMPLX( REAL( A(ISTP) ) + AIMAG( A(ISTP) ),
     1                    REAL( A(ISTP) ) - AIMAG( A(ISTP) ) )
         DO 910 I = 2, MH
            J = (I - 1)*NSKIP + ISTP
            JSTAR = (M - I + 1)*NSKIP + ISTP
            BJ = A( J )
            BJSTAR = A( JSTAR )
            IEXL = IEXSHF*(I - 1) + 1 + ISHIFT
            IEXH = IEXSHF*(M - I + 1) + 1 + ISHIFT
            A( J ) = BJ + CONJG( BJSTAR ) +
     1                (0., 1.)*EX( IEXL )*( BJ - CONJG( BJSTAR ) )
            A( JSTAR ) = BJSTAR + CONJG( BJ ) +
     1                (0., 1.)*EX( IEXH )*( BJSTAR - CONJG( BJ ) )
910      CONTINUE
         J = MH*NSKIP + ISTP
         A(J) = 2. * A(J)
         IF (ISIGN .GT. 0)  A(J) = CONJG( A(J) )
920   CONTINUE
D        call trace_exit (2012) 
      endif
      LOG = LOG - 1
      IEXSHF = 2*IEXSHF
      CALL FTRVMT( A( 1 ), EX( 1 ) )
      LOG = LOG + 1
      IEXSHF = IEXSHF/2
      NPTS=N
C
      IF (LFIRST) THEN
        LFIRST = .FALSE.
        CALL CPUTIM (T2)
        TXXCSR = T2-T1
      END IF
C
      IF (LXSTEP) THEN
        IF (LXTIME) THEN
          LXTIME = .FALSE.
          CALL CPUTIM (T2)
          EXXCSR = T2-T1
        END IF
      END IF
C
      NXXCSR = NXXCSR+1
C
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:07:24
      SUBROUTINE DATAST (A,N2P,N1,GMAPP)
      COMMON /DATA/ALPHA, BETA, BOXX, H, RNU, RKAPA, DT, DTT, T
     X  , NSTEPS
      COMMON /PI/PI
      COMMON /LADDR/LZN, LTN, LPN, LZO, LTO, LPY, LZX, LZY, LEIG
     X  , LDUMY1(3)
      DIMENSION A(N2P,1), GMAPP(1)
C
C PROGRAM TO INITIALIZE THE RUN (EITHER IN PHYSICAL OR FOURIER SPACE)
C PHYSICAL SPACE: KDATA=1    --> A (I,J) ... POINT (I-1, J-1)
C FOURIER SPACE : KDATA=2    --> CA(I,J) ... MODE  (I-1, J-1)
C
C ALSO, IF YOU WANT TO SPECIFY THE MEAN FLOW (KSM=2), DO IT HERE.
C
      COMMON /MFLOW/U(129)
C
      ALPHA = 10.0
C
C UNSTABLE CASE:
      BETA = 1.0
C      RLAMDA = 1.35
C     WHEN CODE IS USED AS A BENCHMARK, SET RLAMDA = 1.00
      RLAMDA = 1.00
      BOXX = 2.0*PI*RLAMDA
      FX = 2.0*PI/BOXX
C
C ASSUMING THAT GSET IS CALLED. IF LMAPP = 1, H SHOULD BE SET TO
C A DEFINED POSITIVE NUMBER.
C
      H = GMAPP(N2P)
C
C COMPUTE VISCOSITY AND HEAT CONDUCTIVITY FROM PRANDTL NUMBER
C AND THE RATIO OF RAYLEIGH NUMBER TO ITS CRITICAL VALUE:
C
      PRANDT = 10.0
      RRATIO = 20.0
      W = ALPHA*BETA*PRANDT*4.0/(27.0*RRATIO)
      RNU = SQRT (ABS(W))
      RKAPA = RNU/PRANDT
C
C DETERMINE DIFFUSION LIMIT FOR THE TIME STEP AND COMPARE IT TO
C THE CHOSEN VALUE:
C
      DT = 0.0001
      X = FX*REAL(N1/2-1)
      Y = REAL(N2P-1)
      DTMAX = 1.0/((X*X+Y*Y) * MAX(RNU,RKAPA))
      WRITE(6,170) DTMAX,DT
  170 FORMAT (' DIFFUSION CONSTRAINT ON DT: DTMAX = ',F10.6,/
     1        ' ACTUAL DT CHOSEN FOR THIS RUN: DT = ',F10.6)
      NW = N2P*N1
C
      XX = BOXX/REAL(N1)
C
      EPS = 100.
D        call trace_enter (2013) 
      DO 20 J=1,N1
         X = REAL(J-1)*2.0*PI/REAL(N1)
         DO 10 I=1,N2P
            Y = REAL(I-1)*PI/REAL(N2P-1)
            A(I,J) = EPS*SIN(X)*SIN(Y)
   10    CONTINUE
   20 CONTINUE
C
D        call trace_exit (2014) 
      WRITE(6,100)
  100 FORMAT (///' INITIAL STREAMFUNCTION IS   A SIN(X) SIN(Y),'/
     1           ' WHERE  0 <= X <= 2*PI  AND  0 <= Y <= PI.'/
     2           ' THIS IMPLIES TWO CONVECTION CELLS INITIALLY.'/
     3           ' NOTE THAT THE PRESCRIBED INITIAL STREAM-'/
     4           ' FUNCTION VS X, FOR Y=YMAX/2, IS PRINTED OUT'/
     5           ' BELOW FOR NSTEPS=1 (TIME ZERO) AND ALSO FOR'/
     6           ' THE NEXT STEP, NSTEPS=2'//)
      CALL OUT (A,LPN,NW)
D        call trace_enter (2015) 
      DO 40 J=1,N1
         DO 30 I=1,N2P
            A(I,J) = 0.0
   30    CONTINUE
   40 CONTINUE
D        call trace_exit (2016) 
      WRITE(6,200)
  200 FORMAT (' INITIAL TEMPERATURE PERTURBATION IS ZERO.'/
     1        ' NOTE THAT THE INITIAL TEMPERATURE DROP VS'/
     2        ' Y IS PRINTED OUT BELOW, WHERE INITIALLY'/
     3        ' THIS IS INDEPENDENT OF X,  I.E., 1 <= IX'/
     4        ' <= 64, AND WHERE THE Y REPRESENTATION IN'/
     5        ' PHYSICAL SPACE SPANS 1 <= JY <= 129.   A'/
     6        ' KEY VARIABLE, THE EVOLUTION OF WHICH CAN'/
     7        ' MONITOR CODE PERFORMANCE, IS  "TEMP PHY('/
     8        ' JY=65,IX=33)"; I.E., A MEASURE OF TEMPER-'/
     9        ' ATURE IN PHYSICAL SPACE AT THE CENTERPOINT'/
     1        ' OF THE BOUNDARY SEPARATING THE TWO CONVEC-'/
     2        ' TION CELLS.')
      CALL OUT (A,LTN,NW)
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:08:01
C***********************************************************************
      SUBROUTINE DEALSE (CA,N2P,N1H,LOC)
      COMPLEX CA(N2P,1)
      COMMON /TIMING/TXXXIN, TXXOUT, TXXRCS, TXXCSR, TXSCSC,
     X  TXACAC, TFTVMT, TXSHUF, TUSHUF, TXPRNT, TXLOG2, EXXRCS, EXXCSR,
     X  EXSCSC, EXACAC, EFTVMT, NXXXIN, NXXOUT, NXXRCS, NXXCSR, NXSCSC,
     X  NXACAC, NFTVMT, NXSHUF, NUSHUF, NXPRNT, NXLOG2
C
C THIS FUNCTION GIVES THE INDEX OF THE HIGHEST MODE TO BE RETAINED
C IN TERMS OF THE NUMBER OF MODES WHICH CAN BE RESOLVED:
C
      LSTMOD (MODEHI) = INT(0.666666666666666*REAL(MODEHI-1)+0.999)
C
      NW = 2*N2P*N1H
      CALL IN (CA,LOC,NW)
      N1CUT = LSTMOD (N1H) +1
      N2CUT = LSTMOD (N2P) +1
C
C THIS DEALIASING PROCEDURE HAS TO BE IMPROVED IF NONLINEAR MAPPING
C IN Y-DIRECTION IS USED:
C
D        call trace_enter (2017) 
      CDOALL 10 J=N1CUT,N1H
   10             CA(1:N2P,J) = 0.0
D        call trace_exit (2018) 
D        call trace_enter (2019) 
      CDOALL 20 J=1,N1H
   20              CA(N2CUT:N2P,J) = 0.0
D        call trace_exit (2020) 
      CALL OUT (CA,LOC,NW)
C
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:03:55
 
C
C     ELAPSE RETURNS WALL CLOCK TIME, T, IN SECONDS.
C     NOTE T IS OF TYPE 'REAL'
C
C     ON THE ALLIANT, INTRINSIC FUNTION 'TIME' IS CALLED.
C     TIME RETURNS SYSTEM TIME IN SECONDS SINCE JAN. 1, 1970,
C     AND WE ONLY USE THE LEAST SIGNIFICANT 6 DIGITS.
C
      SUBROUTINE ELAPSE(T)
      REAL T
      INTEGER TIME
      T=MOD(TIME(),1000000)
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:08:22
C***********************************************************************
C2%2      SUBROUTINE PRESURE (LU, LV, LU2, LPM, NWPX, A, CA, WORK, CWORK
C2%2     1          EX, EVAL, IR, IC, E, FX, N1C, N1R, N2R, LMAPP)
C2%2C
C2%2C LU  IS LCM ADDRESS OF U VELOCITY (EVEN IN Y DIR.; PRESSURE RETURNE
C2%2C LV  ................. V ........ (ODD  .........)
C2%2C LU2 ................. WORKSPACE
C2%2C LPM ................. THE PRESSURE MATRIX
C2%2C
C2%2C A  IS THE  REAL  VERSION OF THE ARRAY
C2%2C CA ...... COMPLEX ................... (A AND CA MUST BE THE SAME)
C2%2C
C2%2C WORK  IS REAL    WORKSPACE
C2%2C CWORK .. COMPLEX .........; THEY MAY BE THE SAME
C2%2C
C2%2C G CONTAINS DZ/DY, I.E. THE INVERSE OF THE DERIVATIVE OF THE MAPPIN
C2%2C EX IS THE ARRAY OF COMPLEX EXPONENTIALS USED BY FFTS
C2%2C
C2%2C FX IS X DIFF. FACTOR (THE SAME AS IN MAIN PRG.)
C2%2C N1CD IS THE FIRST DIMENSION OF CA  (= 2**N +1)
C2%2C N1RD ......................... A   (HAS TO BE 2*N1CD)
C2%2C N2R  IS THE SECOND DIMENSION FOR A     (SAME AS N2C)
C2%2C
C2%2C NOTE: THE NOTATION (N1 V N2) IS NOT THE SAME AS IN THE MAIN PRG.,
C2%2C       THERE IS NO SPECIFIC REASON FOR THAT.
C2%2C
C2%2      COMMON /FT/ NPTS, NSKIP, MTRN, MSKIP, ISIGN, LOG, IEXS
C2%2      COMMON /EXSIZE/ NMAX
C2%2      COMMON /SOLV/ LVECT, LSKIP, NVECT, NVSKIP, GSOLVE(1)
C2%2C
C2%2      DIMENSION A(N1R,1), WORK(1), G(1), EVAL(1), IR(1), IC(1), E(1)
C2%2      COMPLEX CA(N1C,1), CWORK(1), EX(1)
C2%2C
C2%2C
C2%2C THESE ARE SOME RANDOM FACTORS WE USE...
C2%2C
C2%2      NW = N1R*N2R
C2%2      NWH = NW/2
C2%2      NWLINE = N1R
C2%2      N2C = N2R
C2%2      N2RH = N2R/2
C2%2      N2CH = N2RH
C2%2      N1CM = N1C-1
C2%2      N1CMM = N1C-2
C2%2      JH = N2C/2
C2%2      JHP = JH+1
C2%2      FXSQ = FX*FX
C2%2      FU2 = 1.0/(128.0*REAL(N1CM)*REAL(N2C))
C2%2      FUV = 8.0*FU2*FU2
C2%2      FV2 = 2.0*FU2*FUV
C2%2      LVECT = N1CMM
C2%2      LSKIP = 2
C2%2      NVECT = 2
C2%2      NVSKIP = 1
C2%2C
C2%2C INPUT U AND SQUARE IT, GO TO THE FOURIER SPACE AFTERWARDS:
C2%2C
C2%2      CALL IN (A,LU,NW)
C2%2      DO 20 I = 1,N1R
C2%2           DO 10 J = 1,N2R
C2%2                A(I,J) = A(I,J)*A(I,J)
C2%2   10      CONTINUE
C2%2   20 CONTINUE
C2%2C
C2%2      NPTS = 2*N2C
C2%2      NSKIP = N1C
C2%2      MTRN = N1C
C2%2      MSKIP = 1
C2%2      ISIGN = -1
C2%2      CALL XLOG2 (NPTS,LOG)
C2%2      IEXS = NMAX/NPTS
C2%2C
C2%2      CALL RCS (A,EX)
C2%2C
C2%2      NPTS = 2*N1CM
C2%2      NSKIP = 1
C2%2      MTRN = N2C
C2%2      MSKIP = N1C
C2%2      ISIGN = -1
C2%2      CALL XLOG2 (NPTS,LOG)
C2%2      IEXS = NMAX/NPTS
C2%2C
C2%2      CALL SCSC (A,EX,WORK)
C2%2C
C2%2C CA IS EQUIVALENCED TO A, SO THAT WE MAY DIFFERENTIATE:
C2%2C
C2%2      DO 40 J = 1,N2C
C2%2           DXXF = REAL(J-1)*REAL(J-1)*FXSQ
C2%2           DO 30 I = 1,N1C
C2%2                CA(I,J) = DXXF*CA(I,J)
C2%2   30      CONTINUE
C2%2   40 CONTINUE
C2%2C
C2%2C STORE THE FOURIER TRANSFORM OF -D2U2/DX2:
C2%2C
C2%2      CALL OUT (CA,LU2,NW)
C2%2C
C2%2C BRING IN U AND V FOR PRODUCT
C2%2C
C2%2      KU = LU
C2%2      KV = LV
C2%2      DO 70 K = 1,2
C2%2           CALL IN (A(1,1),KU,NWH)
C2%2           CALL IN (A(1,JHP),KV,NWH)
C2%2           DO 60 I = 1,N1R
C2%2                DO 50 J = 1,N2RH
C2%2                     A(I,J) = -A(I,J)*A(I,J+JH)
C2%2                     A(I,J+JH) = A(I,J+JH)*A(I,J+JH)
C2%2   50           CONTINUE
C2%2   60      CONTINUE
C2%2C
C2%2C MOVE OUT UV AND V2:
C2%2C
C2%2           CALL OUT (A(1,1),KU,NWH)
C2%2           CALL OUT (A(1,JHP),KV,NWH)
C2%2           KU = KU+NWH
C2%2           KV = KV+NWH
C2%2   70 CONTINUE
C2%2C
C2%2C CALL IN V2 TO COMPUTE DV2/DY
C2%2C
C2%2      CALL IN (A,LV,NW)
C2%2C
C2%2      NPTS = 2*N2C
C2%2      NSKIP = N1C
C2%2      MTRN = N1C
C2%2      MSKIP = 1
C2%2      ISIGN = -1
C2%2      CALL XLOG2 (NPTS,LOG)
C2%2      IEXS = NMAX/NPTS
C2%2C
C2%2      CALL RCS (A,EX)
C2%2C
C2%2      NPTS = 2*N1CM
C2%2      NSKIP = 1
C2%2      MTRN = N2C
C2%2      MSKIP = N1C
C2%2      ISIGN = -1
C2%2      CALL XLOG2 (NPTS,LOG)
C2%2      IEXS = NMAX/NPTS
C2%2C
C2%2      CALL SCSC (CA,EX,WORK)
C2%2C
C2%2C COMPUTE THE Y PARTIAL DERIVATIVE:
C2%2C
C2%2      DO 90 I = 1,N1CM
C2%2           DZF = REAL(I-1)
C2%2           DO 80 J = 1,N2C
C2%2                CA(I,J) = CMPLX(-DZF*AIMAG(CA(I,J)), DZF*REAL(CA(I,J
C2%2   80      CONTINUE
C2%2   90 CONTINUE
C2%2      DO 100 J = 1,N2C
C2%2           CA(N1C,J) = 0.0
C2%2  100 CONTINUE
C2%2C
C2%2C GO BACK TO THE PHYSICAL SPACE...
C2%2C
C2%2      NPTS = 2*N1CM
C2%2      NSKIP = 1
C2%2      MTRN = N2C
C2%2      MSKIP = N1C
C2%2      ISIGN = 1
C2%2      CALL XLOG2 (NPTS,LOG)
C2%2      IEXS = NMAX/NPTS
C2%2C
C2%2      CALL ACAC (CA,EX,WORK)
C2%2C
C2%2      NPTS = 2*N2C
C2%2      NSKIP = N1C
C2%2      MTRN = N1C
C2%2      MSKIP = 1
C2%2      ISIGN = 1
C2%2      CALL XLOG2 (NPTS,LOG)
C2%2      IEXS = NMAX/NPTS
C2%2C
C2%2      CALL CSR (CA,EX)
C2%2C
C2%2C MULTIPLY BY DZ/DY...
C2%2C
C2%2      DO 120 I = 1,N1R
C2%2           IPH = (I+1)/2
C2%2           GG = G(IPH)
C2%2           DO 110 J = 1,N2R
C2%2                A(I,J) = A(I,J)*GG
C2%2  110      CONTINUE
C2%2  120 CONTINUE
C2%2C
C2%2C BACK TO FOURIER...
C2%2C
C2%2      ISIGN = -1
C2%2C
C2%2      CALL RCS (A,EX)
C2%2C
C2%2      NPTS = 2*N1CM
C2%2      NSKIP = 1
C2%2      MTRN = N2C
C2%2      MSKIP = N1C
C2%2      ISIGN = -1
C2%2      CALL XLOG2 (NPTS,LOG)
C2%2      IEXS = NMAX/NPTS
C2%2C
C2%2      CALL ACAC (CA,EX,WORK)
C2%2C
C2%2      CALL OUT (CA,LV,NW)
C2%2C
C2%2C START WITH THE PHYSICAL UV TO COMPUTE DUV/DX
C2%2C
C2%2      CALL IN (A,LU,NW)
C2%2C
C2%2      NPTS = 2*N2C
C2%2      NSKIP = N1C
C2%2      MTRN = N1C
C2%2      MSKIP = 1
C2%2      ISIGN = -1
C2%2      CALL XLOG2 (NPTS,LOG)
C2%2      IEXS = NMAX/NPTS
C2%2C
C2%2      CALL RCS (A,EX)
C2%2C
C2%2      NPTS = 2*N1CM
C2%2      NSKIP = 1
C2%2      MTRN = N2C
C2%2      MSKIP = N1C
C2%2      ISIGN = -1
C2%2      CALL XLOG2 (NPTS,LOG)
C2%2      IEXS = NMAX/NPTS
C2%2C
C2%2      CALL ACAC (A,EX,WORK)
C2%2C
C2%2      DO 140 J = 1,N2C
C2%2           DXF = REAL(J-1)*FX
C2%2           DO 130 I = 1,N1C
C2%2                CA(I,J) = CMPLX(-DXF*AIMAG(CA(I,J)), DXF*REAL(CA(I,J
C2%2  130      CONTINUE
C2%2  140 CONTINUE
C2%2C
C2%2C ADD THE FOURIER TRANSFORMS OF DUV/DX AND DV2/DY
C2%2C
C2%2      KU = LU+NWH
C2%2      CALL OUT (CA(1,JHP),KU,NWH)
C2%2      KU = LU
C2%2      KV = LV
C2%2      DO 170 K = 1,2
C2%2           CALL IN (CA(1,JHP),KV,NWH)
C2%2           DO 160 I = 1,N1C
C2%2                DO 150 J = 1,N2CH
C2%2                     CA(I,J) = FUV*CA(I,J)+FV2*CA(I,J+JH)
C2%2  150           CONTINUE
C2%2  160      CONTINUE
C2%2           CALL OUT (CA(1,1),KU,NWH)
C2%2           KU = KU+NWH
C2%2           KV = KV+NWH
C2%2           IF (K .EQ. 1) CALL IN (CA(1,1),KU,NWH)
C2%2  170 CONTINUE
C2%2C
C2%2C FIND D/DY(DUV/DX+DV2/DY):
C2%2C
C2%2      CALL IN (CA,LU,NW)
C2%2C
C2%2      DO 190 I = 1,N1CM
C2%2           DZF = REAL(I-1)
C2%2           DO 180 J = 1,N2C
C2%2                CA(I,J) = CMPLX(-DZF*AIMAG(CA(I,J)), DZF*REAL(CA(I,J
C2%2  180      CONTINUE
C2%2  190 CONTINUE
C2%2      DO 200 J = 1,N2C
C2%2           CA(N1C,J) = 0.0
C2%2  200 CONTINUE
C2%2C
C2%2C GO BACK TO THE PHYSICAL SPACE...
C2%2C
C2%2      NPTS = 2*N1CM
C2%2      NSKIP = 1
C2%2      MTRN = N2C
C2%2      MSKIP = N1C
C2%2      ISIGN = 1
C2%2      CALL XLOG2 (NPTS,LOG)
C2%2      IEXS = NMAX/NPTS
C2%2C
C2%2      CALL SCSC (CA,EX,WORK)
C2%2C
C2%2      NPTS = 2*N2C
C2%2      NSKIP = N1C
C2%2      MTRN = N1C
C2%2      MSKIP = 1
C2%2      ISIGN = 1
C2%2      CALL XLOG2 (NPTS,LOG)
C2%2      IEXS = NMAX/NPTS
C2%2C
C2%2      CALL CSR (CA,EX)
C2%2C
C2%2C MULTIPLY BY DZ/DY...
C2%2C
C2%2      DO 220 I = 1,N1R
C2%2           IPH = (I+1)/2
C2%2           GG = G(IPH)
C2%2           DO 210 J = 1,N2R
C2%2                A(I,J) = A(I,J)*GG
C2%2  210      CONTINUE
C2%2  220 CONTINUE
C2%2C
C2%2C BACK TO FOURIER...
C2%2C
C2%2      ISIGN = -1
C2%2C
C2%2      CALL RCS (A,EX)
C2%2C
C2%2      NPTS = 2*N1CM
C2%2      NSKIP = 1
C2%2      MTRN = N2C
C2%2      MSKIP = N1C
C2%2      ISIGN = -1
C2%2      CALL XLOG2 (NPTS,LOG)
C2%2      IEXS = NMAX/NPTS
C2%2C
C2%2      CALL SCSC (CA,EX,WORK)
C2%2C
C2%2C FIND -D2U2/DX2 -2*D2UV/DYDX -D2V2/DY2 = DEL2 P:
C2%2C
C2%2      KU = LU+NWH
C2%2      CALL OUT (CA(1,JHP),KU,NWH)
C2%2      KU = LU
C2%2      KU2 = LU2
C2%2      DO 250 K = 1,2
C2%2           CALL IN (CA(1,JHP),KU2,NWH)
C2%2           DO 240 I = 1,N1C
C2%2                DO 230 J = 1,N2CH
C2%2                     CA(I,J) = FU2*CA(I,J+JH) - CA(I,J)
C2%2  230           CONTINUE
C2%2  240      CONTINUE
C2%2           CALL OUT (CA(1,1),KU,NWH)
C2%2           KU = KU+NWH
C2%2           KU2 = KU2+NWH
C2%2           IF (K .EQ. 1) CALL IN (CA(1,1),KU,NWH)
C2%2  250 CONTINUE
C2%2C
C2%2C THIS GAVE US DEL2 P; NOW WE SOLVE FOR P:
C2%2C
C2%2      CALL IN (EVAL,LPM,NWPX)
C2%2      KU = LU
C2%2      DO 270 J = 1,N2C
C2%2           CALL IN (CWORK,KU,NWLINE)
C2%2           IF (LMAPP .NE. 1) CALL SOLVE2 (CWORK(2),E,N1CMM,IR,IC)
C2%2           F = REAL(J-1)*REAL(J-1)*FXSQ
C2%2           DO 260 I = 2,N1CM
C2%2                CWORK(I) = CWORK(I) / (EVAL(I-1)-F)
C2%2  260      CONTINUE
C2%2           IF (LMAPP .NE. 1) CALL LUMULT2 (CWORK(2),E,N1CMM,IR,IC)
C2%2           WZERO = 0.0
C2%2           IF (F .NE. 0.0) WZERO = -CWORK(1)/F
C2%2           CWORK(1) = WZERO
C2%2           CWORK(N1C) = 0.0
C2%2           CALL OUT (CWORK,KU,NWLINE)
C2%2           KU = KU+NWLINE
C2%2  270 CONTINUE
C2%2C
C2%2C THAT S  ALL FOLKS! THE PRESSURE IS KNOWN AND WE PROUDLY PRESENT IT
C2%2C
C2%2      CALL IN (A,LU,NW)
C2%2C
C2%2C DO NOT FORGET!!! WE ARE STILL IN THE FOURIER SPACE, SO SCSC/CSR SH
C2%2C BE CALLED.
C2%2C
C2%2      NPTS = 2*N1CM
C2%2      NSKIP = 1
C2%2      MTRN = N2C
C2%2      MSKIP = N1C
C2%2      ISIGN = 1
C2%2      CALL XLOG2 (NPTS,LOG)
C2%2      IEXS = NMAX/NPTS
C2%2C
C2%2      CALL SCSC (A,EX,WORK)
C2%2C
C2%2      NPTS = 2*N2C
C2%2      NSKIP = N1C
C2%2      MTRN = N1C
C2%2      MSKIP = 1
C2%2      ISIGN = 1
C2%2      CALL XLOG2 (NPTS,LOG)
C2%2      IEXS = NMAX/NPTS
C2%2C
C2%2      CALL CSR (A,EX)
C2%2C
C2%2C WE GOT BACK THE PHYSICAL VALUES SO WE CAN UNRAVEL THE MESS AND PLO
C2%2C
C2%2      CALL UNSHUF (A, N1C, 2*N2R, WORK)
C2%2      CALL RPRINT (A,8HPRES PHY,N2R,N1R,-1)
C2%2      CALL TELTIM
C2%2C      CALL PLOTME (A,WORK,NCALL)
C2%2      RETURN
C2%2      END
C2%2C*******************************************************************
C
C     FGPS 12-FEB-1988 SUBR. PLOTME TEMPORARILY COMMENTED "C" OUT
C
C      SUBROUTINE PLOTME (Z,WORK,NCALL)
C      COMMON /DATA/ ALPHA,BETA,BOXX,H, RDUMY1(5), IDUMY1
C      COMMON /OPTONS/ NX,NY
C      DIMENSION Z(1), WORK(1)
C      COMMON /PLTDEF/ IDPAT, DXA, DXB, DYA, DYB
CC
CC THIS SUBROUTINE CAN BE USED FOR PLOTTING OF FIELDS IN PHYSICAL
CC SPACE. CONTOUR PLOTS ARE USUALLY BEST.
CC
C      ASPECT = BOXX/H
C      A = (DXB-DXA) / (DYB-DYA)
C      XMIN = DXA
C      XMAX = DXB
C      YMIN = DYA
C      YMAX = DYB
C      IF (A.LT.ASPECT) GO TO 10
C      SPANH = 0.5*(DYB-DYA) * ASPECT
C      RMEAN = 0.5*(DXA+DXB)
C      XMIN = RMEAN-SPANH
C      XMAX = RMEAN+SPANH
C      GO TO 30
C   10 SPANH = 0.5*(DXB-DXA) / ASPECT
C      RMEAN = 0.5*(DYA+DYB)
C      YMIN = RMEAN-SPANH
C      YMAX = RMEAN+SPANH
C   30 CALL SET (XMIN,XMAX,YMIN,YMAX,1.0,REAL(NX+1),1.0,REAL(NY+1),1)
C      CALL EDGES (-1)
C      CALL DRAWBOX (1.0,1.0,REAL(NX),REAL(NY+1))
C      CALL CONREC (Z,NY+1,NY+1,NX,0.0,0.0,0.0,1,0,0)
C      CALL FRAME
C      RETURN
C      END
C***********************************************************************
C      SUBROUTINE DATE (TODAY)
C      TODAY = DATEF(1.0)
C      RETURN
C      END
C***********************************************************************
C      SUBROUTINE TIME (NOW)
C      NOW = 8HNOW
C      RETURN
C      END
C***********************************************************************
C                           E - O - D
C***********************************************************************
C
C FFTFORTRANPACK3
C FFTFTN.5
C 10/16/80
C
      SUBROUTINE EXSET( EX, NPTS )
      COMPLEX EX( 1 )
      COMPLEX A1,A2
      W = 6.283185307179586477/REAL( NPTS )
      NH = NPTS/2
CVD$ NOVECTOR
CVD$ NOCONCUR
D        call trace_enter (2021) 
      DO 10 J = 1, NH
C           EX( J ) = EXP( CMPLX( 0., REAL(J - 1)*W ) )
C10         EX( J + NH ) = EXP( CMPLX( 0., REAL(1 - J)*W ) )
           A1 = CMPLX(0., REAL(J-1)*W)
           EX(J) = EXP(A1)
10         EX(J+NH) = EXP(-1.*A1)
D        call trace_exit (2022) 
      RETURN
      END
C
      SUBROUTINE FTRVMT (DATA,EX)
C
C THIS IS A FORTRAN VERSION OF THE ASSEMBLY LANGUAGE SUBROUTINE
C FFT2, TO BE USED WITH THE NSSL SUBROUTINE PACKAGE FFTPOW2.
C
      COMMON/FT/NPTS,NSKIP,MTRN,MSKIP,ISIGN,LOG,IEXSHF
C
C DATA IS A COMPLEX ARRAY OF LENGTH NPTS WHICH SERVES FOR BOTH
C INPUT AND OUTPUT.
C
      COMMON /TIMING/ TXXXIN,TXXOUT,TXXRCS,TXXCSR,TXSCSC,TXACAC,TFTVMT,
     1                TXSHUF,TUSHUF,TXPRNT,TXLOG2,
     2                EXXRCS,EXXCSR,EXSCSC,EXACAC,EFTVMT,
     3                NXXXIN,NXXOUT,NXXRCS,NXXCSR,NXSCSC,NXACAC,NFTVMT,
     4                NXSHUF,NUSHUF,NXPRNT,NXLOG2
C
      integer reflect
      integer div, gcd
      COMPLEX DATA(99), EXP1, EXK, EXJ, H, EX(1)
      COMPLEX EXJx
      REAL HH(2)
      EQUIVALENCE (HH,H)
      LOGICAL   LFIRST,LXSTEP,LXTIME
      DATA      LFIRST,LXSTEP,LXTIME /.TRUE.,.FALSE.,.TRUE./
C
      IF (NSTEPS.EQ.NUMBER) LXSTEP = .TRUE.
      IF (LFIRST) CALL CPUTIM (T1)
      IF (LXSTEP) THEN
        IF (LXTIME) CALL CPUTIM (T1)
      END IF
C
      IERR=0
      MFACTOR = (MTRN-1)*MSKIP
      I2K=NPTS
      IF(I2K.EQ.1) GO TO 7777
      SGN1=ISIGN
      EXK=EX(1+IEXSHF)
      IF (SGN1.LT.0.) EXK=CONJG(EXK)
  101 CONTINUE
      I2KP=I2K
      I2K=I2K/2
      I2KS=I2K*NSKIP
      IF(2*I2K.NE.I2KP) GO TO 117
      JLI=I2K/2+1
      div = gcd(MSKIP, I2KP*NSKIP)
      MSKIPlt = MSKIP/div
      I2KPlt  = I2KP*NSKIP/div
      if ((MSKIPlt .GT. 0) .and.
     #    (MSKIPlt .LT. (NPTS-1+I2KP)/I2KP) .and.
     #    (I2KPlt  .GT. 0) .and.
     #    (I2KPlt  .LT. MTRN)) then
 
C---Serial version of 109
 
D        call trace_enter (2023) 
      DO 109 JL=1,I2K
         IF(JL-1) 102,102,104
  102    EXJ=(1.,0.)
         DO 103 JJ=JL,NPTS,I2KP
            DO 103 MM=1,MTRN
               JS=(JJ-1)*NSKIP+(MM-1)*MSKIP+1
               H=DATA(JS)-DATA(JS+I2KS)
               DATA(JS)=DATA(JS)+DATA(JS+I2KS)
               DATA(JS+I2KS)=H
  103    CONTINUE
         GO TO 109
  104    IF(JL-JLI) 105,107,105
C
C INCREMENT JL-DEPENDENT EXPONENTIAL FACTOR
C
  105    EXJ=EXJ*EXK
         DO 106 JJ=JL,NPTS,I2KP
            DO 106 MM=1,MTRN
               JS=(JJ-1)*NSKIP+(MM-1)*MSKIP+1
               H=DATA(JS)-DATA(JS+I2KS)
               DATA(JS)=DATA(JS)+DATA(JS+I2KS)
               DATA(JS+I2KS)=H*EXJ
  106    CONTINUE
         GO TO 109
  107    EXJ=CMPLX(0.,SGN1)
         DO 108 JJ=JL,NPTS,I2KP
            DO 108 MM=1,MTRN
               JS=(JJ-1)*NSKIP+(MM-1)*MSKIP+1
               H=DATA(JS)-DATA(JS+I2KS)
               DATA(JS)=DATA(JS)+DATA(JS+I2KS)
               DATA(JS+I2KS)=CMPLX(-SGN1*HH(2),SGN1*HH(1))
  108    CONTINUE
  109 CONTINUE
D        call trace_exit (2024) 
      else if (I2K .GE. 8) then
D        call trace_enter (2025) 
      CDOALL 9109 JL=1,I2K
         integer MM
         complex EXJx
         complex H(1:MTRN)
         integer JJ, JS, lastval, JS2, lastval2
 
         if (JL .eq. 1) then
         else if (JL .lt. JLI) then
            EXJx = (EXK**(JL-1))
         else
            EXJx = CMPLX(0.,SGN1)*(EXK**(JL-JLI))
         endif
         IF(JL-1) 9102,9102,9104
 9102    DO 9103 JJ=JL,NPTS,I2KP
               JS=(JJ-1)*NSKIP+1
               JS2=JS+I2KS
               lastval=JS+MFACTOR
               lastval2=lastval+I2KS
               H=DATA(JS:lastval:MSKIP)-
     *           DATA(JS2:lastval2:MSKIP)
               DATA(JS:lastval:MSKIP)=DATA(JS:lastval:MSKIP)+
     *                      DATA(JS2:lastval2:MSKIP)
               DATA(JS2:lastval2:MSKIP)=H
 9103    CONTINUE
         GO TO 9109
 9104    IF(JL-JLI) 9105,9107,9105
C
C INCREMENT JL-DEPENDENT EXPONENTIAL FACTOR
C
 9105    DO 9106 JJ=JL,NPTS,I2KP
               JS=(JJ-1)*NSKIP+1
               JS2=JS+I2KS
               lastval=JS+MFACTOR
               lastval2=lastval+I2KS
               H=DATA(JS:lastval:MSKIP)-
     *           DATA(JS2:lastval2:MSKIP)
               DATA(JS:lastval:MSKIP)=DATA(JS:lastval:MSKIP)+
     *                      DATA(JS2:lastval2:MSKIP)
               DATA(JS2:lastval2:MSKIP)=H*EXJx
 9106    CONTINUE
         GO TO 9109
 9107    DO 9108 JJ=JL,NPTS,I2KP
               JS=(JJ-1)*NSKIP+1
               JS2=JS+I2KS
               lastval=JS+MFACTOR
               lastval2=lastval+I2KS
               H=DATA(JS:lastval:MSKIP)-
     *           DATA(JS2:lastval2:MSKIP)
               DATA(JS:lastval:MSKIP)=DATA(JS:lastval:MSKIP)+
     *                      DATA(JS2:lastval2:MSKIP)
               DATA(JS2:lastval2:MSKIP)=
     *                      CMPLX(-SGN1*aimag(H),SGN1*real(H))
 9108    CONTINUE
 9109 CONTINUE
D        call trace_exit (2026) 
      else

C---CDOALL inner

D        call trace_enter (2027) 
      DO 8109 JL=1,I2K
 
         if (JL .eq. 1) then
         else if (JL .lt. JLI) then
            EXJx = (EXK**(JL-1))
         else
            EXJx = CMPLX(0.,SGN1)*(EXK**(JL-JLI))
         endif
         IF(JL-1) 8102,8102,8104
 8102    CDOALL 8103 JJ=JL,NPTS,I2KP
         complex H(1:MTRN)
         integer JS, lastval, JS2, lastval2
               JS=(JJ-1)*NSKIP+1
               JS2=JS+I2KS
               lastval=JS+MFACTOR
               lastval2=lastval+I2KS
               H=DATA(JS:lastval:MSKIP)-
     *           DATA(JS2:lastval2:MSKIP)
               DATA(JS:lastval:MSKIP)=DATA(JS:lastval:MSKIP)+
     *                      DATA(JS2:lastval2:MSKIP)
               DATA(JS2:lastval2:MSKIP)=H
 8103    CONTINUE
         GO TO 8109
 8104    IF(JL-JLI) 8105,8107,8105
C
C INCREMENT JL-DEPENDENT EXPONENTIAL FACTOR
C
 8105    CDOALL 8106 JJ=JL,NPTS,I2KP
         complex H(1:MTRN)
         integer JS, lastval, JS2, lastval2
               JS=(JJ-1)*NSKIP+1
               JS2=JS+I2KS
               lastval=JS+MFACTOR
               lastval2=lastval+I2KS
               H=DATA(JS:lastval:MSKIP)-
     *           DATA(JS2:lastval2:MSKIP)
               DATA(JS:lastval:MSKIP)=DATA(JS:lastval:MSKIP)+
     *                      DATA(JS2:lastval2:MSKIP)
               DATA(JS2:lastval2:MSKIP)=H*EXJx
 8106    CONTINUE
         GO TO 8109
 8107    CDOALL 8108 JJ=JL,NPTS,I2KP
         complex H(1:MTRN)
         integer JS, lastval, JS2, lastval2
               JS=(JJ-1)*NSKIP+1
               JS2=JS+I2KS
               lastval=JS+MFACTOR
               lastval2=lastval+I2KS
               H=DATA(JS:lastval:MSKIP)-
     *           DATA(JS2:lastval2:MSKIP)
               DATA(JS:lastval:MSKIP)=DATA(JS:lastval:MSKIP)+
     *                      DATA(JS2:lastval2:MSKIP)
               DATA(JS2:lastval2:MSKIP)=
     *                      CMPLX(-SGN1*aimag(H),SGN1*real(H))
 8108    CONTINUE
 8109 CONTINUE
D        call trace_exit (2028) 
      endif
C
C INCREMENT K-DEPENDENT EXPONENTIAL FACTOR
C
      EXK=EXK*EXK
      IF(I2K-1) 110,110,101
  110 IF(NPTS.LE.2) GO TO 7777
      NPTSD2=NPTS/2
      JMIN=0
      JMAX=NPTS-4
      JREV=0
      if ((NSKIP/MSKIP .gt. 0) .and.
     *    (NSKIP/MSKIP .lt. MTRN)) then

C---Serial version of DO 116:

D        call trace_enter (2029) 
      DO 116 J=JMIN,JMAX,2
         I2K=NPTSD2
         JREV2=JREV+I2K
         IF(JREV2-(J+1)) 113,113,111
  111    DO 1110 MM=1,MTRN
            JREV2S=(MM-1)*MSKIP+JREV2*NSKIP
            JS=(MM-1)*MSKIP+(J+1)*NSKIP
            H=DATA(JREV2S+1)
            DATA(JREV2S+1)=DATA(JS+1)
            DATA(JS+1)=H
 1110    CONTINUE
         IF(JREV-J) 113,113,112
  112    DO 1120 MM=1,MTRN
            JREVS=JREV*NSKIP+(MM-1)*MSKIP
            JS=J*NSKIP+(MM-1)*MSKIP
            H=DATA(JREVS+1)
            DATA(JREVS+1)=DATA(JS+1)
            DATA(JS+1)=H
 1120    CONTINUE
  113    CONTINUE
  114    I2K=I2K/2
         JREV=JREV-I2K
         IF(JREV) 115,114,114
  115    JREV=JREV+2*I2K
  116 CONTINUE

D        call trace_exit (2030) 
      else

C---Parallel version of DO 116:

D        call trace_enter (2031) 
      CDOALL 9116 J=JMIN,JMAX,2
         INTEGER JREV, JREV2, I2K, JREVS, JS, JREV2S
         COMPLEX H(1:MTRN)
         INTEGER lastval, lastval2
         I2K=NPTSD2
         JREV = reflect(JMAX,J)
         JREV2=JREV+I2K
         IF(JREV2-(J+1)) 9113,9113,9111
 9111       JREV2S=JREV2*NSKIP
            JS=(J+1)*NSKIP
            lastval = (MTRN-1)*MSKIP+JREV2S
            lastval2 = (MTRN-1)*MSKIP+JS
            H(1:MTRN)=DATA(JREV2S+1:lastval:MSKIP)
            DATA(JREV2S+1:lastval:MSKIP)=DATA(JS+1:lastval2:MSKIP)
            DATA(JS+1:lastval2:MSKIP)=H(1:MTRN)
         IF(JREV-J) 9113,9113,9112
 9112       JREVS=JREV*NSKIP
            JS=J*NSKIP
            lastval = (MTRN-1)*MSKIP+JREVS
            lastval2 = (MTRN-1)*MSKIP+JS
            H(1:MTRN)=DATA(JREVS+1:lastval:MSKIP)
            DATA(JREVS+1:lastval:MSKIP)=DATA(JS+1:lastval2:MSKIP)
            DATA(JS+1:lastval2:MSKIP)=H(1:MTRN)
 9113    CONTINUE
 9116 CONTINUE

D        call trace_exit (2032) 
      endif
      GO TO 7777
  117 IERR=101
C
 7777 CONTINUE
C
      IF (LFIRST) THEN
        LFIRST = .FALSE.
        CALL CPUTIM (T2)
        TFTVMT = T2-T1
      END IF
C
      IF (LXSTEP) THEN
        IF (LXTIME) THEN
          LXTIME = .FALSE.
          CALL CPUTIM (T2)
          EFTVMT = T2-T1
        END IF
      END IF
C
      NFTVMT = NFTVMT+1
C
      RETURN
      END
C***********************************************************************
C
C     "CPUTIM" RETURNS ELAPSED USER (CPU) TIME, T, IN SECONDS, WHERE "T"
C     A REAL VARIABLE
C
C     ON THE CYBER205/ETA-10, THE INTRINSIC FUNCTION "SECOND()" IS REFER
C
C      SUBROUTINE CPUTIM (T)
C
C         REAL T
C         T = SECOND()
C
C      RETURN
C      END
C***********************************************************************
C
C     "ELAPSE" RETURNS ELAPSED WALL-CLOCK TIME, T, IN SECONDS
C
C     ON THE CYBER205 SYSTEM USE IS MADE OF THE SIL SUBROUTINE "Q5DCDMSC
C
C     FGPS 19-APR-88
C
C      SUBROUTINE ELAPSE (T)
C
C         REAL T
C         CALL Q5DCDMSC ('MILLSEC=',TELAPSED)
C         T = TELAPSED*1.0E-03
C
C      RETURN
C      END
      integer function gcd(mpar,npar)
      integer mpar,npar
      integer m,n

      if ((mpar .eq. 0) .or. 
     #    (npar .eq. 0)) then
                     gcd = 0
                     return
      endif

      if (mpar .lt. npar) then
                     m = npar
                     n = mpar
      else
                     m = mpar
                     n = npar
      endif

100   r = m - ((m / n)*n)
      if (r .eq. 0) then
                     gcd = n
                     return
      endif

      m = n
      n = r
      goto 100
      end
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:10:28
C***********************************************************************
      SUBROUTINE GSET (GMAPP)
      DIMENSION GMAPP(1)
      COMMON /PI/PI
      COMMON /NMBRS/NSKIP(4), N2P, NDUMY1(3)
      F = PI/REAL(N2P-1)
C
C GSET DEFINES THE MAPPING FUNCTION.
C
D        call trace_enter (2033) 
      DO 20 I = 1,N2P
20         GMAPP(I) = F*REAL(I-1)
D        call trace_exit (2034) 
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3 19 Dec 1990 14:39:08
C***********************************************************************
C
      SUBROUTINE IN (ARRAY,LOC,NW)
      COMMON /MEMORY/MEMSIZ, RM(165117)
      COMMON /TIMING/TXXXIN, TXXOUT, TXXRCS, TXXCSR, TXSCSC,
     X  TXACAC, TFTVMT, TXSHUF, TUSHUF, TXPRNT, TXLOG2, EXXRCS, EXXCSR,
     X  EXSCSC, EXACAC, EFTVMT, NXXXIN, NXXOUT, NXXRCS, NXXCSR, NXSCSC,
     X  NXACAC, NFTVMT, NXSHUF, NUSHUF, NXPRNT, NXLOG2
      DIMENSION ARRAY(1)
      LOGICAL   LFIRST
      INTEGER I1, I2, I3, I4, I5
      DATA      LFIRST /.TRUE./
C
      IF (LFIRST) CALL CPUTIM (T1)
C
      IF ((LOC .GE. 1) .AND. ((LOC + NW - 1) .LE. MEMSIZ) .AND. (NW
     X   .GE. 1)) THEN
      LOCM=LOC-1
D        call trace_enter (2035) 
      CDOALL 10 I1=0,numpro$()
       integer J1,J2,J3
       J1 = VOH$(1) + 1
       J2 = VLH$(NW)
       J3 = VIH$(1)
       ARRAY(J1:$J2:J3)=RM(J1+LOCM:$J2:J3)
   10 CONTINUE
C
D        call trace_exit (2036) 
      IF (LFIRST) THEN
        LFIRST = .FALSE.
        CALL CPUTIM (T2)
        TXXXIN = T2-T1
      END IF
C
      NXXXIN = NXXXIN+1
C
      RETURN
      END IF
C
  100 WRITE(6,101) LOC,NW
  101 FORMAT (///' IN: ILLEGAL REQUEST. LOCATION:',I22,
     1           ' ;   NUMBER OF WORDS:',I22,' ;  MEMSIZ:',I7)
      STOP
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:11:09
C***********************************************************************
      FUNCTION LCMREQ (LARGE)
      PARAMETER (LCMSIZ = 165117)
      COMMON /MEMORY/MEMSIZ, RM(LCMSIZ)
      IF (LARGE .LE. LCMSIZ) THEN
      MEMSIZ = LARGE
      LCMREQ = 1
      WRITE(6,100) LARGE
100   FORMAT (//' LCM REQUESTED:',I7,' WORDS',//)
      RETURN
      END IF
C
   10 WRITE(6,11) MEMSIZ,LARGE
   11 FORMAT (///' LCMREQ: REQUEST EXCEEDS MEMORY SIZE.'/
     1          ,' MEMORY SIZE:',I7,' ;   WORDS REQUESTED:',I22)
      STOP
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:11:25
C***********************************************************************
      SUBROUTINE MEAN (CA,U,G)
      DIMENSION U(1),G(1)
      COMPLEX CA(1)
      COMMON /NMBRS/NSKIP(4), N2P, NDUMY1(3)
D        call trace_enter (2037) 
      DO 10 I = 1,N2P
10         U(I) = -G(I)*REAL(CA(I))
D        call trace_exit (2038) 
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:11:39
C
C
C******NOTE: USE OF MACHINE-DEPENDENT CONSTANT: ZERO IN SUBROUTINE RUNIN
C
C            ZERO = 1.0E-200 (MAY HAVE TO REPLACE WITH YOUR MACHINES
C                             RELATIVE PRECISION FOR REAL DATA TYPE)
C
C                    THIS PROGRAM VERSION HAS BEEN SET UP AT PRINCETON B
C                    FRED SEIDL (I.E., "FGPS") FOR USE AS A PERFECT-CLUB
C                    BENCHMARK.   IT MAY BE NOTED THAT TIMING MEASUREMEN
C                    MAKE USE OF (1) THE CYBER205 INTRINSIC SCALAR FUNCT
C                    SECOND() AND OF (2) THE CYBER205 SYSTEM-INTERFACE-L
C                    UAGE CALL Q5DCDMSC('MILLSEC=',T),  WHERE "T" IS THE
C                    WALL-CLOCK TIME IN MILLISECONDS.  SECOND() AND Q5DC
C                    ARE EMBEDDED IN SUBROUTINES CPUTIM AND ELAPSE RESPE
C                    TIVELY.  MOREOVER, IN ORDER TO DISPLAY THE OBJECT M
C                    ULE SIZE AND LOAD MODULE SIZE (BY WAY OF THE LOG FI
C                    THE CYBER205 CONTROL STATEMENT "FILES." IS INCLUDED
C                    THE JCL.
C
C     FGPS 12-MAY-88 WHEN CODE IS USED AS A BENCHMARK, SET "RLAMDA = 1.0
C                    IN SUBROUTINE DATAST
C     FGPS 11-MAY-88 REMOVED SOME INCONSISTENCIES IN NORMALIZING THE FFT
C                    AND RESET EPS = 100. IN SUBROUTINE DATAST
C     FGPS  9-MAY-88 TIMING MEASUREMENTS ON DEALSE REPLACED BY MEASUREME
C                    ON FTRVMT (SEE "FGPS 10-MAR-88")
C     FGPS  4-MAY-88 MADE PROVISIONS TO MEASURE CPU EXECUTION TIMES DURI
C                    THE LAST TIMESTEP FOR SUBROUTINES RCS, CSR, SCSC, A
C     FGPS 29-APR-88 REPLACED FUNCTION LOG2 (NA) BY SUBROUTINE XLOG2 (NA
C     FGPS 15-APR-88 INCREASED THE INITIAL AMPLITUDE PRESCRIBED FOR THE
C                    STREAMFUNCTION BY *50 (I.E., EPS = 50.0 IN DATAST)
C     FGPS 15-APR-88 THIS VERSION OF THE SOURCE HAS,  IN A WAY CONSISTEN
C                    WITH THE PRESCRIBED PARAMETERS, ALL NONTRIVIAL UNRE
C                    ERENCED MODULES COMMENTED OUT USING THE FLAG "C2%2"
C                    WHERE C IS LOCATED IN COLUMN 1
C     FGPS 14-APR-88 WHILE IN USE AS A BENCHMARK-TEST CODE, CERTAIN STAT
C                    MENTS HAVE BEEN COMMENTED OUT.  IN PARTICULAR, CALL
C                    TO LUMULT2 AND SOLVE2 WHERE THESE ARE HANDLED AS DY
C                    NAMIC EXTERNALS ARE NOT TO BE MADE. TO FACILITATE R
C                    TORATION OF THE DETACHED PROGRAMMING,  THE CHARACTE
C                    STRING C2%2, WHERE C IS PLACED IN COLUMN 1, HAS BEE
C                    USED TO TRANSFORM STATEMENTS INTO COMMENT LINES
C     FGPS  8-APR-88 INTRODUCED SUBROUTINE RPRNT2 (A MODIFIED VER-
C                    SION OF RPRINT), WHICH AT INTERVALS PRINTS THE
C                    TEMPERATURE AT THE CENTER OF THE FIRST CONVECTION
C                    CELL SO THAT THIS QUANTITY CAN BE USED TO MONITOR
C                    CODE EXECUTION
C     FGPS  5-APR-88 FUNCTION LCMREQ (LARGE) CONTAINS
C                      PARAMETER (LCMSIZ=165117)
C                      COMMON /MEMORY/ MEMSIZ,RM(LCMSIZ)
C                    ELSEWHERE RESET RM(25000)==>RM(165117)
C     FGPS  4-APR-88 MOVED THE CALLS TO SUBROUTINE PSIPHY AND COR-
C                    RECTED FOR ANY CHANGES MADE TO THE STREAMFUNC-
C                    TION IN CALLING PSIPHY BY CALLING IN (CA,LPN,
C                    NW) BEFORE AND AFTER CALLING PSIPHY
C     FGPS  2-APR-88 REWROTE SUBROUTINE PSIPHY
C     FGPS 29-MAR-88 ADDED SUBROUTINES SHUF, UNSHUF, AND RPRINT TO
C                    THE LIST SUBJECT TO MEASUREMENTS OF EXECUTION
C                    TIME AND NUMBER-OF-CALLS-TO
C     FGPS 15-MAR-88 MODIFIED SUBROUTINE RPRINT(ARRAY,NAME,N1H,N2PD,IMOD
C                    AND REFERENCING SUBROUTINES SO AS TO ALLOW SELECTIO
C                    OF ONE OF THREE ALTERNATIVE PRINT FORMATS ACCORDING
C                    TO IMODE = -1,0,+1
C     FGPS 10-MAR-88 MEASUREMENTS OF CPU EXECUTION TIME PER CALL AND
C                    OF THE CUMULATIVE NUMBER OF CALLS WERE ADDED TO THE
C                    SUBROUTINES:  IN, OUT, RCS, CSR, SCSC, ACAC, DEALSE
C                    MEASURED VALUES ENTERED INTO THE MAIN PROGRAM VIA
C                    COMMON /TIMING/, AND PRINTED OUT FROM THERE.  LATER
C                    (9-MAY-88), MEASUREMENTS ON DEALSE REPLACED BY FTRV
C     FGPS  8-MAR-88 REPROGRAMMED SUBROUTINE RPRINT SO AS TO PRINT OUT
C                    QUANTITIES REPRESENTED IN PHYSICAL (OR REAL) SPACE
C     FGPS 12-FEB-88 ONLY UNUSED MODULES IN THIS VERSION ARE DATE AND
C                    TIME.  ALSO, SUBR. PLOTME COMMENTED "C" OUT
C     FGPS 10-FEB-88 INSERTED "COMPLEX EX(1)" INTO SUBROUTINE TEMPHY
C     FGPS 9-FEB-88  DELETED EXTRA LISTINGS OF SUBROUTINE EXSET AND
C                    FUNCTION LOG2
C     FGPS 4-DEC-87  TEMPORARILY COMMENTED OUT (I.E., "C") CALLS TO SUB-
C                    ROUTINE PLOTME
C     FGPS PRIOR TO DEC-87 THE USE OF "*" AS A DELIMITER IN FORMAT
C                    STATEMENTS WAS REPLACED BY THE SINGLE QUOTE
C
C***********************************************************************
C                        OCEAN FORTRAN PROGRAMS
C                        CREATION DATE: 3/22/81
C***********************************************************************
      PROGRAM OCEAN
C
C  D(Z)/DT + (U,V).GRAD(Z) = RNU*DELSQ(Z) + ALPHA*D(TEMP)/DX
C
C  D(TEMP)/DT + (U,V).GRAD(TEMP) = RKAPA*DELSQ(TEMP) + BETA*V
C
C
C
C THIS PROGRAM SIMULATES TWO-DIMENSIONAL FLUID FLOW ON A   (N2+1) * N1
C GRID. IT IS POSSIBLE TO SPECIFY NON-LINEAR DISTRIBUTION OF DATA POINTS
C THE Y-DIRECTION (THE FIRST INDEX CORRESPONDS TO Y DIRECTION, SECOND TO
C X DIRECTION). N1 AND N2 HAVE TO BE POWERS OF TWO GREATER OR EQUAL TO 8
C
C THE PROGRAM USES LARGE CORE MEMORY. IT REQUIRES 8*(N2+1)*N1+(N2-1)*(N2
C WORDS OF IT. IF NOTEMP = 1 IT IS POSSIBLE TO SAVE 2*(N2+1)*N1 WORDS,
C IF LMAPP = 1 YOU SAVE ADDITIONAL (N2-1)*(N2+1) WORDS.
C
C IF  LMAPP = 2 , LCM REQUIREMENTS ARE AT LEAST  3 * (N2-1) * (N2-1)
C MORE MEMORY COULD BE NEEDED IN THIS CASE BECAUSE OF EIGSET AND LCMRQR.
C
C
C FOR CDC7600 RUNS: DELETE ROUTINES LCMREQ, IN AND OUT FROM THE END OF
C                   THIS PACKAGE. ON CDC7600 THE LCM IS USED THROUGH
C                   THE ASSEMBLY ROUTINES.
C
C                   LIBRARY.
C FOR CRAY-1 RUNS : DELETE ROUTINES SECOND, DATE, TIME, EXSET AND
C                   LOG2 FROM THE END OF THIS PACKAGE. THEY ARE
C                   OBTAINED AT LOAD TIME FROM CRAY LIBRARIES AND
C                   FFTLIB.
C                   ALSO, ADJUST THE SIZE OF PARAMETER LCMSIZ IN
C                   THE ROUTINE LCMREQ SO THAT THE COMMON IS LARGE
C                   ENOUGH TO EMULATE CDC7600 LCM REQUIRED FOR THE RUN.
C
C THE FOLLOWING PARAMETERS DEFINE THE SIZE OF THE RUN:
C
      PARAMETER (NX=128, NY=128)
      PARAMETER (NA1=2*(NY+1),NA2=NX/2,NE=NY-1,NW1=NY+1)
      PARAMETER (NW2=128,NEX=256)
      PARAMETER (NI=2*NY-1,NEQ=3*NY-2,NCW2=2*NW1+1,NCW3=4*NW1+1)
C
C PLEASE REFER TO THE DIMENSIONING AND EQUIVALENCING INSTRUCTIONS IN
C THE CASE YOUR COMPILER CANNOT HANDLE PARAMETER STATEMENTS...
C COMMON BLOCKS:
C
      COMMON /FT/NPTS, NSKIP, MTRN, MSKIP, ISIGN, LOG, IEXSHF
C
C THE DIMENSION OF  GSOLV  HAS TO BE AT LEAST (N2-1)
C
      COMMON /SOLV/LVECT, LSKIP, NVECT, NVSKIP, GSOLV(127)
C
C THE DIMENSIONS OF  GMAPP  AND  G  HAVE TO BE AT LEAST (N2+1)
C
      COMMON /MAPING/GMAPP(129), G(129)
      COMMON /MFLOW/U(129)
      COMMON /DATA/ALPHA, BETA, BOXX, H, RNU, RKAPA, DT, DTT, T
     X  , NSTEPS
      COMMON /OPTONS/N1, N2, NUMBER, KDATA, LMAPP, NOTEMP, KTA,
     X     KTAPE, KSM, KPP, KZP, KTP, KUP, KVP, KPF, KZF, KTF, KUF, KVF
     X     , KPRESS, NOALS
      COMMON /PI/PI
      COMMON /NMBRS/N1H, N1Q, N1E, N2M, N2P, N2DP, N2DM, N2PD
      COMMON /EXSIZE/NMAX2
      COMMON /LADDR/LZN, LTN, LPN, LZO, LTO, LPY, LZX, LZY, LEIG
     X  , LE, LH, LEV
      COMMON /TIMING/TXXXIN, TXXOUT, TXXRCS, TXXCSR, TXSCSC,
     X  TXACAC, TFTVMT, TXSHUF, TUSHUF, TXPRNT, TXLOG2, EXXRCS, EXXCSR,
     X  EXSCSC, EXACAC, EFTVMT, NXXXIN, NXXOUT, NXXRCS, NXXCSR, NXSCSC,
     X  NXACAC, NFTVMT, NXSHUF, NUSHUF, NXPRNT, NXLOG2
C
C
C COMPLEX ARRAYS HAVE TO BE DIMENSIONED EXACTLY AS THE FORMULAS SAY:
C            CA        (N2+1) X N1/2
C            CWORK     N2+1
C            CWORK2    N2+1
C            CWORK3    N2+1
C            EX        MAX(2*N2, N1)
C
C EX ARRAY MUST NOT BE THE FIRST ARRAY IN THE MEMORY.
C
      COMPLEX CA(NW1,NA2), CWORK(NW1), CWORK2(NW1)
      COMPLEX CWORK3(NW1), EX(NEX), CF
C
C REAL ARRAYS HAVE TO BE DIMENSIONED EXACTLY AS THE FORMULAS SAY:
C            A      2*(N2+1) X N1/2
C            E      (N2-1)   X (N2-1)
C            WORK   N2+1     X MAX(6, 2*MIN(64, N1/2))   (AT LEAST)
C            EVAL   N2-1
C            IR     N2-1
C            IC     N2-1
C
      REAL A(NA1,NA2), E(NE,NE)
      REAL WORK(NW1*NW2)
      REAL EVAL(NE), IR(NE), IC(NE)
      INTEGER VALID
C
C EQUIVALENCE STATEMENTS ARE SAVING MEMORY SPACE. THE FOLLOWING PATTERN
C HAS TO BE FOLLOWED EXACTLY:
C
C     A-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
C     CA+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
C     EVAL+-+IR-+-+-IC+-+-+E+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
C
C
C     WORK+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
C     CWORK-+-+-+CWORK2-+-+-CWORK3+-+-+
C
C      EQUIVALENCE (A,CA,EVAL), (A(NY),IR), (A(NI),IC), A(NEQ),E) - ORGINAL
C      EQUIVALENCE (A,CA,EVAL), (EVAL(NY),IR), (EVAL(NI),IC),
C     *             (EVAL(NEQ),E) - MACFARLANE'S FIX. BAD.
C POINTER'S FIX. ANSI REQUIRES THAT THE NUMBER OF SUBSCRIPTS MATCH
C THE NUMBER OF DIMENSIONS OF THE ARRAY. THAT WAS THE PROBLEM WITH
C THE ORGINAL STATEMENT. THE PROBLEM WITH MACFARLANE'S FIX IS THAT
C NY,NI,NEQ>NE (THE DIMENSION OF EVAL). HERE 3*NE+1-NA1 IS THE 3*NE+1TH
C ELEMENT OF A AND 3*NE+1 = NEQ.
      EQUIVALENCE (A,CA,EVAL), (A(NY,1),IR), (A(NI,1),IC),
     *            (A(3*NE+1-NA1,2),E)
      EQUIVALENCE (WORK,CWORK), (WORK(NCW2),CWORK2), (WORK(NCW3),CWORK3)
      COMMON /VERIFY/VDAT(15), CDAT(15)
C
C NOW WE CAN START WITH THE PROGRAM...
C SUBROUTINE START TELLS OCEAN WHAT TO DO:
C
 
      CALL CPUTIM (CPU1)
      CALL ELAPSE (TCLCK1)
D     CALL INIT_TRACE(1)     
      OPEN(1,FILE='OCV')
      OPEN(6,FILE='OCO6')
      WRITE(1,9991)
9991  FORMAT(1X,'OUTPUT FOR PERFECT CLUB BENCHMARK: OCEAN'/
     *       1X,'$Revision: 1.8 $ $Author: kipp $'/)
 
      CALL START (NX,NY)
C
C IF  LMAPP = 1 , H  (THE SIZE OF THE BOX IN Y DIRECTION)  SHOULD BE
C SPECIFIED IN THE MAIN PROGRAM.
C
      H = PI
C
C DEFINING CONSTANTS THAT WILL BE NEEDED:
C
      N1H = N1/2
      N1Q = N1/4
      N1E = N1/8
      N2M = N2-1
      N2P = N2+1
      N2DP = 2*N2+1
      N2DM = 2*N2-1
      N2PD = 2*N2P
      NW = N2PD*N1H
      NWH = NW/2
      NWQ = NW/4
      NWEIG = N2M
      IF (LMAPP .NE. 1) NWEIG = (N2M+3)*N2M
      NMAX2 = MAX(2*N2,N1)
      K1Q = N1E+1
      K2Q = K1Q+N1E
      K3Q = K2Q+N1E
      K1QM = K1Q-1
      K2QM = K2Q-1
      K3QM = K3Q-1
C
C LCM ALLOCATION AND COMPUTATION OF ADDRESSES:
C
      LARGE = 8*NW
      IF (NOTEMP .EQ. 1) LARGE = 6*NW
      IF (LMAPP .EQ. 2) THEN
C
      IF (KPRESS .GT. 1) THEN
      LARGE = MAX (LARGE, 3 * N2M * N2M) + NWEIG + NWEIG
      ELSE
      LARGE = MAX (LARGE + NWEIG, 3 * N2M * N2M)
      END IF
      ELSE
C
   66 LARGE = LARGE + NWEIG
      END IF
C
   67 LZN = LCMREQ (LARGE)
      LTN = LZN+NW
      IF (NOTEMP .EQ. 1) LTN = LZN
      LPN = LTN+NW
      LZO = LPN+NW
      LTO = LZO+NW
      IF (NOTEMP .EQ. 1) LTO = LZO
      LPY = LTO+NW
      LZX = LPY+NW
      LZY = LZX+NW
      LPRESS = LZN + LARGE - NWEIG
      LEIG = LPRESS
      IF ((KPRESS .GT. 1) .AND. (LMAPP .NE. 1)) LEIG = LPRESS - NWEIG
C
C THESE LCM ADDRESSES ARE USED BY EIGSET AND LCMRQR
C
      LE = LZN
      LH = LE + N2M*N2M
      LEV = LH + N2M*N2M
C
      CALL EXSET (EX,NMAX2)
C
C SET ALL  U(I) TO 0. TO AVOID TROUBLE IF NO MEAN FLOW IS DESIRED
C
D        call trace_enter (2039) 
      DO 11 I = 1,N2P
11         U(I) = 0.
C
C SET UP ARRAYS ASSOCIATED WITH THE MAPPING FUNCTION:
C
D        call trace_exit (2040) 
      IF (LMAPP .EQ. 1) THEN
C
C LINEAR MAPPING - EIGENVALUES KNOWN, EIGENFUNCTIONS ARE SIMPLY SINES
C AND COSINES, SO THAT NO MATRICES ARE NEEDED:
C
           F = H/REAL(N2)
           FZ = PI/H
           FZSQ = FZ*FZ
           GMAPP(1) = 0.
           G(1) = FZ
D        call trace_enter (2041) 
           DO 1 I = 1,N2M
                GMAPP(I+1) = F*REAL(I)
                G(I+1) = FZ
1               EVAL(I) = -(REAL(I)**2)*FZSQ
D        call trace_exit (2042) 
           GMAPP(N2P) = H
           G(N2P) = FZ
           CALL OUT (EVAL,LEIG,NWEIG)
           GO TO 4
           ELSE
2     IF (LMAPP .NE. 2) GO TO 3
      END IF
C2%2C
C2%2C NONLINEAR MAPPING - FIND OUT WHAT IS IT AND SET UP THE VISCOUS MAT
C2%2C
C2%2           CALL GSET (GMAPP)
C2%2           CALL EIGSET (CA,G,GMAPP,CWORK,EX,EVAL,IR,IC,E,N2M)
C2%2C
C2%2C SET UP THE PRESSURE MATRIX:
C2%2C
C2%2           IF (KPRESS .GT. 1)  CALL PRESSET (CA, G, GMAPP, CWORK, EX
C2%2     1                                   EVAL, IR, IC, E, N2M, LPRES
C2%2           GO TO 4
3     CONTINUE
C2%2      IF (LMAPP .NE. 3) STOP
C2%2           CALL EIGIN (EVAL,IR,IC,E,G,GMAPP)
4     CONTINUE
C2%2      IF ((LMAPP .EQ. 2) .AND. ((KTAPE .EQ. 1) .OR. (KTAPE .EQ. 3)))
C2%2     1       CALL EIGOUT (EVAL,IR,IC,E,G,GMAPP)
C
C READ THE DATA:
C
      IF ((KDATA .EQ. 1) .OR. (KDATA .EQ. 2)) THEN
           CALL DATAST (A,N2P,N1,GMAPP)
           GO TO 14
           END IF
13    CONTINUE
C2%2      IF (KDATA .NE. 3) STOP
C2%2           CALL DATAIN (A,WORK)
14    CONTINUE
C2%2      IF ((KDATA .EQ. 3) .AND. ((KTAPE .EQ. 2) .OR. (KTAPE .EQ. 3)))
C2%2     1       CALL DATAOUT (A,WORK)
      FX = 2.0*PI/BOXX
      FX2 = 2.*FX
C
C PREPARE THE INPUT FOR PROCESSING:
C
      IF (KDATA .EQ. 1) THEN
C
C THE INPUT WAS STREAMFUNCTION IN PHYSICAL SPACE - SHUFFLE THE DATA AND
C GO TO FOURIER SPACE:
C
           CALL IN (A,LPN,NW)
           CALL SHUF (A,N2P,N1,WORK)
           NPTS = N1
           NSKIP = N2P
           MTRN = N2P
           MSKIP = 1
           ISIGN = -1
           CALL XLOG2 (NPTS,LOG)
           IEXSHF = NMAX2/NPTS
           CALL RCS (A,EX)
           NPTS = 2*N2
           NSKIP = 1
           MTRN = N1H
           MSKIP = N2P
           ISIGN = -1
           CALL XLOG2 (NPTS,LOG)
           IEXSHF = NMAX2/NPTS
           CALL ACAC (A,EX,WORK)
C           F = 0.125/REAL(N1*N2)
           F = 0.0625/REAL(N1*N2)
D        call trace_enter (2043) 
           DO 30 J = 1,N1H
                DO 30 I = 1,N2PD
30                   A(I,J) = A(I,J)*F
D        call trace_exit (2044) 
           CALL OUT (A,LPN,NW)
           CALL OUT (A,LZN,NW)
           END IF
C
CC*****C H E C K   F O U R I E R   C O E F F I C I E N T S**************
C
C         WRITE (6,7010) A(1,1),A(1,2),A(1,3)
C         WRITE (6,7020) A(2,1),A(2,2),A(2,3)
C         WRITE (6,7030) A(3,1),A(3,2),A(3,3)
C 7010    FORMAT(/2X,26HCHECK FOURIER COEFFICIENTS/4X,8HA(1,1) =,1PE13.6
C     1   2X,8HA(1,2) =,1PE13.6,2X,8HA(1,3) =,1PE13.6)
C 7020    FORMAT(4X,8HA(2,1) =,1PE13.6,2X,8HA(2,2) =,1PE13.6,2X,
C     1   8HA(2,3) =,1PE13.6)
C 7030    FORMAT(4X,8HA(3,1) =,1PE13.6,2X,8HA(3,2) =,1PE13.6,2X,
C     1   8HA(3,3) =,1PE13.6/)
C
C
   40 IF (KDATA .NE. 3) THEN
C                                                     2
C STREAMFUNCTION KNOWN - FIND THE VORTICITY:  Z =  DEL  (PSI):
C
           CALL IN (EVAL,LEIG,NWEIG)
           KZN = LZN
           LVECT = N2M
           LSKIP = 2
           NVECT = 2
           NVSKIP = 1
D        call trace_enter (2045) 
           DO 60 J = 1,N1H
                CALL IN (CWORK,KZN,N2PD)
C2%2                IF (LMAPP .NE. 1) CALL SOLVE2 (CWORK(2),E,N2M,IR,IC)
                F = REAL((J-1)*(J-1))*FX*FX
                DO 50 I = 2,N2
50                   CWORK(I) = (EVAL(I-1)-F)*CWORK(I)
C2%2                IF (LMAPP .NE. 1) CALL LUMULT2 (CWORK(2),E,N2M,IR,IC
                CWORK(1) = -F*CWORK(1)
                CWORK(N2P) = 0.0
                CALL OUT (CWORK,KZN,N2PD)
60              KZN = KZN+N2PD
D        call trace_exit (2046) 
           NPTS = 2*N2
           NSKIP = 1
           MTRN = N1H
           MSKIP = N2P
           ISIGN = 1
           CALL XLOG2 (NPTS,LOG)
           IEXSHF = NMAX2/NPTS
           CALL IN (A,LZN,NW)
           CALL ACAC (A,EX,WORK)
D        call trace_enter (2047) 
           DO 70 J = 1,N1H
                DO 70 I = 1,N2PD
70                   A(I,J) = 0.5*A(I,J)
D        call trace_exit (2048) 
           CALL OUT (A,LZO,NW)
      IF (NOTEMP .NE. 1) THEN
      IF (KDATA .EQ. 1) THEN
C
C TEMPERATURE IS SUPPLIED IN PHYSICAL SPACE - SHUFFLE THE DATA AND
C GO TO FOURIER REPRESENTATION:
C
           CALL IN (A,LTN,NW)
           CALL SHUF (A,N2P,N1,WORK)
           NPTS = N1
           NSKIP = N2P
           MTRN = N2P
           MSKIP = 1
           ISIGN = -1
           CALL XLOG2 (NPTS,LOG)
           IEXSHF = NMAX2/NPTS
           CALL RCS (A,EX)
           F = 0.5/REAL(N1)
D        call trace_enter (2049) 
           DO 100 J = 1,N1H
                DO 100 I = 1,N2PD
100                  A(I,J) = F*A(I,J)
D        call trace_exit (2050) 
           CALL OUT (A,LTO,NW)
           NPTS = 2*N2
           NSKIP = 1
           MTRN = N1H
           MSKIP = N2P
           ISIGN = -1
           CALL XLOG2 (NPTS,LOG)
           IEXSHF = NMAX2/NPTS
           CALL ACAC (A,EX,WORK)
C           F = 0.25/REAL(N2)
           F = 0.125/REAL(N2)
D        call trace_enter (2051) 
           DO 110 J = 1,N1H
                DO 110 I = 1,N2PD
110                  A(I,J) = F*A(I,J)
D        call trace_exit (2052) 
           CALL OUT (A,LTN,NW)
           ELSE
120        CALL IN (A,LTN,NW)
C
C NEW TEMPERATURE KNOWN - SET UP T(OLD):
C
           NPTS = 2*N2
           NSKIP = 1
           MTRN = N1H
           MSKIP = N2P
           ISIGN = 1
           CALL XLOG2 (NPTS,LOG)
           IEXSHF = NMAX2/NPTS
           CALL ACAC (A,EX,WORK)
D        call trace_enter (2053) 
           DO 130 J = 1,N1H
                DO 130 I = 1,N2PD
130                  A(I,J) = A(I,J)*0.5
D        call trace_exit (2054) 
           CALL OUT (A,LTO,NW)
           END IF
           END IF
140   T = 0.
      DTT = DT
      NSTEPS = 1
      END IF
145   CALL RUNINF
      CALL BUG (10HAFT INITAL)
C
C THIS IS THE BEGINNING OF THE TIME STEP.
C
150   IF ((MOD(NSTEPS, KTF) .EQ. 1) .AND. (NOTEMP .NE. 1))
     1                             CALL TEMPFO (CA,N2P,N1H,CWORK)
      IF (MOD(NSTEPS, KPF) .EQ. 1) CALL PSIFOU  (CA,N2P,N1H,CWORK)
      IF (MOD(NSTEPS, KZF) .EQ. 1) CALL ZETAFO (CA,N2P,N1H,CWORK)
      IF (MOD(NSTEPS, KVF) .EQ. 1) CALL VVELFO (CA,N2P,N1H,FX,CWORK)
      IF (MOD (NSTEPS + 1, KTA) .EQ. 1) THEN
C
C TIME AVERAGE VORTICITY:
C
           DTT = DT
           T = T-0.5*DT
           CALL IN (A,LZO,NW)
           NPTS = 2*N2
           NSKIP = 1
           MTRN = N1H
           MSKIP = N2P
           ISIGN = -1
           IEXSHF = NMAX2/NPTS
           CALL XLOG2 (NPTS,LOG)
           CALL ACAC (A,EX,WORK)
           F = 0.125/REAL(N2)
D        call trace_enter (2055) 
           DO 160 J = 1,N1H
                DO 160 I = 1,N2PD
160                  A(I,J) = A(I,J)*F
D        call trace_exit (2056) 
           CALL OUT (A,LZO,NW)
           ISIGN = 1
           MTRN = N1Q
           KZN = LZN
           KZO = LZO
D        call trace_enter (2057) 
           DO 180 K = 1,2
                CALL IN (A,KZO,NWH)
                CALL IN (A(1,K2Q),KZN,NWH)
                DO 170 J = 1,N1Q
                     K2QJ = J+K2QM
                     DO 170 I = 1,N2PD
170                       A(I,J) = A(I,J)+0.5*A(I,K2QJ)
                CALL OUT (A,KZN,NWH)
                CALL ACAC (A,EX,WORK)
                DO 175 J = 1,N1Q
                     DO 175 I = 1,N2PD
175                       A(I,J) = 0.5*A(I,J)
                CALL OUT (A,KZO,NWH)
                KZO = KZO+NWH
180             KZN = KZN+NWH
D        call trace_exit (2058) 
      IF (NOTEMP .NE. 1) THEN
C
C TIME AVERAGE TEMPERATURE:
C
           ISIGN = -1
           MTRN = N1H
           CALL IN (A,LTO,NW)
           CALL ACAC (A,EX,WORK)
           F = 0.125/REAL(N2)
D        call trace_enter (2059) 
           DO 190 J = 1,N1H
                DO 190 I = 1,N2PD
190                  A(I,J) = F*A(I,J)
D        call trace_exit (2060) 
           CALL OUT (A,LTO,NW)
           ISIGN = 1
           MTRN = N1Q
           KTO = LTO
           KTN = LTN
D        call trace_enter (2061) 
           DO 210 K = 1,2
                CALL IN (A,KTO,NWH)
                CALL IN (A(1,K2Q),KTN,NWH)
                DO 200 J = 1,N1Q
                     K2QJ = J+K2QM
                     DO 200 I = 1,N2PD
200                       A(I,J) = A(I,J)+0.5*A(I,K2QJ)
                CALL OUT (A,KTN,NWH)
                CALL ACAC (A,EX,WORK)
                DO 205 J = 1,N1Q
                     DO 205 I = 1,N2PD
205                       A(I,J) = 0.5*A(I,J)
                CALL OUT (A,KTO,NWH)
                KTO = KTO+NWH
210             KTN = KTN+NWH
D        call trace_exit (2062) 
                END IF
                END IF
C
C THE BEGINING OF A NORMAL TIME STEP
C (U IS X VELOCITY AND V IS Y VELOCITY)
C FIND (-U) = D(PSI)/DY
C
211   CONTINUE
C
      IF (NSTEPS.LT.3) THEN
         CALL IN (CA,LPN,NW)
         CALL PSIPHY (CA,N2P,N1H,EX,G,U,WORK,CWORK3,+1)
      ELSE
         CALL IN (CA,LPN,NW)
         IF (MOD (NSTEPS , KPP) .EQ. 1) CALL PSIPHY (CA,N2P,N1H,EX,G,
     1                                              U,WORK,CWORK3,-1)
      END IF
C
      NPTS = 2*N2
      NSKIP = 1
      MTRN = N1H
      MSKIP = N2P
      ISIGN = 1
      CALL XLOG2 (NPTS,LOG)
      IEXSHF = NMAX2/NPTS
      CALL IN (CA,LPN,NW)
      F = 0.
D        call trace_enter (2063) 
      DO 230 I = 1,N2
           DO 220 J = 1,N1H
220             CA(I,J) = CMPLX(-F*AIMAG(CA(I,J)), F*REAL(CA(I,J)))
230        F = F+1.
D        call trace_exit (2064) 
D        call trace_enter (2065) 
      DO 235 J = 1,N1H
235        CA(N2P,J) = 0.
D        call trace_exit (2066) 
      CALL SCSC (CA,EX,WORK)
      CALL OUT (CA,LPY,NW)
      IF (KSM .EQ. 1) CALL MEAN (CA,U,G)
      IF (MOD(NSTEPS, KUF) .EQ. 1) CALL UVELFO (CA,N2P,N1H,G,EX,CWORK)
      CALL IN (CA,LPN,NW)
C
C FIND  V = D(PSI)/DX
C
      F = 0.
D        call trace_enter (2067) 
      DO 250 J = 1,N1H
           DO 240 I = 1,N2P
240             CA(I,J) = CMPLX(-F*AIMAG(CA(I,J)), F*REAL(CA(I,J)))
250        F = F+FX
D        call trace_exit (2068) 
      CALL ACAC (CA,EX,WORK)
      CALL OUT (CA,LPN,NW)
      IF ((MOD(NSTEPS, KPP) .EQ. 1) .AND. (NOTEMP .NE. 1))
     1                              CALL IN (CA,LPN,NW)
      NPTS = 2*N2
      NSKIP = 1
      MTRN = N1H
      MSKIP = N2P
      ISIGN = 1
      CALL XLOG2 (NPTS,LOG)
      IEXSHF = NMAX2/NPTS
      IF (NOTEMP .NE. 1) THEN
C
C T(TOTAL) = T-BETA*Y
C WHERE BETA < 0 MEANS   STABLE STRATIFICATION AND
C       BETA > 0 MEANS UNSTABLE STRATIFICATION
C
           KTO = LTO
           DTB = 0.5*BETA*DTT
D        call trace_enter (2069) 
           CDOALL 270 J = 1,N1H
                INTEGER KTO
                REAL F
                COMPLEX CWORK(NW1)
                KTO = LTO + (J-1)*N2PD
                CALL IN (CWORK,KTO,N2PD)
                F = -REAL(J-1)*FX*DTT*0.25
260               CWORK(1:N2P) = 
     *                  CWORK(1:N2P)*CMPLX(1., U(1:N2P)*F)+
     1                  DTB*CA(1:N2P,J)
                CALL OUT (CWORK,KTO,N2PD)
270             CONTINUE
D        call trace_exit (2070) 
                END IF
271   CALL IN (CA,LZN,NW)
C
C FIND DZ/DY:
C
      F = 0.
D        call trace_enter (2071) 
      CDOALL 280 J = 1,N1H
280        CA(1:N2,J) = CMPLX(-REAL(<0:(N2-1)>)*AIMAG(CA(1:N2,J)),
     *                         REAL(<0:(N2-1)>)*REAL(CA(1:N2,J)))
D        call trace_exit (2072) 
D        call trace_enter (2073) 
      DO 295 J = 1,N1H
295        CA(N2P,J) = 0.
D        call trace_exit (2074) 
      CALL SCSC (CA,EX,WORK)
      CALL OUT  (CA,LZY,NW)
      CALL IN   (CA,LZN,NW)
      CALL ACAC (CA,EX,WORK)
D        call trace_enter (2075) 
      CDOALL 300 J = 1,N1H
300             CA(1:N2P,J) = CA(1:N2P,J)*0.5
D        call trace_exit (2076) 
      CALL OUT (CA,LZN,NW)
      NPTS = N1
      NSKIP = N2P
      MTRN = N2P
      MSKIP = 1
      ISIGN = 1
      CALL XLOG2 (NPTS,LOG)
      IEXSHF = NMAX2/NPTS
      IF (MOD(NSTEPS, KZP) .EQ. 1) CALL ZETAPH (CA,N2PD,N1H,EX,WORK,-1)
      IF (MOD(NSTEPS, KZP) .EQ. 1) CALL IN (CA,LZN,NW)
C
C FIND DZ/DX:
C
      F = 0.
D        call trace_enter (2077) 
      CDOALL 320 J = 1,N1H
           REAL F
           F = (J-1)*FX2
310             CA(1:N2P,J) = CMPLX(-F*AIMAG(CA(1:N2P,J)), 
     *                               F*REAL(CA(1:N2P,J)))
320        CONTINUE
D        call trace_exit (2078) 
      CALL CSR (CA,EX)
      CALL OUT (CA,LZX,NW)
      CALL IN  (CA,LZY,NW)
      CALL CSR (CA,EX)
      CALL OUT (CA,LZY,NW)
      CALL IN  (CA,LPN,NW)
      CALL CSR (CA,EX)
      CALL OUT (CA,LPN,NW)
      CALL IN  (CA,LPY,NW)
      CALL CSR (CA,EX)
      CALL OUT (CA,LPY,NW)
C
C WE ARE IN PHYSICAL SPACE NOW - FIND  (U,V).GRAD (Z):
C
      IF (MOD(NSTEPS, KUP) .EQ. 1) CALL UVELPH (A,N2PD,N1H,WORK,-1)
      IF (MOD(NSTEPS, KVP) .EQ. 1) CALL VVELPH (A,N2PD,N1H,WORK,-1)
      KPY = LPY
      KPN = LPN
      KZY = LZY
      KZX = LZX
      UKSM1F = REAL(2-KSM)
D        call trace_enter (2079) 
      DO 340 K = 1,4
           CALL IN (A,KPY,NWQ)
           CALL IN (A(1,K1Q),KPN,NWQ)
           CALL IN (A(1,K2Q),KZY,NWQ)
           CALL IN (A(1,K3Q),KZX,NWQ)
           CDOALL 330 J = 1,N1E
                A(1:N2PD,J) = A(1:N2PD,J)*G(<2:(N2PD+1)>/2) +
     *            U(<2:(N2PD+1)>/2)*UKSM1F
                A(1:N2PD,K2QM+J) = A(1:N2PD,J)*A(1:N2PD,K3QM+J) -
     *            A(1:N2PD,K1QM+J)*A(1:N2PD,K2QM+J)*G(<2:(N2PD+1)>/2)
330        CONTINUE
           CALL OUT (A,KPY,NWQ)
           CALL OUT (A(1,K2Q),KZY,NWQ)
           KPN = KPN+NWQ
           KPY = KPY+NWQ
           KZX = KZX+NWQ
340        KZY = KZY+NWQ
C
C [Z(OLD) + (MEAN -U) * (-DZ(OLD)/DX)] + (U,V).GRAD(Z)
C
D        call trace_exit (2080) 
      ISIGN = -1
      CALL IN  (A,LZY,NW)
      CALL RCS (A,EX)
      CALL OUT (A,LZY,NW)
      KZO = LZO
      KZN = LZN
      KZY = LZY
      DTFAC = 0.125*DTT/REAL(N1)
      F1 = DTT*FX*0.25
      F = F1
D        call trace_enter (2081) 
      DO 360 K = 1,2
           CALL IN  (CA,KZO,NWH)
           CALL IN  (CA(1,K2Q),KZN,NWH)
           CALL OUT (CA(1,K2Q),KZO,NWH)
           CALL IN  (CA(1,K2Q),KZY,NWH)
           CDOALL 350 J = 1,N1Q
                INTEGER K2QJ
                REAL F
                K2QJ = J+K2QM
                if (K .eq. 1) then
                    F = (1-J)*F1
                else
                    F = (1-J-N1Q)*F1
                endif
350                  CA(1:N2P,J) = CA(1:N2P,J)*CMPLX(1.,F*U(1:N2P))+
     *                    DTFAC*CA(1:N2P,K2QJ)
           CALL OUT (CA,KZN,NWH)
           KZN = KZN+NWH
           KZO = KZO+NWH
360        KZY = KZY+NWH
D        call trace_exit (2082) 
      IF (NOTEMP .NE. 1) THEN
C
C FIND DT/DY:
C
           NPTS = 2*N2
           NSKIP = 1
           MTRN = N1H
           MSKIP = N2P
           ISIGN = 1
           CALL XLOG2 (NPTS,LOG)
           IEXSHF = NMAX2/NPTS
           CALL IN (CA,LTN,NW)
           F = 0.
D        call trace_enter (2083) 
           CDOALL 370 J = 1,N1H
370             CA(1:N2,J) = CMPLX(-REAL(<0:(N2-1)>)*AIMAG(CA(1:N2,J)), 
     *                              REAL(<0:(N2-1)>)*REAL(CA(1:N2,J)))
D        call trace_exit (2084) 
D        call trace_enter (2085) 
           DO 385 J = 1,N1H
385             CA(N2P,J) = 0.
D        call trace_exit (2086) 
           CALL SCSC (CA,EX,WORK)
           CALL OUT  (CA,LZY,NW)
           CALL IN   (CA,LTN,NW)
           CALL ACAC (CA,EX,WORK)
           CALL OUT  (CA,LTN,NW)
           NPTS = N1
           NSKIP = N2P
           MTRN = N2P
           MSKIP = 1
           CALL XLOG2 (NPTS,LOG)
           IEXSHF = NMAX2/NPTS
           IF (NSTEPS.EQ.1) THEN
              CALL TEMPHY (A,N2PD,N1H,EX,WORK,0)
           ELSE
              IF ((MOD(NSTEPS, KTP).EQ.1).OR.(MOD(NSTEPS, KPP).EQ.1))
     1        CALL TEMPHY (A,N2PD,N1H,EX,WORK,-1)
           END IF
C
C TEMPERATURE INFLUENCE:
C
           F = -FX
           KZN = LZN
           KZX = LZX
           KTN = LTN
           DTA = 0.5*ALPHA*DTT
D        call trace_enter (2087) 
           DO 400 K = 1,2
                CALL IN (CA,KZN,NWH)
                CALL IN (CA(1,K2Q),KTN,NWH)
                CDOALL 390 J = 1,N1Q
                     INTEGER K2QJ
                     REAL F
                     K2QJ = J+K2QM
                     if (K .eq. 1) then
                        F = (J-1)*FX
                     else
                        F = (J-1+N1Q)*FX
                     endif
                          CA(1:N2P,K2QJ) = CMPLX(-F*AIMAG(CA(1:N2P,K2QJ)),
     1                                            F*REAL(CA(1:N2P,K2QJ)))
390                       CA(1:N2P,J) = CA(1:N2P,J)+DTA*CA(1:N2P,K2QJ)
                CALL OUT (CA,KZN,NWH)
                CALL OUT (CA(1,K2Q),KZX,NWH)
                KZX = KZX+NWH
                KTN = KTN+NWH
400             KZN = KZN+NWH
D        call trace_exit (2088) 
           CALL IN  (A,LZX,NW)
           CALL CSR (A,EX)
           CALL OUT (A,LZX,NW)
           CALL IN  (A,LZY,NW)
           CALL CSR (A,EX)
           CALL OUT (A,LZY,NW)
           KPN = LPN
           KPY = LPY
           KZX = LZX
           KZY = LZY
C
C IN PHYSICAL SPACE - FIND  (U,V).GRAD(T):
C
D        call trace_enter (2089) 
           DO 420 K = 1,4
                CALL IN (A,KPY,NWQ)
                CALL IN (A(1,K1Q),KPN,NWQ)
                CALL IN (A(1,K2Q),KZY,NWQ)
                CALL IN (A(1,K3Q),KZX,NWQ)
                     CDOALL 410 J = 1,N1E
                          A(1:N2PD,J) = A(1:N2PD,J)*A(1:N2PD,K3QM+J) -
     1                             A(1:N2PD,K1QM+J)*A(1:N2PD,K2QM+J)*
     2                             G(<2:(N2PD+1)>/2)
410             CONTINUE
                CALL OUT (A,KZY,NWQ)
                KPN = KPN+NWQ
                KPY = KPY+NWQ
                KZX = KZX+NWQ
420             KZY = KZY+NWQ
D        call trace_exit (2090) 
           ISIGN = -1
           CALL IN  (A,LZY,NW)
           CALL RCS (A,EX)
           CALL OUT (A,LZY,NW)
           KTN = LTN
           KTO = LTO
           KZY = LZY
D        call trace_enter (2091) 
           DO 440 K = 1,2
                CALL IN (CA,KTO,NWH)
                CALL IN (A(1,K2Q),KTN,NWH)
                CDOALL 425 J = K2Q,N1H
425                       A(1:N2PD,J) = 0.5*A(1:N2PD,J)
                CALL OUT (A(1,K2Q),KTO,NWH)
                CALL IN  (CA(1,K2Q),KZY,NWH)
                CDOALL 430 J = 1,N1Q
                     INTEGER K2QJ
                     K2QJ = J+K2QM
430                       CA(1:N2P,J) = CA(1:N2P,J)+DTFAC*CA(1:N2P,K2QJ)
                CALL OUT (CA,KTN,NWH)
                KTN = KTN+NWH
                KTO = KTO+NWH
440             KZY = KZY+NWH
D        call trace_exit (2092) 
                END IF
441   DTF = 0.25*DTT*FX
      F = -DTF
      KZN = LZN
      KTN = LTN
D        call trace_enter (2093) 
      DO 460 K = 1,2
           IF (NOTEMP .NE. 1) CALL IN (CA,KTN,NWH)
           CALL IN (CA(1,K2Q),KZN,NWH)
           CDOALL 450 J = 1,N1Q
                INTEGER K2QJ
                REAL F
                K2QJ = J+K2QM
                F = (J-1)*DTF
                IF (NOTEMP .NE. 1) THEN
                     CA(1:N2P,J) = CMPLX (1.0, 
     *                               -F*U(1:N2P)) * CA(1:N2P,J) /
     1                               (1.0 + F*U(1:N2P)*F*U(1:N2P))
448             CONTINUE
                END IF
                     CA(1:N2P,K2QJ) = CMPLX (1.0, 
     *                                  -F*U(1:N2P)) * CA(1:N2P,K2QJ) /
     1                                  (1.0 + F*U(1:N2P)*F*U(1:N2P))
450        CONTINUE
           IF (NOTEMP .NE. 1) CALL OUT (CA,KTN,NWH)
           CALL OUT (CA(1,K2Q),KZN,NWH)
           KTN = KTN+NWH
460        KZN = KZN+NWH
D        call trace_exit (2094) 
      NPTS = 2*N2
      NSKIP = 1
      MTRN = N1H
      MSKIP = N2P
      ISIGN = -1
      IEXSHF = NMAX2/NPTS
      CALL XLOG2 (NPTS,LOG)
      CALL IN   (A,LZN,NW)
      CALL ACAC (A,EX,WORK)
      CALL OUT  (A,LZN,NW)
      IF (NOTEMP .NE. 1) THEN
           CALL IN   (A,LTN,NW)
           CALL ACAC (A,EX,WORK)
           CALL OUT  (A,LTN,NW)
           END IF
461   KZN = LZN
      KPN = LPN
      F2 = 1./(4.*REAL(N2))
      F1 = RNU*DTT
C
C FIND PRESSURE NOW OR NEVER (IF REQUIRED...)
C
C2%2      IF (MOD(NSTEPS,KPRESS) .EQ. 1)    CALL PRESURE  (LPY, LPN, LZY
C2%2     1    LPRESS, NWEIG, A, CA, WORK, CWORK, G, EX, EVAL, IR, IC, E,
C2%2     2    FX, N2P, N2PD, N1H, LMAPP)
      CALL IN (EVAL,LEIG,NWEIG)
      LVECT = N2M
      LSKIP = 2
      NVECT = 2
      NVSKIP = 1
      FXSQ = FX*FX
C
C UPDATE VORTICITY AND FIND THE NEW STREAMFUNCTION:
C
D        call trace_enter (2095) 
      CDOALL 480 J = 1,N1H
           COMPLEX CWORK(NW1), CWORK2(NW1)
           REAL F
           INTEGER KPN, KZN
           KZN = LZN+(J-1)*N2PD
           KPN = LPN+(J-1)*N2PD
           CALL IN (CWORK,KZN,N2PD)
           F = REAL((J-1)*(J-1))*FXSQ
                CWORK(2:N2) = CWORK(2:N2)*F2 / (1.0-F1*(EVAL(1:(N2-1))-F))
                CWORK2(2:N2) = CWORK(2:N2) / (EVAL(1:(N2-1))-F)
           CWORK(1) = CWORK(1)*F2/(1.0+F1*F)
           CWORK2(1) = 0.0
           IF (F.NE.0.0) CWORK2(1) = -CWORK(1)/F
           CWORK(N2P) = 0.0
           CWORK2(N2P) = 0.0
           CALL OUT (CWORK,KZN,N2PD)
           CALL OUT (CWORK2,KPN,N2PD)
480        CONTINUE
C
C DE-ALIASE UPDATED FIELDS IF REQUESTED:
C
D        call trace_exit (2096) 
      IF (NOALS.EQ.1) CALL DEALSE (CA,N2P,N1H,LZN)
      IF (NOALS.EQ.1) CALL DEALSE (CA,N2P,N1H,LPN)
      IF (NOTEMP .NE. 1) THEN
C
C UPDATE TEMPERATURE:
C
           IF (NOALS.EQ.1) CALL IN (EVAL,LEIG,NWEIG)
           KTN = LTN
           F1 = RKAPA*DTT
D        call trace_enter (2097) 
           CDOALL 500 J = 1,N1H
                COMPLEX CWORK(NW1)
                REAL F
                INTEGER KTN
                KTN = LTN+(J-1)*N2PD
                CALL IN (CWORK,KTN,N2PD)
                F = REAL((J-1)*(J-1))*FXSQ
                     CWORK(2:N2) = CWORK(2:N2)*F2 / 
     *                              (1.0-F1*(EVAL(1:(N2-1))-F))
490             CONTINUE
                CWORK(1) = CWORK(1)*F2 / (1.0+F1*F)
                CWORK(N2P) = 0.0
                CALL OUT (CWORK,KTN,N2PD)
500             CONTINUE
C
C DE-ALIASE IF REQUESTED:
C
D        call trace_exit (2098) 
           IF (NOALS.EQ.1) CALL DEALSE (CA,N2P,N1H,LTN)
           END IF
C
C AT LAST, THE END OF THE TIME STEP:
C
501   DTT = DT+DT
      T = T+DT
      NSTEPS = NSTEPS+1
C2%2      IF ((KTAPE .EQ. 2) .OR. (KTAPE .EQ. 3)) CALL DATAOUT (A,WORK)
      IF (NUMBER .GE. NSTEPS) GO TO 150
C
      WRITE (6,1010) TXXXIN,TXXOUT,TXXRCS,TXXCSR,TXSCSC,TXACAC,TFTVMT,
     1  TXSHUF,TUSHUF,TXPRNT,TXLOG2
      WRITE (6,1012) EXXRCS,EXXCSR,EXSCSC,EXACAC,EFTVMT
      WRITE (6,1020) NXXXIN,NXXOUT,NXXRCS,NXXCSR,NXSCSC,NXACAC,NFTVMT,
     1  NXSHUF,NUSHUF,NXPRNT,NXLOG2
C
      CALL BUG (10HAFTER  ALL)
C
 1010 FORMAT(/2X,42HSUBROUTINE    IN, EX-TIME FOR FIRST CALL =,1PE13.6,
     .        8H SECONDS/
     1        2X,42HSUBROUTINE   OUT, EX-TIME FOR FIRST CALL =,1PE13.6/
     2        2X,42HSUBROUTINE   RCS, EX-TIME FOR FIRST CALL =,1PE13.6/
     3        2X,42HSUBROUTINE   CSR, EX-TIME FOR FIRST CALL =,1PE13.6/
     4        2X,42HSUBROUTINE  SCSC, EX-TIME FOR FIRST CALL =,1PE13.6/
     5        2X,42HSUBROUTINE  ACAC, EX-TIME FOR FIRST CALL =,1PE13.6/
     6        2X,42HSUBROUTINE FTRVMT EX-TIME FOR FIRST CALL =,1PE13.6/
     7        2X,42HSUBROUTINE  SHUF, EX-TIME FOR FIRST CALL =,1PE13.6/
     8        2X,42HSUBROUTINE UNSHUF EX-TIME FOR FIRST CALL =,1PE13.6/
     9        2X,42HSUBROUTINE RPRINT EX-TIME FOR FIRST CALL =,1PE13.6/
     1        2X,42HSUBROUTINE XLOG2, EX-TIME FOR FIRST CALL =,1PE13.6)
 1012 FORMAT(/2X,42HSUBROUTINE   RCS, EX-TIME LAST TIMESTEP  =,1PE13.6,
     .        8H SECONDS/
     1        2X,42HSUBROUTINE   CSR, EX-TIME LAST TIMESTEP  =,1PE13.6/
     2        2X,42HSUBROUTINE  SCSC, EX-TIME LAST TIMESTEP  =,1PE13.6/
     3        2X,42HSUBROUTINE  ACAC, EX-TIME LAST TIMESTEP  =,1PE13.6/
     4        2X,42HSUBROUTINE FTRVMT EX-TIME LAST TIMESTEP  =,1PE13.6)
 1020 FORMAT(/2X,42HSUBROUTINE    IN, CUMULATIVE CALLS TO    =,I12/
     1        2X,42HSUBROUTINE   OUT, CUMULATIVE CALLS TO    =,I12/
     2        2X,42HSUBROUTINE   RCS, CUMULATIVE CALLS TO    =,I12/
     3        2X,42HSUBROUTINE   CSR, CUMULATIVE CALLS TO    =,I12/
     4        2X,42HSUBROUTINE  SCSC, CUMULATIVE CALLS TO    =,I12/
     5        2X,42HSUBROUTINE  ACAC, CUMULATIVE CALLS TO    =,I12/
     6        2X,42HSUBROUTINE FTRVMT CUMULATIVE CALLS TO    =,I12/
     7        2X,42HSUBROUTINE  SHUF, CUMULATIVE CALLS TO    =,I12/
     8        2X,42HSUBROUTINE UNSHUF CUMULATIVE CALLS TO    =,I12/
     9        2X,42HSUBROUTINE RPRINT CUMULATIVE CALLS TO    =,I12/
     1        2X,42HSUBROUTINE XLOG2, CUMULATIVE CALLS TO    =,I12)
C
      CALL CPUTIM (CPU2)
      CALL ELAPSE (TCLCK2)
C
      TWALL = MOD(TCLCK2-TCLCK1+1000000.0,1000000.0)
      WRITE (6,1040) TWALL
 1040 FORMAT(/2X,50HMEASURE OF WALL-CLOCK TIME (ENVIRONMENT SENSITIVE)/
     1 2X,20HFOR EXECUTION ONLY =,1PE13.6,1X,7HSECONDS)
      WRITE(1,*)
      WRITE(1,*) 'ELAPSED CPU TIME IN SECONDS: ',CPU2-CPU1
C MFLOPS RATE = MFLOP 1 CPU CRAY X-MP/CPU TIME
      WRITE(1,*) 'MFLOPS RATE: ', 1657.863/(CPU2-CPU1)
      WRITE(1,*) 'ELAPSED WALLCLOCK TIME IN SECONDS: ',TWALL
      WRITE(1,9992)
      WRITE(1,9995) (CDAT(I),I=1,15)
      VALID = 1
D        call trace_enter (2099) 
      DO  7  I=1,15
      IF (I.EQ.3 .OR. I.EQ.13) THEN
         IF (ABS(CDAT(I)) .GT. ABS(VDAT(I))) VALID = 0
      ELSE
         IF (ABS(VDAT(I)-CDAT(I)) .GT. ABS(.01*VDAT(I))) VALID = 0
      ENDIF
    7 CONTINUE
C
D        call trace_exit (2100) 
      IF (VALID .EQ. 1) THEN
         WRITE(1,9993)
      ELSE
         WRITE(1,9994)
      ENDIF
C
9992  FORMAT(/1X,'VALIDATION PARAMETERS:'/)
9993  FORMAT(//1X,'RESULTS FOR THIS RUN ARE:   VALID')
9994  FORMAT(//1X,'RESULTS FOR THIS RUN ARE: INVALID')
9995  FORMAT(5E15.5)
D     call exit_trace()
      STOP
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3 19 Dec 1990 14:40:31
C***********************************************************************
C
      SUBROUTINE OUT (ARRAY,LOC,NW)
      COMMON /MEMORY/MEMSIZ, RM(165117)
      COMMON /TIMING/TXXXIN, TXXOUT, TXXRCS, TXXCSR, TXSCSC,
     X  TXACAC, TFTVMT, TXSHUF, TUSHUF, TXPRNT, TXLOG2, EXXRCS, EXXCSR,
     X  EXSCSC, EXACAC, EFTVMT, NXXXIN, NXXOUT, NXXRCS, NXXCSR, NXSCSC,
     X  NXACAC, NFTVMT, NXSHUF, NUSHUF, NXPRNT, NXLOG2
      DIMENSION ARRAY(1)
      LOGICAL   LFIRST
      INTEGER I1, I2, I3, I4, I5
      DATA      LFIRST /.TRUE./
C
      IF (LFIRST) CALL CPUTIM (T1)
C
      IF ((LOC .GE. 1) .AND. ((LOC + NW - 1) .LE. MEMSIZ) .AND. (NW
     X   .GE. 1)) THEN
      LOCM = LOC-1
D        call trace_enter (2101) 
      CDOALL 10 I1=0,numpro$()
       integer J1,J2,J3
       J1 = VOH$(1) + 1
       J2 = VLH$(NW)
       J3 = VIH$(1)
       RM(J1+LOCM:$J2:J3)=ARRAY(J1:$J2:J3)
   10 CONTINUE
C
D        call trace_exit (2102) 
      IF (LFIRST) THEN
        LFIRST = .FALSE.
        CALL CPUTIM (T2)
        TXXOUT = T2-T1
      END IF
C
      NXXOUT = NXXOUT+1
C
      RETURN
      END IF
C
  100 WRITE(6,101) LOC,NW,MEMSIZ
  101 FORMAT (///' OUT: ILLEGAL REQUEST. LOCATION:',I22,
     1           ' ;   NUMBER OF WORDS:',I22,' ;  MEMSIZ:',I7)
      STOP
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:17:01
C***********************************************************************
      SUBROUTINE PSIFOU (CA,N2P,N1H,CWORK)
      COMMON /LADDR/LDUMMY(2), LPN, LDUMY1(9)
      COMPLEX CA(N2P,1),CWORK(1)
      NW = N2P*N1H*2
      CALL IN (CA,LPN,NW)
      CALL CPRINT (CA,7HPSI FOU,N1H,N2P,-1)
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:17:17
C***********************************************************************
C
C     FGPS  2-APR-88 REWROTE SUBROUTINE SO AS TO RECEIVE THE COMPLEX ARR
C                    CA IN FOURIER SPACE, TRANSFORM THIS ONTO PHYSICAL S
C                    AND CALL CPRINT TO PRINT OUT THE RESULT
C
      SUBROUTINE PSIPHY (CA,N2P,N1H,EX,G,U,WORK,CWORK3,IMODE)
      COMMON /EXSIZE/NMAX2
      COMMON /DATA/ALPHA, BETA, FX, H, RNU, RKAPA, DT, DTT, T,
     X  NSTEPS
      COMMON /FT/NPTS, NSKIP, MTRN, MSKIP, ISIGN, LOG, IEXSHF
      COMPLEX CA(N2P,1), CWORK3(1), EX(1)
      REAL    U(1), G(1), WORK(1)
C
      N2PD = N2P+N2P
      NPTS = N2PD - 2
      NSKIP = 1
      MTRN = N1H
      MSKIP = N2P
      ISIGN = 1
      CALL XLOG2 (NPTS,LOG)
      IEXSHF = NMAX2/NPTS
      CALL ACAC (CA,EX,WORK)
C
      N1 = N1H+N1H
      NPTS = N1
      NSKIP = N2P
      MTRN = N2P
      MSKIP = 1
      ISIGN = 1
      CALL XLOG2 (NPTS,LOG)
      IEXSHF = NMAX2/NPTS
      CALL CSR (CA,EX)
C
      CALL TELTIM
      CALL UNSHUF (CA,N2P,N1,WORK)
      CALL CPRINT (CA,8HPSI PHYS,N1H,N2P,IMODE)
C      CALL PLOTME (CA,WORK,NCALL)
      RETURN
C
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:17:40
C
      SUBROUTINE RCS( A, EX )
      COMMON /FT/NPTS, NSKIP, MTRN, MSKIP, ISIGN, LOG, IEXSHF
      COMMON /DATA/ALPHA, BETA, BOXX, H, RNU, RKAPA, DT, DTT, T
     X  , NSTEPS
      COMMON /OPTONS/N1, N2, NUMBER, KDATA, LMAPP, NOTEMP, KTA,
     X     KTAPE, KSM, KPP, KZP, KTP, KUP, KVP, KPF, KZF, KTF, KUF, KVF
     X     , KPRESS, NOALS
      COMMON /TIMING/TXXXIN, TXXOUT, TXXRCS, TXXCSR, TXSCSC,
     X  TXACAC, TFTVMT, TXSHUF, TUSHUF, TXPRNT, TXLOG2, EXXRCS, EXXCSR,
     X  EXSCSC, EXACAC, EFTVMT, NXXXIN, NXXOUT, NXXRCS, NXXCSR, NXSCSC,
     X  NXACAC, NFTVMT, NXSHUF, NUSHUF, NXPRNT, NXLOG2
      COMPLEX A( 1 ), EX( 1 ), BJ, BJSTAR
      integer gcd, div, MSKIPlt, NSKIPlt
C
C   PERFORM A REAL TO CONJUGATE SYMMETRIC TRANFORM, SAVING ONLY HALF OF
C   THE RESULTING CONJUGATE SYMMETRIC ARRAY, AND PACKING A(0) AND A(N/2)
C   INTO A(0) SINCE THEY ARE BOTH REAL
C
      LOGICAL   LFIRST,LXSTEP,LXTIME
      DATA      LFIRST,LXSTEP,LXTIME /.TRUE.,.FALSE.,.TRUE./
C
      IF (NSTEPS.EQ.NUMBER) LXSTEP = .TRUE.
      IF (LFIRST) CALL CPUTIM (T1)
      IF (LXSTEP) THEN
        IF (LXTIME) CALL CPUTIM (T1)
      END IF
C
      N = NPTS
      NPTS = NPTS/2
      M = NPTS
      ISHIFT = 0
      IF (ISIGN .LT. 0)  ISHIFT=M*IEXSHF
      MH = M/2
      MHP = MH + 1
      LOG = LOG - 1
      IEXSHF = 2*IEXSHF
      CALL FTRVMT( A( 1 ), EX( 1 ) )
      LOG = LOG + 1
      IEXSHF = IEXSHF/2
      NPTS = N
      div = gcd(MSKIP, NSKIP)
      MSKIPlt = MSKIP/div
      NSKIPlt = NSKIP/div
      if ((MSKIPlt .GT. 1) .and.
     *    (MSKIPlt .LT. MH-1) .and.
     *    (NSKIPlt .GT. 1) .and.
     *    (NSKIPlt .LT. MTRN-1)) then

C--- Serial version of DO 20

D        call trace_enter (2103) 
      DO 20 LOOP = 1, MTRN
      IST = (LOOP - 1)*MSKIP
      ISTP = IST + 1
      A( ISTP ) = CMPLX( 2.*( REAL( A(ISTP) ) + AIMAG( A( ISTP ) ) ),
     1                 2.*( REAL( A(ISTP) ) - AIMAG( A( ISTP ) ) ) )
      DO 10 I = 2, MH
      J = (I - 1)*NSKIP + ISTP
      JSTAR = (M - I + 1)*NSKIP + ISTP
      BJ = A( J )
      BJSTAR = A( JSTAR )
      IEXL = IEXSHF*(I - 1) + 1 + ISHIFT
      IEXH = IEXSHF*(M - I + 1) + 1 + ISHIFT
      A( J ) = BJ + CONJG( BJSTAR ) +
     1                    (0., -1.)*EX( IEXL )*(BJ - CONJG( BJSTAR ) )
      A( JSTAR ) = BJSTAR + CONJG( BJ ) +
     1             (0., -1.)*EX( IEXH )*(BJSTAR - CONJG( BJ ) )
10    CONTINUE
      J = MH*NSKIP + ISTP
      A( J ) = 2.*A( J )
      IF (ISIGN .LT. 0)  A(J) = CONJG( A(J) )
20    CONTINUE

D        call trace_exit (2104) 
      else

D        call trace_enter (2105) 
      CDOALL 920 LOOP = 1, MTRN
         INTEGER IST, ISTP, J, JSTAR, I, IEXL, IEXH
         COMPLEX BJ, BJSTAR
      IST = (LOOP - 1)*MSKIP
      ISTP = IST + 1
      A( ISTP ) = CMPLX( 2.*( REAL( A(ISTP) ) + AIMAG( A( ISTP ) ) ),
     1                 2.*( REAL( A(ISTP) ) - AIMAG( A( ISTP ) ) ) )
      DO 910 I = 2, MH
      J = (I - 1)*NSKIP + ISTP
      JSTAR = (M - I + 1)*NSKIP + ISTP
      BJ = A( J )
      BJSTAR = A( JSTAR )
      IEXL = IEXSHF*(I - 1) + 1 + ISHIFT
      IEXH = IEXSHF*(M - I + 1) + 1 + ISHIFT
      A( J ) = BJ + CONJG( BJSTAR ) +
     1                    (0., -1.)*EX( IEXL )*(BJ - CONJG( BJSTAR ) )
      A( JSTAR ) = BJSTAR + CONJG( BJ ) +
     1             (0., -1.)*EX( IEXH )*(BJSTAR - CONJG( BJ ) )
910   CONTINUE
      J = MH*NSKIP + ISTP
      A( J ) = 2.*A( J )
      IF (ISIGN .LT. 0)  A(J) = CONJG( A(J) )
920   CONTINUE
D        call trace_exit (2106) 
      endif
C
      IF (LFIRST) THEN
        LFIRST = .FALSE.
        CALL CPUTIM (T2)
        TXXRCS = T2-T1
      END IF
C
      IF (LXSTEP) THEN
        IF (LXTIME) THEN
          LXTIME = .FALSE.
          CALL CPUTIM (T2)
          EXXRCS = T2-T1
        END IF
      END IF
C
      NXXRCS = NXXRCS+1
C
      RETURN
      END
	integer function reflect(N,J)
	integer N, J
	integer result, highbit
	integer ibset
	logical btest

	do i=31,0,-1
	   if (btest(N,i)) goto 100
	end do

100	highbit = i

	result = 0
	do i=0,highbit
	   if (btest(J,i)) then
                      result = ibset(result, highbit-i)
	   endif
	end do

	reflect = result
	end
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:18:21
C
C***********************************************************************
C
C     FGPS 25-MAR-88 CHANGED THE DIMENSIONING OF R(1,1) TO R(N2PD,1)
C     FGPS 7-MAR-88 SUBROUTINE RPRINT REPROGRAMMED
C
C     N O T E :  THE INDEXING OF ARRAYS HANDLING VARIABLES REPRESENTED I
C     PHYSICAL SPACE IS USUALLY OF THE FORM
C
C                        A (1<=JY<=N2PD,1<=IX<=N1H)
C
C     WHERE "JY" IS THE COUNT ALONG THE Y-AXIS AND "IX" RUNS ALONG THE X
C     AXIS, AND WHERE
C
C                        N2PD = 2 * (N2+1)                 FOR THE Y-AXI
C     AND
C                         N1H = N1/2                       FOR THE X-AXI
C
C     AND WHERE THE BASIC GRID IS DIMENSIONED 2*(N2+1) BY N1.
C
C
      SUBROUTINE RPRINT (R,NAME,N1H,N2PD,IMODE)
C
      COMMON /DATA/ALPHA, BETA, BOXX, H, RNU, RKAPA, DT, DTT, T
     X  , NSTEPS
      COMMON /TIMING/TXXXIN, TXXOUT, TXXRCS, TXXCSR, TXSCSC,
     X  TXACAC, TFTVMT, TXSHUF, TUSHUF, TXPRNT, TXLOG2, EXXRCS, EXXCSR,
     X  EXSCSC, EXACAC, EFTVMT, NXXXIN, NXXOUT, NXXRCS, NXXCSR, NXSCSC,
     X  NXACAC, NFTVMT, NXSHUF, NUSHUF, NXPRNT, NXLOG2
      COMMON /VERIFY/VDAT(15), CDAT(15)
      COMMON /OPTONS/N1, N2, NUMBER, KDATA, LMAPP, NOTEMP, KTA,
     X     KTAPE, KSM, KPP, KZP, KTP, KUP, KVP, KPF, KZF, KTF, KUF, KVF
     X     , KPRESS, NOALS
      REAL            R(N2PD,1)
      CHARACTER*8     NAME
C
C
      WRITE (6,1002) NSTEPS
C
C     SELECT THE PRINT-OUT MODE
C
      IF (IMODE) 1000,2000,3000
C
 1000 CONTINUE
C
         IX1 = 1+N1H/4
         IX2 = 1+N1H/2
         JY1 = 1+N2PD/4
         WRITE (6,1010) NAME,JY1,IX1,R(JY1,IX1)
C
         WRITE (6,1020) NAME,JY1,IX2,R(JY1,IX2)
         IF (NSTEPS .EQ. 1) THEN
            IF (NAME .EQ. 'ZETA PHY') THEN
               CDAT(2) = R(JY1,IX1)
            ELSE IF (NAME .EQ. 'UVEL PHY') THEN
               CDAT(3) = R(JY1,IX2)
            ELSE IF (NAME .EQ. 'VVEL PHY') THEN
               CDAT(4) = R(JY1,IX2)
            ENDIF
         ELSE IF (NSTEPS .EQ. NUMBER) THEN
            IF (NAME .EQ. 'ZETA PHY') THEN
               CDAT(12) = R(JY1,IX1)
            ELSE IF (NAME .EQ. 'UVEL PHY') THEN
               CDAT(13) = R(JY1,IX2)
            ELSE IF (NAME .EQ. 'VVEL PHY') THEN
               CDAT(14) = R(JY1,IX2)
            ENDIF
         ENDIF
C
C
      NXPRNT = NXPRNT+1
C
      RETURN
C
 1002 FORMAT(/2X,8HNSTEPS =,I7)
 1010 FORMAT(2X,A8,4H(JY=,I3,4H,IX=,I3,3H) =,1PE13.6)
 1020 FORMAT(2X,A8,4H(JY=,I3,4H,IX=,I3,3H) =,1PE13.6/)
C
 2000 CONTINUE
C
C     VALUES OF THE VARIABLE ASSOCIATED WITH NAME ARE PRINTED OUT AT INT
C     VALS AS A FUNCTION OF Y (I.E., 1<=JY<=N2P WITH STRIDE = 4) AT CONS
C     X (I.E., IX = 1+N1H/2)
C
         IX1 = 1+N1H/2
         N2P = N2PD/2
         WRITE (6,2020) (JY,NAME,IX1,R(JY,IX1),JY=1,N2P,4)
         WRITE (6,2030)
         IF (NSTEPS .EQ. 1 .AND. NAME .EQ. 'TEMP PHY') THEN
            CDAT(5) = R(65,IX1)
         ENDIF
C
      NXPRNT = NXPRNT+1
C
      RETURN
C
 2020 FORMAT(34(2X,4HJY =,I5,2X,A8,7H(JY,IX=,I3,3H) =,1PE13.6/))
 2030 FORMAT(///)
C
 3000 CONTINUE
C
C     VALUES OF THE VARIABLE ASSOCIATED WITH NAME ARE PRINTED OUT AT INT
C     VALS AS A FUNCTION OF X (I.E., 1<=IX<=N1H WITH STRIDE = 2) AT CONS
C     Y (I.E., JY = N2PD/4)
C
         JY1 = 3*N2PD/4
         WRITE (6,3020) (IX,NAME,JY1,R(JY1,IX),IX=1,N1H,2)
C
      NXPRNT = NXPRNT+1
C
      RETURN
C
 3020 FORMAT(/,32(2X,4HIX =,I5,2X,A8,4H(JY=,I3,6H,IX) =,1PE13.6,6X,
     1   4HIX =,I5,2X,A8,4H(JY=,I3,6H,IX) =,1PE13.6/))
C
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:18:54
C***********************************************************************
C
C     FGPS  8-APR-88 SET UP RPRNT2 AS A MODIFICATION OF RPRINT.  THE IN
C                    TENT IS TO PRINT THE VALUE OF A QUANTITY AT THE CEN
C                    OF THE FIRST VORTEX CELL IN ORDER TO MONITOR EXECUT
C
      SUBROUTINE RPRNT2 (R,NAME,N1H,N2PD,IMODE)
C
      COMMON /DATA/ALPHA, BETA, BOXX, H, RNU, RKAPA, DT, DTT, T
     X  , NSTEPS
      COMMON /TIMING/TXXXIN, TXXOUT, TXXRCS, TXXCSR, TXSCSC,
     X  TXACAC, TFTVMT, TXSHUF, TUSHUF, TXPRNT, TXLOG2, EXXRCS, EXXCSR,
     X  EXSCSC, EXACAC, EFTVMT, NXXXIN, NXXOUT, NXXRCS, NXXCSR, NXSCSC,
     X  NXACAC, NFTVMT, NXSHUF, NUSHUF, NXPRNT, NXLOG2
      COMMON /VERIFY/VDAT(15), CDAT(15)
      COMMON /OPTONS/N1, N2, NUMBER, KDATA, LMAPP, NOTEMP, KTA,
     X     KTAPE, KSM, KPP, KZP, KTP, KUP, KVP, KPF, KZF, KTF, KUF, KVF
     X     , KPRESS, NOALS
      REAL            R(N2PD,1)
      CHARACTER*8     NAME
C
      LOGICAL         LFIRST
      DATA            LFIRST /.TRUE./
C
      IF (LFIRST)     CALL CPUTIM (T1)
C
      WRITE (6,1002) NSTEPS
C
C
         IX1 = 1+N1H/4
         IX2 = 1+N1H/2
         JY1 = 1+N2PD/4
         WRITE (6,1010) NAME,JY1,IX1,R(JY1,IX1)
         WRITE (6,1020) NAME,JY1,IX2,R(JY1,IX2)
         IF (NSTEPS .EQ. 51) THEN
            CDAT(7) = R(JY1,IX2)
         ELSE IF (NSTEPS .EQ. 101) THEN
            CDAT(8) = R(JY1,IX2)
         ELSE IF (NSTEPS .EQ. 151) THEN
            CDAT(9) = R(JY1,IX2)
         ELSE IF (NSTEPS .EQ. 201) THEN
            CDAT(10) = R(JY1,IX2)
         ELSE IF (NSTEPS .EQ. NUMBER) THEN
            CDAT(15) = R(JY1,IX2)
         ENDIF
C
      IF (LFIRST) THEN
         LFIRST = .FALSE.
         CALL CPUTIM (T2)
         TXPRNT = T2-T1
      END IF
C
      NXPRNT = NXPRNT+1
C
      RETURN
C
 1002 FORMAT(/2X,8HNSTEPS =,I7)
 1010 FORMAT(2X,17HTEMPERATURE DROP:/
     1 2X,41HAT THE CENTER OF FIRST CONVECTION CELL = ,A8,
     2 4H(JY=,I3,4H,IX=,I2,3H) =,1PE13.6)
 1020 FORMAT(
     1 2X,41HAT CENTER OF CONVECTION-CELL BOUNDARY  = ,A8,
     2 4H(JY=,I3,4H,IX=,I2,3H) =,1PE13.6/)
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:19:57
C***********************************************************************
      SUBROUTINE RUNINF
      COMMON /OPTONS/N1, N2, NUMBER, KDATA, LMAPP, NOTEMP, KTA,
     X       KTAPE, KSM, KPP, KZP, KTP, KUP, KVP, KPF, KZF, KTF, KUF,
     X       KVF, KPRESS, NOALS
      COMMON /DATA/ALPHA, BETA, BOXX, H, RNU, RKAPA, DT, DTT, T
     X  , NSTEPS
C
C THIS SUBROUTINE TELLS US WHAT  OCEAN  WILL BE DOING:
C
C*****MACHINE-DEPENDENT CONSTANT (REPLACE FOR YOUR MACHINE)
C
C*********************
      ZERO = 1.0E-200
C*********************
C
      WRITE(6,100)
C
      CALL CPUTIM (CPUTM)
C      CALL DATE   (TODAY)
C      CALL TIME   (NOW)
      WRITE(6,200) CPUTM
C
      MOREST = NUMBER-NSTEPS+1
      WRITE(6,300) N1,N2,MOREST,KTA
      IF (KSM.EQ.1) WRITE(6,301)
      IF (KSM.EQ.2) WRITE(6,302)
C
      GO TO (1,2,3), KDATA
      WRITE(6,400)
      GO TO 10
1     WRITE(6,401)
      GO TO 10
2     WRITE(6,402)
      GO TO 10
3     WRITE(6,403)
C
10    GO TO (11,123,123), LMAPP
      WRITE(6,500)
      GO TO 20
11    WRITE(6,501)
      GO TO 20
123   WRITE(6,523)
C
20    GO TO (21), NOTEMP
      WRITE(6,600)
      GO TO 30
21    WRITE(6,601)
C
30    GO TO (31,32,33), KTAPE
      WRITE(6,700)
      GO TO 40
31    WRITE(6,701)
      GO TO 40
32    WRITE(6,702)
      GO TO 40
33    WRITE(6,703)
C
40    IF (KPP.NE.1) WRITE(6,801) KPP
      IF (KZP.NE.1) WRITE(6,802) KZP
      IF (KTP.NE.1) WRITE(6,803) KTP
      IF (KUP.NE.1) WRITE(6,804) KUP
      IF (KVP.NE.1) WRITE(6,805) KVP
      IF (KPF.NE.1) WRITE(6,806) KPF
      IF (KZF.NE.1) WRITE(6,807) KZF
      IF (KTF.NE.1) WRITE(6,808) KTF
      IF (KUF.NE.1) WRITE(6,809) KUF
      IF (KVF.NE.1) WRITE(6,810) KVF
      IF (KPRESS.NE.1) WRITE(6,811) KPRESS
C
      IF (NOALS.EQ.1) WRITE(6,901)
C
      REY = 1.0/(RNU+ZERO)
      RH =  H*H*H*H*ABS(ALPHA*BETA)/(RNU*RKAPA+ZERO)
C
C CRITICAL RAYLEIGH NUMBER IS   (PI**4) * 27/4:
C
      RHCRIT = 657.5113648
      RRATIO = RH/RHCRIT
      PR  = RNU/(RKAPA+ZERO)
      WRITE(6,1000)  BOXX,H,RNU,RKAPA,ALPHA,BETA,REY,RH,RRATIO,PR,DT,T
C
      RETURN
C
C FORMAT STATEMENTS:
C
100   FORMAT(/12X,' OOOOOO     CCCCCC    EEEEEEE    AAAAAA    N     N'/
     2        12X,'O      O   C      C   E         A      A   NN    N'/
     3        12X,'O      O   C          E         A      A   N N   N'/
     4        12X,'O      O   C          EEEE      AAAAAAAA   N  N  N'/
     5        12X,'O      O   C          E         A      A   N   N N'/
     6        12X,'O      O   C      C   E         A      A   N    NN'/
     7        12X,' OOOOOO     CCCCCC    EEEEEEE   A      A   N     N')
C
C200   FORMAT (////' THIS RUN BEGINS ON DATE ',A8,' AT TIME ',A8,/,
C     1            ' CPU TIME USED SO FAR IS',F9.6,' SECONDS.')
200    FORMAT (////' CPU TIME USED SO FAR IS',F9.6,' SECONDS.'//
     1      'W A R N I N G ******** POSSIBLE UNDERFLOW ********'/
     2      'THE STATEMENT "ZERO = 1.0E-200" APPEARS IN RUNINF.')
C
  300 FORMAT (//' THIS RUN USES ',I3,' BY ',I3,' GRID, AND DOES',I5,
     1    ' TIME STEPS',/,' TIME AVERAGING IS DONE EVERY',I3,' STEPS')
  301 FORMAT (' MEAN FLOW IS INCLUDED IN CALCULATIONS')
  302 FORMAT (' MEAN FLOW IS SPECIFIED BY USER')
C
  400 FORMAT (' KDATA HAS ILLEGAL VALUE')
  401 FORMAT (' INITIAL DATA IN PHYSICAL SPACE')
  402 FORMAT (' INITIAL DATA IN FOURIER SPACE')
  403 FORMAT (/' THIS IS A RESTART RUN'/)
C
  500 FORMAT (' LMAPP HAS AN ILLEGAL VALUE')
  501 FORMAT (' LINEAR MAPPING IN BOTH DIRECTIONS')
  523 FORMAT (' NON-LINEAR MAPPING IN Y DIRECTION')
C
  600 FORMAT (' TEMPERATURE FIELD INCLUDED IN CALCULATIONS')
  601 FORMAT (' CALCULATIONS DONE WITHOUT TEMPERATURE FIELD')
C
  700 FORMAT (/' NO HISTORY TAPE WILL BE WRITTEN'/)
  701 FORMAT (/' HISTORY TAPE WILL INCLUDE OPERATOR MATRICES ONLY'/)
  702 FORMAT (/' HISTORY TAPE WILL NOT INCLUDE OPERATOR MATRICES'/)
  703 FORMAT (/' HISTORY TAPE WILL INCLUDE ALL IMPORTANT ARRAYS'/)
C
  801 FORMAT (' OUTPUT PHYSICAL STREAMFUNCTION EVERY',I4,' TIME STEPS')
  802 FORMAT (' OUTPUT PHYSICAL VORTICITY      EVERY',I4,' TIME STEPS')
  803 FORMAT (' OUTPUT PHYSICAL TEMPERATURE    EVERY',I4,' TIME STEPS')
  804 FORMAT (' OUTPUT PHYSICAL X VELOCITY     EVERY',I4,' TIME STEPS')
  805 FORMAT (' OUTPUT PHYSICAL Y VELOCITY     EVERY',I4,' TIME STEPS')
  806 FORMAT (' OUTPUT FOURIER  STREAMFUNCTION EVERY',I4,' TIME STEPS')
  807 FORMAT (' OUTPUT FOURIER  VORTICITY      EVERY',I4,' TIME STEPS')
  808 FORMAT (' OUTPUT FOURIER  TEMPERATURE    EVERY',I4,' TIME STEPS')
  809 FORMAT (' OUTPUT FOURIER  X VELOCITY     EVERY',I4,' TIME STEPS')
  810 FORMAT (' OUTPUT FOURIER  V VELOCITY     EVERY',I4,' TIME STEPS')
  811 FORMAT (' OUTPUT PHYSICAL PRESSURE       EVERY',I4,' TIME STEPS')
C
  901 FORMAT (' DE-ALIASING TURNED ON.')
C
 1000 FORMAT (////' PHYSICAL PARAMETERS FOR THIS RUN ARE:',/,
     1     ' BOX DIMENSIONS          : ',F10.6,' BY ',F10.6,/,
     2     ' VISCOSITY (NU)          : ',E24.14,/,
     3     ' HEAT CONDUCTIVITY (KAPA): ',E24.14,/,
     4     ' ALPHA AND BETA          : ',F10.6,' AND',F10.6,/,
     5     ' REYNOLDS NUMBER         : ',E24.14,/,
     6     ' RAYLEIGH NUMBER         : ',E24.14,/,
     7     ' RATIO RAY/RAY(CRITICAL) : ',E24.14,/,
     8     ' PRANDTL  NUMBER         : ',E24.14,//,' THE TIME STEP IS',
     9     F10.6,/,' WE BEGIN AT  T =',F10.6,///,1H ,60(2H+-),//)
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:21:21
C
      SUBROUTINE SCSC(AC,EX,WORK)
C
C COMPLEX SYMMETRIC TO COMPLEX SYMMETRIC
C
      COMMON /FT/NPTS, NSKIP, MTRN, MSKIP, ISIGN, LOG, IEXSHF
      COMMON /DATA/ALPHA, BETA, BOXX, H, RNU, RKAPA, DT, DTT, T
     X  , NSTEPS
      COMMON /OPTONS/N1, N2, NUMBER, KDATA, LMAPP, NOTEMP, KTA,
     X     KTAPE, KSM, KPP, KZP, KTP, KUP, KVP, KPF, KZF, KTF, KUF, KVF
     X     , KPRESS, NOALS
      COMMON /TIMING/TXXXIN, TXXOUT, TXXRCS, TXXCSR, TXSCSC,
     X  TXACAC, TFTVMT, TXSHUF, TUSHUF, TXPRNT, TXLOG2, EXXRCS, EXXCSR,
     X  EXSCSC, EXACAC, EFTVMT, NXXXIN, NXXOUT, NXXRCS, NXXCSR, NXSCSC,
     X  NXACAC, NFTVMT, NXSHUF, NUSHUF, NXPRNT, NXLOG2
      COMPLEX AC(1),WORK(1),TEMP1,TEMP2,X,Y,BJ,BJSYM
      DIMENSION EX(1)
      integer div, gcd, NSKIPlt, MSKIPlt
C
      LOGICAL   LFIRST,LXSTEP,LXTIME
      DATA      LFIRST,LXSTEP,LXTIME /.TRUE.,.FALSE.,.TRUE./
C
      IF (NSTEPS.EQ.NUMBER) LXSTEP = .TRUE.
      IF (LFIRST) CALL CPUTIM (T1)
      IF (LXSTEP) THEN
        IF (LXTIME) CALL CPUTIM (T1)
      END IF
C
      M=NPTS/2
      NPTS=M
      MH=M/2
      MHP=MH+1
      ISTOP=1+(MTRN-1)*MSKIP
      MNSKIP=M*NSKIP
      LOG=LOG-1
      NSKIP2=NSKIP*2
      MP2=M+2
      IEXSHF=IEXSHF*2
      FACT=REAL(ISIGN)/2.
      MNSH=MNSKIP/2
      IPROD=MNSH-NSKIP
      IEXSYM=4+M*IEXSHF
      div = gcd(MSKIP,NSKIP)
      MSKIPlt = MSKIP/div
      NSKIPlt = NSKIP/div
      if ((MSKIPlt .GT. 0) .and.
     *    (MSKIPlt .LT. M) .and.
     *    (NSKIPlt .GT. 0) .and.
     *    (NSKIPlt .LT. MTRN)) then

C--- Serial version of DO 30

D        call trace_enter (2107) 
      DO 30 LOOP=1,ISTOP,MSKIP
         ISUM=LOOP+MNSKIP
         WORK(1)=AC(LOOP)
         WORK(MHP)=AC(ISUM)
         IAC=LOOP+NSKIP
         Y=AC(IAC)
         DO 10 I=2,MH
            IAC=IAC+NSKIP2
            Y=Y+AC(IAC)
            TEMP1=CMPLX(0.,1.)*(AC(IAC)-AC(IAC-NSKIP2))
            TEMP2=AC(IAC-NSKIP)
            WORK(I)=TEMP2+TEMP1
            WORK(MP2-I)=TEMP2-TEMP1
   10    CONTINUE
         IAC=LOOP
         DO 20 I=1,M
            AC(IAC)=WORK(I)
            IAC=IAC+NSKIP
   20    CONTINUE
         AC(ISUM)=4.*Y
   30 CONTINUE
D        call trace_exit (2108) 
      CALL FTRVMT(AC,EX)
D        call trace_enter (2109) 
      DO 40 LOOP=1,ISTOP,MSKIP
         ISUM=LOOP+MNSKIP
         JSUM=ISUM+LOOP
         X=2.*AC(LOOP)
         Y=AC(ISUM)
         AC(LOOP)=X+Y
         AC(ISUM)=X-Y
         AC(LOOP+MNSH)=2.*AC(LOOP+MNSH)
         ISTART=LOOP+NSKIP
         IFIN=LOOP+IPROD
         I=2
         DO 35 J=ISTART,IFIN,NSKIP
            I=I+IEXSHF
            JSYM=JSUM-J
            BJ=AC(J)
            BJSYM=AC(JSYM)
            TEMP1=BJ+BJSYM
            TEMP2=CMPLX(FACT/EX(I),0.)*(BJ-BJSYM)
            AC(J)=TEMP1+TEMP2
            AC(JSYM)=TEMP1-TEMP2
   35    CONTINUE
   40 CONTINUE

D        call trace_exit (2110) 
      else

D        call trace_enter (2111) 
      CDOALL 930 LOOP=1,ISTOP,MSKIP
         integer IAC, I, ISUM
         complex TEMP1(2:MH), TEMP2(2:MH), LWORK(M), Y

         ISUM=LOOP+MNSKIP
         LWORK(1)=AC(LOOP)
         LWORK(MHP)=AC(ISUM)
         IAC=LOOP+NSKIP
         Y=AC(IAC)
            IAC=IAC+NSKIP2
            Y=Y+SUM(AC(IAC:$(MH-1):NSKIP2))
            TEMP1=CMPLX(0.,1.)*(AC(IAC:$(MH-1):NSKIP2)-
     *                          AC((IAC-NSKIP2):$(MH-1):NSKIP2))
            TEMP2=AC((IAC-NSKIP):$(MH-1):NSKIP2)
            LWORK(2:MH)=TEMP2+TEMP1
            LWORK((MP2-2):(MP2-MH):-1)=TEMP2-TEMP1
  910    CONTINUE
            AC(LOOP:$M:NSKIP)=LWORK(1:M)
  920    CONTINUE
         AC(ISUM)=4.*Y
         if (LOOP .eq. ISTOP) then
                WORK(1:M) = LWORK(1:M)
         endif
  930 CONTINUE
D        call trace_exit (2112) 
      CALL FTRVMT(AC,EX)
D        call trace_enter (2113) 
      CDOALL 940 LOOP=1,ISTOP,MSKIP
         integer ISUM, JSUM, ISTART, IFIN, I, J, JSYM
         complex X, Y, BJ, BJSYM, TEMP1, TEMP2
         ISUM=LOOP+MNSKIP
         JSUM=ISUM+LOOP
         X=2.*AC(LOOP)
         Y=AC(ISUM)
         AC(LOOP)=X+Y
         AC(ISUM)=X-Y
         AC(LOOP+MNSH)=2.*AC(LOOP+MNSH)
         ISTART=LOOP+NSKIP
         IFIN=LOOP+IPROD
         I=2
         DO 935 J=ISTART,IFIN,NSKIP
            I=I+IEXSHF
            JSYM=JSUM-J
            BJ=AC(J)
            BJSYM=AC(JSYM)
            TEMP1=BJ+BJSYM
            TEMP2=CMPLX(FACT/EX(I),0.)*(BJ-BJSYM)
            AC(J)=TEMP1+TEMP2
            AC(JSYM)=TEMP1-TEMP2
  935    CONTINUE
  940 CONTINUE

D        call trace_exit (2114) 
      endif

      NPTS=M*2
      LOG=LOG+1
      IEXSHF=IEXSHF/2
C
      IF (LFIRST) THEN
        LFIRST = .FALSE.
        CALL CPUTIM (T2)
        TXSCSC = T2-T1
      END IF
C
      IF (LXSTEP) THEN
        IF (LXTIME) THEN
          LXTIME = .FALSE.
          CALL CPUTIM (T2)
          EXSCSC = T2-T1
        END IF
      END IF
C
      NXSCSC = NXSCSC+1
C
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:22:36
C***********************************************************************
      SUBROUTINE SHUF (A,N2P,N1,WORK)
      DIMENSION A(N2P,1),WORK(1)
      COMMON /TIMING/TXXXIN, TXXOUT, TXXRCS, TXXCSR, TXSCSC,
     X  TXACAC, TFTVMT, TXSHUF, TUSHUF, TXPRNT, TXLOG2, EXXRCS, EXXCSR,
     X  EXSCSC, EXACAC, EFTVMT, NXXXIN, NXXOUT, NXXRCS, NXXCSR, NXSCSC,
     X  NXACAC, NFTVMT, NXSHUF, NUSHUF, NXPRNT, NXLOG2
      LOGICAL   LFIRST
      DATA      LFIRST /.TRUE./
C
      IF (LFIRST) CALL CPUTIM (T1)
C
D        call trace_enter (2115) 
      DO 10 J = 1,N1,2
            DO 20 I = 1,N2P
                  II = I+I
                  WORK(II-1) = A(I,J)
   20             WORK(II) = A(I,J+1)
            DO 10 I = 1,N2P
                  A(I,J) = WORK(I)
   10             A(I,J+1) = WORK(I+N2P)
C
D        call trace_exit (2116) 
      IF (LFIRST) THEN
        LFIRST = .FALSE.
        CALL CPUTIM (T2)
        TXSHUF = T2-T1
      END IF
C
      NXSHUF = NXSHUF+1
C
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:23:31
C***********************************************************************
C     FGPS  2-MAY-99 SET KPP = KZP = KUP = KVP = 249 AND NUMBER = 250
C     FGPS 18-APR-88 SET KPP = KZP = KUP = KVP = 499 AND NUMBER = 500
C
      SUBROUTINE START (NX,NY)
C
C THIS SUBROUTINE IS USED TO SPECIFY OPTIONS FOR PROGRAM OCEAN.
C
      COMMON /OPTONS/N1, N2, NUMBER, KDATA, LMAPP, NOTEMP, KTA,
     X       KTAPE, KSM, KPP, KZP, KTP, KUP, KVP, KPF, KZF, KTF, KUF,
     X       KVF, KPRESS, NOALS
C
C N1 AND N2 ARE THE DIMENSIONS OF THE MATRIX. THEY HAVE TO BE POWERS
C OF  2  AND GREATER THAN OR EQUAL TO  8
C
      N1 = NX
      N2 = NY
C
C KDATA SPECIFIES THE WAY DATA IS SUPPLIED TO THE PROGRAM.
C
C            KDATA = 1     MEANS THAT IT WILL BE IN PHYSICAL SPACE
C                  = 2     MEANS THAT IT WILL BE IN FOURIER SPACE
C                  = 3     MEANS THAT THIS IS A RESTART RUN (->READ TAPE
C
      KDATA = 1
C
C LMAPP SPECIFIES THE MAPPING IN THE Y DIRECTION.
C
C            LMAPP = 1     MEANS LINEAR MAPPING (-> EIGSET NOT CALLED)
C                  = 2     MEANS NON-LINEAR MAPPING
C                  = 3     MEANS RESTART RUN, NON-LINEAR MAPPING
C
      LMAPP = 1
C
C NOTEMP EXCLUDES TEMPERATURE FIELD FROM CALCULATIONS WHEN SET TO 1.
C
      NOTEMP = 0
C
C NOALS TURNS ON DEALIASING AT EACH TIME STEP WHEN SET TO 1:
C (TO BE USED ONLY WITH LINEAR MAPPING)
C
      NOALS = 1
C
C TIME AVERAGING IS PERFORMED EACH KTA TIME STEPS:
C
      KTA = 50
C
C THE FOLLOWING PARAMETERS SPECIFY WHEN TO CALL CORRESPONDING OUTPUT
C SUBROUTINES. IF YOU WANT, FOR EXAMPLE, PSIPHY TO BE CALLED EVERY
C 50 TIME STEPS, YOU SHOULD SET KPP TO 50.
C
C WARNING: SETTING A PARAMETER TO 1 TURNS OFF THE SUBROUTINE. IT DOES
C          NOT CAUSE IT TO BE CALLED EVERY TIME STEP.
C          YOU SHOULD NEVER SET ANY OF THEM TO 0, SINCE THEY ARE USED
C          WITH THE FUNCTION MOD(NSTEPS,KXYZ).
C
      KPP = 249
      KZP = 249
      KTP = 50
      KUP = 249
      KVP = 249
      KPF = 1
      KZF = 1
      KTF = 1
      KUF = 1
      KVF = 1
      KPRESS = 1
C
C KTAPE SPECIFIES HOW WILL HISTORY TAPE BE WRITTEN:
C
C          KTAPE = 1  WRITE ONLY EIG-STUFF ON TAPE
C                = 2  WRITE ONLY DATA ON TAPE
C                = 3  WRITE BOTH EIG-STUFF AND DATA ON TAPE
C
C ANY OTHER VALUE WILL PREVENT THE HISTORY TAPE FROM BEING WRITTEN.
C
      KTAPE = 0
C
C NUMBER SPECIFIES THE NUMBER OF TIME STEPS IN A SINGLE RUN:
C
      NUMBER = 250
C
C KSM GOVERNS THE USE OF THE MEAN FLOW OPTION.
C
C                   KSM = 0       MEANS THAT U(MEAN) IS ZERO
C                         1       MEANS THAT IT SHOULD BE COMPUTED
C                         2       MEANS THAT IT IS USER-SPECIFIED
C
      KSM = 1
C
C THAT WAS ALL. RETURN TO MOTHER OCEAN.
C
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:23:57
C***********************************************************************
      SUBROUTINE TELTIM
      COMMON /DATA/DUMMY(8), TIME, IDUMY1
      WRITE(6,100) TIME
100   FORMAT (' TIME = ',F20.6)
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:24:28
C***********************************************************************
      SUBROUTINE TEMPFO (CA,N2P,N1H,CWORK)
      COMMON /LADDR/LDUMMY, LTN, LDUMY1(10)
      COMPLEX CA(N2P,1), CWORK(1)
      NW = N2P*N1H*2
      CALL IN (CA,LTN,NW)
      CALL CPRINT (CA,8HTEMP FOU,N1H,N2P,-1)
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:24:49
C***********************************************************************
C
C
C     FGPS  9-APR-88 MADE TO CALL RPRNT2 (NOT RPRINT) WHENEVER IMODE =
C     FGPS 18-FEB-88 RELOCATED "CALL RPRINT ( , ,N1H,N2PD,IMODE)"
C     FGPS 10-FEB-88 ADDED "COMPLEX  EX(1)"
C
      SUBROUTINE TEMPHY (A,N2PD,N1H,EX,WORK,IMODE)
      COMMON /LADDR/LDUMMY, LTN, LDUMY1(10)
      DIMENSION A(N2PD,1), WORK(1)
      COMPLEX   EX(1)
      COMMON /DATA/ALPHA, BETA, BOXX, H, RNU, RKAPA, DT, DTT, T
     X  , NSTEPS
      COMMON /MAPING/GMAPP(129), GDUMY1(129)
      SAVE NCALL
      DATA NCALL /0/
      NW = N2PD*N1H
      N2P = N2PD/2
      N1 = N1H+N1H
      N2 = N2P-1
      CALL IN (A,LTN,NW)
      CALL CSR (A,EX)
D        call trace_enter (2117) 
      DO 3 J=1,N1H
    3    WORK(J) = 0.0
D        call trace_exit (2118) 
D        call trace_enter (2119) 
      DO 4 I=1,N2PD
         IPH = (I+1)/2
         ADJUST = BETA*GMAPP(IPH)
C WHEN INTERESTED IN TEMPERATURE DISTURBANCE ONLY, USE THIS INSTEAD:
C        ADJUST = 0.0
         DO 4 J=1,N1H
            WORK(J) = WORK(J)+A(I,J)*A(I,J)
    4       A(I,J) = 0.5*A(I,J)-ADJUST
D        call trace_exit (2120) 
      SUMSQ=0.0
D        call trace_enter (2121) 
      DO 5 J=1,N1H
    5    SUMSQ = SUMSQ+WORK(J)
D        call trace_exit (2122) 
      ZRMS = 0.5*SQRT (SUMSQ/(REAL(N1)*REAL(N2P)))
      WRITE(6,6)  ZRMS
    6 FORMAT (/' SQRT (AVERAGE TEMPERATURESQUARED) =',F30.15)
      NCALL = NCALL+1
      CALL UNSHUF (A,N2P,N1,WORK)
      CALL TELTIM
      IF (IMODE.LT.0) THEN
         CALL RPRNT2 (A,8HTEMP PHY,N1H,N2PD,IMODE)
      ELSE
         CALL RPRINT  (A,8HTEMP PHY,N1H,N2PD,IMODE)
      END IF
C      CALL PLOTME (A,WORK,NCALL)
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:25:25
C***********************************************************************
      SUBROUTINE TESTDT (A,N2P,N1,WORK,G)
      COMMON /PI/PI
      DIMENSION A(N2P,N1),WORK(N2P),G(N2P)
C
C FIND MAXIMUM DT:
C
D        call trace_enter (2123) 
      DO 10 I=1,N2P
   10    WORK(I) = 0.0
D        call trace_exit (2124) 
D        call trace_enter (2125) 
      DO 20 J=1,N1
         DO 20 I=1,N2P
   20       WORK(I) = MAX(WORK(I), ABS(G(I)*A(I,J)) )
C
C G WAS 1.0/(DY/DX), AND X GOES FROM 0.0 TO PI, HENCE IF WE WANT
C ((DY/DI)/V)=((DY/DX)(DX/DI)/V)=PI/(N1*G(I)*V(I))
C REMEMBER, A CONTAINS 2.0*V:
D        call trace_exit (2126) 
D        call trace_enter (2127) 
      DO 30 I=2,N2P
   30    WORK(1) = MAX(WORK(1), WORK(I))
C
C SO, WORK(1) = MAX (G(I)*2*V(I,J)):
C DT(MAX) = 0.2* MIN (DY/V) = 0.2*2.0*PI/(N1*WORK(1)):
CSRD  DTMAX = 0.4*PI/(REAL(N1)*WORK(1)+1.0E-1000)
D        call trace_exit (2128) 
      DTMAX = 0.4*PI/(REAL(N1)*WORK(1)+1.0E-300)
      WRITE(6,200)  DTMAX
  200 FORMAT (//,' DTMAX =',F16.10)
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:25:47
C***********************************************************************
      SUBROUTINE UNSHUF (A,N2P,N1,WORK)
      DIMENSION A(N2P,1),WORK(1)
      COMMON /TIMING/TXXXIN, TXXOUT, TXXRCS, TXXCSR, TXSCSC,
     X  TXACAC, TFTVMT, TXSHUF, TUSHUF, TXPRNT, TXLOG2, EXXRCS, EXXCSR,
     X  EXSCSC, EXACAC, EFTVMT, NXXXIN, NXXOUT, NXXRCS, NXXCSR, NXSCSC,
     X  NXACAC, NFTVMT, NXSHUF, NUSHUF, NXPRNT, NXLOG2
      LOGICAL   LFIRST
      DATA      LFIRST /.TRUE./
C
      IF (LFIRST) CALL CPUTIM (T1)
C
D        call trace_enter (2129) 
      DO 10 J = 1,N1,2
            DO 20 I = 1,N2P
                  WORK(I) = A(I,J)
   20             WORK(I+N2P) = A(I,J+1)
            DO 10 I = 1,N2P
                  II = I+I
                  A(I,J) = WORK(II-1)
   10             A(I,J+1) = WORK(II)
C
D        call trace_exit (2130) 
      IF (LFIRST) THEN
        LFIRST = .FALSE.
        CALL CPUTIM (T2)
        TUSHUF = T2-T1
      END IF
C
      NUSHUF = NUSHUF+1
C
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:26:17
C***********************************************************************
      SUBROUTINE UVELFO (CA,N2P,N1H,G,EX,CWORK)
      COMMON /FT/NDUMMY(4), ISIGN, NDUMY2(2)
      COMPLEX CA(N2P,1),CWORK(1),EX(1)
      DIMENSION G(1)
D        call trace_enter (2131) 
      DO 10 I = 1,N2P
           DO 10 J = 1,N1H
10              CA(I,J) = G(I)*CA(I,J)
D        call trace_exit (2132) 
      ISIGN = -1
      CALL SCSC (CA,EX,CWORK)
      ISIGN = 1
      F = 0.125/REAL(N2P-1)
D        call trace_enter (2133) 
      DO 20 J = 1,N1H
           DO 20 I = 1,N2P
20              CA(I,J) = F*CA(I,J)
D        call trace_exit (2134) 
      CALL CPRINT (CA,8HUVEL FOU,N1H,N2P,-1)
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:26:38
C***********************************************************************
C
C     FGPS 18-FEB-88 RELOCATED "CALL RPRINT ( , ,N1H,N2PD,IMODE)"
C
      SUBROUTINE UVELPH (A,N2PD,N1H,WORK,IMODE)
      COMMON /LADDR/LDUMMY(5), LPY, LDUMY1(6)
      DIMENSION A(N2PD,1), WORK(1)
      COMMON /DATA/DUMY1(2), BOXX, DUMY2(6), IDUMY1
D        call trace_enter (2135) 
      DO 5 I=1,N2PD
    5      WORK(I) = 0.0
D        call trace_exit (2136) 
      NW = N2PD*N1H
      N2P = N2PD/2
      N1 = N1H+N1H
      N2 = N2P-1
      CALL TELTIM
      CALL IN (A,LPY,NW)
D        call trace_enter (2137) 
      DO 10 J = 1,N1H
           DO 10 I = 1,N2PD
   10           WORK(I) = MAX(WORK(I), ABS(A(I,J)) )
D        call trace_exit (2138) 
      WRKMAX = 0.0
D        call trace_enter (2139) 
      DO 20 I=1,N2PD
   20      WRKMAX = MAX(WRKMAX, WORK(I))
D        call trace_exit (2140) 
      CALL UNSHUF (A,N2P,N1,WORK)
      CALL RPRINT (A,8HUVEL PHY,N1H,N2PD,IMODE)
C
C AT THIS POINT A(N2P,N1) CONTAINS 2.0*U
C
      UMAX = 0.5*WRKMAX+1.0E-32
      DTMAX = 0.2*(BOXX/REAL(N1))/UMAX
      WRITE(6,100)  DTMAX
  100 FORMAT (//,' DTMAX =',F16.10)
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:27:03
C***********************************************************************
      SUBROUTINE VVELFO (CA,N2P,N1H,FX,CWORK)
      COMMON /LADDR/LDUMMY(2), LPN, LDUMY1(9)
      COMPLEX CA(N2P,1),CWORK(1)
      NW = N2P*N1H*2
      CALL IN (CA,LPN,NW)
      F = 0.
D        call trace_enter (2141) 
      DO 20 J = 1,N1H
           DO 10 I = 1,N2P
10             CA(I,J) = CMPLX(-F*AIMAG(CA(I,J)), F*REAL(CA(I,J)))
20         F = F+FX
D        call trace_exit (2142) 
      CALL CPRINT (CA,8HVVEL FOU,N1H,N2P,-1)
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:27:21
C***********************************************************************
C
C     FGPS 18-FEB-88 RELOCATED "CALL RPRINT ( , ,N1H,N2PD,IMODE)"
C
      SUBROUTINE VVELPH (A,N2PD,N1H,WORK,IMODE)
      COMMON /LADDR/LDUMMY(2), LPN, LDUMY1(9)
      DIMENSION A(N2PD,1), WORK(1)
      COMMON /MAPING/GMAPP(129), G(129)
      NW = N2PD*N1H
      N2P = N2PD/2
      N1 = N1H+N1H
      N2 = N2P-1
      CALL TELTIM
      CALL IN (A,LPN,NW)
      CALL UNSHUF (A,N2P,N1,WORK)
      CALL RPRINT (A,8HVVEL PHY,N1H,N2PD,IMODE)
C
C AT THIS POINT A(N2P,N1) CONTAINS 2.0*V
C
      CALL TESTDT (A,N2P,N1,WORK,G)
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:27:39
C***********************************************************************
C
C     FGPS 29-APR-88 INTRODUCED "SUBROUTINE XLOG2 (NA,NB)" IN ORDER TO I
C                    PROVE EFFICIENCY.  THIS REPLACES "FUNCTION LOG2 (N)
C
C      FUNCTION LOG2 (N)
C      LOG2 = LOG(REAL(N))/LOG(2.)+0.01
C      RETURN
C      END
C
      SUBROUTINE XLOG2 (NA,NB)
C
      COMMON /TIMING/TXXXIN, TXXOUT, TXXRCS, TXXCSR, TXSCSC,
     X  TXACAC, TFTVMT, TXSHUF, TUSHUF, TXPRNT, TXLOG2, EXXRCS, EXXCSR,
     X  EXSCSC, EXACAC, EFTVMT, NXXXIN, NXXOUT, NXXRCS, NXXCSR, NXSCSC,
     X  NXACAC, NFTVMT, NXSHUF, NUSHUF, NXPRNT, NXLOG2
C
      LOGICAL    INITL1,INITL2
      DATA       INITL1,INITL2 /.TRUE.,.TRUE./
      REAL T1, T2, F1, B
      SAVE INITL1, INITL2, F1
C
      IF        (INITL1) CALL CPUTIM (T1)
C
      IF        (INITL2) THEN
         INITL2 = .FALSE.
         F1     = 1.0/LOG(2.0)
      END IF
C
      B  = F1*LOG( REAL(NA) ) + 0.01
      NB = INT(B)
C
      IF        (INITL1) THEN
         INITL1 = .FALSE.
         CALL CPUTIM (T2)
         TXLOG2 = T2-T1
      END IF
C
      NXLOG2 = NXLOG2+1
C
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:28:08
C***********************************************************************
      SUBROUTINE ZETAFO (CA,N2P,N1H,CWORK)
      COMMON /LADDR/LZN, LDUMY1(11)
      COMPLEX CA(N2P,1),CWORK(1)
      NW = N2P*N1H*2
      CALL IN (CA,LZN,NW)
      CALL CPRINT (CA,8HZETA FOU,N1H,N2P,-1)
      RETURN
      END
C     Cedar Fortran KAP   (Fri, 16 Nov 1990)  o3,r3,d3  4 Dec 1990 14:28:27
C***********************************************************************
C
C     FGPS 18-FEB-88 RELOCATED "CALL RPRINT ( , ,N1H,N2PD,IMODE)"
C
      SUBROUTINE ZETAPH (A,N2PD,N1H,EX,WORK,IMODE)
      DIMENSION A(N2PD,1), EX(1), WORK(1)
      SAVE NCALL
      DATA NCALL /0/
      CALL CSR (A,EX)
      N2P = N2PD/2
      N1 = N1H+N1H
      N2 = N2P-1
      CALL UNSHUF (A,N2P,N1,WORK)
      CALL TELTIM
D        call trace_enter (2143) 
      DO 3 J=1,N1H
    3    WORK(J) = 0.0
D        call trace_exit (2144) 
D        call trace_enter (2145) 
      DO 4 I=1,N2PD
         DO 4 J=1,N1H
    4       WORK(J) = WORK(J)+A(I,J)*A(I,J)
D        call trace_exit (2146) 
      SUMSQ=0.0
D        call trace_enter (2147) 
      DO 5 J=1,N1H
    5    SUMSQ = SUMSQ+WORK(J)
D        call trace_exit (2148) 
      ZRMS = SQRT (SUMSQ/(REAL(N1)*REAL(N2P)))
      WRITE(6,6)  ZRMS
    6 FORMAT (/' SQRT (AVERAGE ZETASQUARED) =',F30.15)
      NCALL = NCALL+1
      CALL RPRINT (A,8HZETA PHY,N1H,N2PD,IMODE)
C      CALL PLOTME (A,WORK,NCALL)
      RETURN
      END
